
/*  A Bison parser, made from Gmsh.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	tDOUBLE	257
#define	tSTRING	258
#define	tBIGSTR	259
#define	tEND	260
#define	tAFFECT	261
#define	tDOTS	262
#define	tPi	263
#define	tMPI_Rank	264
#define	tMPI_Size	265
#define	tExp	266
#define	tLog	267
#define	tLog10	268
#define	tSqrt	269
#define	tSin	270
#define	tAsin	271
#define	tCos	272
#define	tAcos	273
#define	tTan	274
#define	tRand	275
#define	tAtan	276
#define	tAtan2	277
#define	tSinh	278
#define	tCosh	279
#define	tTanh	280
#define	tFabs	281
#define	tFloor	282
#define	tCeil	283
#define	tFmod	284
#define	tModulo	285
#define	tHypot	286
#define	tPrintf	287
#define	tSprintf	288
#define	tStrCat	289
#define	tStrPrefix	290
#define	tStrRelative	291
#define	tBoundingBox	292
#define	tDraw	293
#define	tToday	294
#define	tPoint	295
#define	tCircle	296
#define	tEllipse	297
#define	tLine	298
#define	tSurface	299
#define	tSpline	300
#define	tVolume	301
#define	tCharacteristic	302
#define	tLength	303
#define	tParametric	304
#define	tElliptic	305
#define	tPlane	306
#define	tRuled	307
#define	tTransfinite	308
#define	tComplex	309
#define	tPhysical	310
#define	tUsing	311
#define	tBump	312
#define	tProgression	313
#define	tPlugin	314
#define	tRotate	315
#define	tTranslate	316
#define	tSymmetry	317
#define	tDilate	318
#define	tExtrude	319
#define	tDuplicata	320
#define	tLoop	321
#define	tRecombine	322
#define	tDelete	323
#define	tCoherence	324
#define	tIntersect	325
#define	tAttractor	326
#define	tLayers	327
#define	tAlias	328
#define	tAliasWithOptions	329
#define	tText2D	330
#define	tText3D	331
#define	tInterpolationScheme	332
#define	tTime	333
#define	tGrain	334
#define	tCombine	335
#define	tBSpline	336
#define	tBezier	337
#define	tNurbs	338
#define	tOrder	339
#define	tWith	340
#define	tBounds	341
#define	tKnots	342
#define	tColor	343
#define	tColorTable	344
#define	tFor	345
#define	tIn	346
#define	tEndFor	347
#define	tIf	348
#define	tEndIf	349
#define	tExit	350
#define	tReturn	351
#define	tCall	352
#define	tFunction	353
#define	tTrimmed	354
#define	tShow	355
#define	tHide	356
#define	tGetValue	357
#define	tGMSH_MAJOR_VERSION	358
#define	tGMSH_MINOR_VERSION	359
#define	tGMSH_PATCH_VERSION	360
#define	tAFFECTPLUS	361
#define	tAFFECTMINUS	362
#define	tAFFECTTIMES	363
#define	tAFFECTDIVIDE	364
#define	tOR	365
#define	tAND	366
#define	tEQUAL	367
#define	tNOTEQUAL	368
#define	tAPPROXEQUAL	369
#define	tLESSOREQUAL	370
#define	tGREATEROREQUAL	371
#define	tCROSSPRODUCT	372
#define	tPLUSPLUS	373
#define	tMINUSMINUS	374
#define	UNARYPREC	375

#line 1 "Gmsh.y"

// $Id: Gmsh.tab.cpp,v 1.294 2006-12-16 15:44:28 geuzaine Exp $
//
// Copyright (C) 1997-2007 C. Geuzaine, J.-F. Remacle
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA.
// 
// Please report all bugs and problems to <gmsh@geuz.org>.

#include <stdarg.h>
#include <time.h>
#include "PluginManager.h"
#include "ParUtil.h"
#include "Gmsh.h"
#include "Numeric.h"
#include "Context.h"
#include "GModel.h"
#include "Geo.h"
#include "GeoInterpolation.h"
#include "GeoUtils.h"
#include "Generator.h"
#include "Draw.h"
#include "Views.h"
#include "Options.h"
#include "Colors.h"
#include "Parser.h"
#include "OpenFile.h"
#include "CommandLine.h"
#include "FunctionManager.h"
#include "ColorTable.h"
#include "OS.h"
#include "CreateFile.h"

Tree_T *Symbol_T = NULL;

extern Context_T CTX;
extern Mesh *THEM;
extern GModel *GMODEL;

static ExtrudeParams extr;

static Post_View *View;
static List_T *ViewValueList;
static double ViewCoord[100];
static int *ViewNumList, ViewNumNodes, ViewNumComp, ViewNumListTmp;
static int ViewCoordIdx, ViewElementIdx;
static int ViewErrorFlags[VIEW_NB_ELEMENT_TYPES];

#define MAX_RECUR_LOOPS 100
static int ImbricatedLoop = 0;
static fpos_t yyposImbricatedLoopsTab[MAX_RECUR_LOOPS];
static int yylinenoImbricatedLoopsTab[MAX_RECUR_LOOPS];
static double LoopControlVariablesTab[MAX_RECUR_LOOPS][3];
static char *LoopControlVariablesNameTab[MAX_RECUR_LOOPS];

void yyerror(char *s);
void yymsg(int type, char *fmt, ...);
void skip_until(char *skip, char *until);
int PrintListOfDouble(char *format, List_T *list, char *buffer);
int CheckViewErrorFlags(Post_View *v);

#line 76 "Gmsh.y"
typedef union {
  char *c;
  int i;
  unsigned int u;
  double d;
  double v[5];
  Shape s;
  List_T *l;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		1227
#define	YYFLAG		-32768
#define	YYNTBASE	142

#define YYTRANSLATE(x) ((unsigned)(x) <= 375 ? yytranslate[x] : 209)

static const short yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,   127,     2,   137,     2,   125,     2,     2,   132,
   133,   123,   121,   138,   122,   136,   124,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,   117,
     2,   119,   111,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
   134,     2,   135,   131,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,   139,     2,   140,   141,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
    57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
    77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
    87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
    97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
   107,   108,   109,   110,   112,   113,   114,   115,   116,   118,
   120,   126,   128,   129,   130
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     5,     6,     9,    11,    13,    15,    17,    19,
    21,    23,    25,    27,    29,    31,    33,    35,    37,    39,
    41,    44,    50,    58,    66,    76,    83,    92,    93,    96,
    99,   102,   105,   108,   111,   113,   117,   119,   123,   124,
   125,   136,   138,   142,   143,   157,   159,   163,   164,   180,
   189,   190,   197,   204,   206,   208,   210,   212,   214,   216,
   218,   223,   231,   241,   248,   255,   259,   266,   273,   283,
   290,   300,   306,   315,   324,   336,   343,   353,   363,   373,
   375,   377,   385,   394,   407,   414,   422,   430,   438,   448,
   456,   466,   484,   492,   500,   512,   521,   534,   543,   552,
   561,   574,   597,   618,   627,   636,   645,   653,   662,   668,
   680,   686,   696,   698,   700,   702,   703,   706,   713,   720,
   727,   734,   739,   746,   753,   760,   765,   772,   776,   781,
   787,   791,   795,   800,   805,   809,   817,   825,   829,   837,
   841,   844,   847,   863,   866,   873,   882,   891,   902,   904,
   907,   909,   913,   918,   920,   926,   938,   952,   953,   961,
   962,   976,   977,   993,  1002,  1011,  1020,  1033,  1046,  1059,
  1074,  1089,  1104,  1105,  1118,  1119,  1132,  1133,  1146,  1147,
  1164,  1165,  1182,  1183,  1200,  1201,  1220,  1221,  1240,  1241,
  1260,  1262,  1265,  1271,  1279,  1289,  1292,  1299,  1309,  1319,
  1328,  1338,  1347,  1356,  1363,  1368,  1375,  1382,  1389,  1396,
  1399,  1402,  1404,  1408,  1411,  1414,  1417,  1421,  1425,  1429,
  1433,  1437,  1441,  1445,  1449,  1453,  1457,  1461,  1465,  1469,
  1473,  1479,  1484,  1489,  1494,  1499,  1504,  1509,  1514,  1519,
  1524,  1529,  1536,  1541,  1546,  1551,  1556,  1561,  1566,  1573,
  1580,  1587,  1592,  1597,  1602,  1607,  1612,  1617,  1622,  1627,
  1632,  1637,  1642,  1649,  1654,  1659,  1664,  1669,  1674,  1679,
  1686,  1693,  1700,  1705,  1707,  1709,  1711,  1713,  1715,  1717,
  1719,  1721,  1727,  1732,  1737,  1740,  1746,  1750,  1757,  1762,
  1770,  1777,  1779,  1782,  1785,  1789,  1793,  1805,  1815,  1823,
  1831,  1832,  1836,  1840,  1842,  1846,  1848,  1850,  1853,  1857,
  1862,  1866,  1872,  1877,  1879,  1881,  1883,  1887,  1892,  1899,
  1907,  1909,  1911,  1915,  1919,  1929,  1937,  1939,  1945,  1949,
  1956,  1958,  1962,  1964,  1966,  1973,  1978,  1983,  1988,  1995,
  2002
};

static const short yyrhs[] = {   143,
     0,     1,     6,     0,     0,   143,   144,     0,   147,     0,
   146,     0,   166,     0,   168,     0,   169,     0,   172,     0,
   173,     0,   174,     0,   175,     0,   178,     0,   193,     0,
   194,     0,   195,     0,   177,     0,   176,     0,   119,     0,
   119,   119,     0,    33,   132,     5,   133,     6,     0,    33,
   132,     5,   133,   145,   208,     6,     0,    33,   132,     5,
   138,   204,   133,     6,     0,    33,   132,     5,   138,   204,
   133,   145,   208,     6,     0,     4,     5,   139,   148,   140,
     6,     0,     4,     5,     4,   198,   139,   148,   140,     6,
     0,     0,   148,   151,     0,   148,   155,     0,   148,   158,
     0,   148,   160,     0,   148,   161,     0,   148,   163,     0,
   196,     0,   149,   138,   196,     0,   196,     0,   150,   138,
   196,     0,     0,     0,     4,   152,   132,   149,   133,   153,
   139,   150,   140,     6,     0,   208,     0,   154,   138,   208,
     0,     0,    76,   132,   196,   138,   196,   138,   196,   133,
   156,   139,   154,   140,     6,     0,   208,     0,   157,   138,
   208,     0,     0,    77,   132,   196,   138,   196,   138,   196,
   138,   196,   133,   159,   139,   157,   140,     6,     0,    78,
   139,   201,   140,   139,   201,   140,     6,     0,     0,    79,
   162,   139,   150,   140,     6,     0,    80,   132,   196,   133,
   202,     6,     0,     7,     0,   107,     0,   108,     0,   109,
     0,   110,     0,   128,     0,   129,     0,     4,   164,   196,
     6,     0,     4,   134,   196,   135,   164,   196,     6,     0,
     4,   134,   139,   204,   140,   135,   164,   202,     6,     0,
     4,   134,   135,     7,   202,     6,     0,     4,   134,   135,
   107,   202,     6,     0,     4,   165,     6,     0,     4,   134,
   196,   135,   165,     6,     0,     4,   136,     4,     7,   208,
     6,     0,     4,   134,   196,   135,   136,     4,     7,   208,
     6,     0,     4,   136,     4,   164,   196,     6,     0,     4,
   134,   196,   135,   136,     4,   164,   196,     6,     0,     4,
   136,     4,   165,     6,     0,     4,   134,   196,   135,   136,
     4,   165,     6,     0,     4,   136,    89,   136,     4,     7,
   205,     6,     0,     4,   134,   196,   135,   136,    89,   136,
     4,     7,   205,     6,     0,     4,   136,    90,     7,   206,
     6,     0,     4,   134,   196,   135,   136,    90,     7,   206,
     6,     0,    60,   132,     4,   133,   136,     4,     7,   196,
     6,     0,    60,   132,     4,   133,   136,     4,     7,   208,
     6,     0,   196,     0,   208,     0,    41,   132,   196,   133,
     7,   198,     6,     0,    56,    41,   132,   167,   133,     7,
   202,     6,     0,    72,    41,   202,     7,   139,   196,   138,
   196,   138,   196,   140,     6,     0,    48,    49,   202,     7,
   196,     6,     0,    44,   132,   196,   133,     7,   202,     6,
     0,    46,   132,   196,   133,     7,   202,     6,     0,    42,
   132,   196,   133,     7,   202,     6,     0,    42,   132,   196,
   133,     7,   202,    52,   198,     6,     0,    43,   132,   196,
   133,     7,   202,     6,     0,    43,   132,   196,   133,     7,
   202,    52,   198,     6,     0,    50,   132,   196,   133,     7,
   139,   196,   138,   196,   138,     5,   138,     5,   138,     5,
   140,     6,     0,    82,   132,   196,   133,     7,   202,     6,
     0,    83,   132,   196,   133,     7,   202,     6,     0,    84,
   132,   196,   133,     7,   202,    88,   202,    85,   196,     6,
     0,    44,    67,   132,   196,   133,     7,   202,     6,     0,
    72,    44,   202,     7,   139,   196,   138,   196,   138,   196,
   140,     6,     0,    56,    44,   132,   167,   133,     7,   202,
     6,     0,    52,    45,   132,   196,   133,     7,   202,     6,
     0,    53,    45,   132,   196,   133,     7,   202,     6,     0,
   100,    45,   132,   196,   133,     7,   139,   196,   138,   202,
   140,     6,     0,    84,    45,    86,    87,   132,   196,   133,
     7,   200,    88,   139,   202,   138,   202,   140,    85,   139,
   196,   138,   196,   140,     6,     0,    84,    45,   132,   196,
   133,     7,   200,    88,   139,   202,   138,   202,   140,    85,
   139,   196,   138,   196,   140,     6,     0,    45,    67,   132,
   196,   133,     7,   202,     6,     0,    56,    45,   132,   167,
   133,     7,   202,     6,     0,    55,    47,   132,   196,   133,
     7,   202,     6,     0,    47,   132,   196,   133,     7,   202,
     6,     0,    56,    47,   132,   167,   133,     7,   202,     6,
     0,    62,   198,   139,   170,   140,     0,    61,   139,   198,
   138,   198,   138,   196,   140,   139,   170,   140,     0,    63,
   198,   139,   170,   140,     0,    64,   139,   198,   138,   196,
   140,   139,   170,   140,     0,   172,     0,   171,     0,   169,
     0,     0,   171,   168,     0,   171,    41,   139,   204,   140,
     6,     0,   171,    44,   139,   204,   140,     6,     0,   171,
    45,   139,   204,   140,     6,     0,   171,    47,   139,   204,
   140,     6,     0,    66,   139,   171,   140,     0,    66,     4,
   134,   196,   135,     6,     0,    74,     4,   134,   196,   135,
     6,     0,    75,     4,   134,   196,   135,     6,     0,    69,
   139,   171,   140,     0,    69,     4,   134,   196,   135,     6,
     0,    69,     4,     6,     0,    69,     4,     4,     6,     0,
    89,   205,   139,   171,   140,     0,   101,   208,     6,     0,
   102,   208,     6,     0,   101,   139,   171,   140,     0,   102,
   139,   171,   140,     0,     4,   208,     6,     0,     4,     4,
   134,   196,   135,   208,     6,     0,     4,     4,     4,   134,
   196,   135,     6,     0,     4,   196,     6,     0,    60,   132,
     4,   133,   136,     4,     6,     0,    81,     4,     6,     0,
    96,     6,     0,    38,     6,     0,    38,   139,   196,   138,
   196,   138,   196,   138,   196,   138,   196,   138,   196,   140,
     6,     0,    39,     6,     0,    91,   132,   196,     8,   196,
   133,     0,    91,   132,   196,     8,   196,     8,   196,   133,
     0,    91,     4,    92,   139,   196,     8,   196,   140,     0,
    91,     4,    92,   139,   196,     8,   196,     8,   196,   140,
     0,    93,     0,    99,     4,     0,    97,     0,    98,     4,
     6,     0,    94,   132,   196,   133,     0,    95,     0,    65,
   198,   139,   171,   140,     0,    65,   139,   198,   138,   198,
   138,   196,   140,   139,   171,   140,     0,    65,   139,   198,
   138,   198,   138,   198,   138,   196,   140,   139,   171,   140,
     0,     0,    65,   198,   139,   171,   179,   191,   140,     0,
     0,    65,   139,   198,   138,   198,   138,   196,   140,   139,
   171,   180,   191,   140,     0,     0,    65,   139,   198,   138,
   198,   138,   198,   138,   196,   140,   139,   171,   181,   191,
   140,     0,    65,    41,   139,   196,   138,   198,   140,     6,
     0,    65,    44,   139,   196,   138,   198,   140,     6,     0,
    65,    45,   139,   196,   138,   198,   140,     6,     0,    65,
    41,   139,   196,   138,   198,   138,   198,   138,   196,   140,
     6,     0,    65,    44,   139,   196,   138,   198,   138,   198,
   138,   196,   140,     6,     0,    65,    45,   139,   196,   138,
   198,   138,   198,   138,   196,   140,     6,     0,    65,    41,
   139,   196,   138,   198,   138,   198,   138,   198,   138,   196,
   140,     6,     0,    65,    44,   139,   196,   138,   198,   138,
   198,   138,   198,   138,   196,   140,     6,     0,    65,    45,
   139,   196,   138,   198,   138,   198,   138,   198,   138,   196,
   140,     6,     0,     0,    65,    41,   139,   196,   138,   198,
   140,   182,   139,   191,   140,     6,     0,     0,    65,    44,
   139,   196,   138,   198,   140,   183,   139,   191,   140,     6,
     0,     0,    65,    45,   139,   196,   138,   198,   140,   184,
   139,   191,   140,     6,     0,     0,    65,    41,   139,   196,
   138,   198,   138,   198,   138,   196,   140,   185,   139,   191,
   140,     6,     0,     0,    65,    44,   139,   196,   138,   198,
   138,   198,   138,   196,   140,   186,   139,   191,   140,     6,
     0,     0,    65,    45,   139,   196,   138,   198,   138,   198,
   138,   196,   140,   187,   139,   191,   140,     6,     0,     0,
    65,    41,   139,   196,   138,   198,   138,   198,   138,   198,
   138,   196,   140,   188,   139,   191,   140,     6,     0,     0,
    65,    44,   139,   196,   138,   198,   138,   198,   138,   198,
   138,   196,   140,   189,   139,   191,   140,     6,     0,     0,
    65,    45,   139,   196,   138,   198,   138,   198,   138,   198,
   138,   196,   140,   190,   139,   191,   140,     6,     0,   192,
     0,   191,   192,     0,    73,   139,   196,   140,     6,     0,
    73,   139,   202,   138,   202,   140,     6,     0,    73,   139,
   202,   138,   202,   138,   202,   140,     6,     0,    68,     6,
     0,    54,    44,   202,     7,   196,     6,     0,    54,    44,
   202,     7,   196,    57,    59,   196,     6,     0,    54,    44,
   202,     7,   196,    57,    58,   196,     6,     0,    54,    45,
   139,   196,   140,     7,   202,     6,     0,    54,    45,   139,
   196,   140,     7,   202,     4,     6,     0,    51,    45,   139,
   196,   140,     7,   202,     6,     0,    54,    47,   139,   196,
   140,     7,   202,     6,     0,    68,    45,   202,     7,   196,
     6,     0,    68,    45,   202,     6,     0,    41,   202,    92,
    45,   196,     6,     0,    44,   202,    92,    45,   196,     6,
     0,    44,   202,    92,    47,   196,     6,     0,    45,   202,
    92,    47,   196,     6,     0,    70,     6,     0,    71,     6,
     0,   197,     0,   132,   196,   133,     0,   122,   196,     0,
   121,   196,     0,   127,   196,     0,   196,   122,   196,     0,
   196,   121,   196,     0,   196,   123,   196,     0,   196,   124,
   196,     0,   196,   125,   196,     0,   196,   131,   196,     0,
   196,   117,   196,     0,   196,   119,   196,     0,   196,   118,
   196,     0,   196,   120,   196,     0,   196,   114,   196,     0,
   196,   115,   196,     0,   196,   113,   196,     0,   196,   112,
   196,     0,   196,   111,   196,     8,   196,     0,    12,   132,
   196,   133,     0,    13,   132,   196,   133,     0,    14,   132,
   196,   133,     0,    15,   132,   196,   133,     0,    16,   132,
   196,   133,     0,    17,   132,   196,   133,     0,    18,   132,
   196,   133,     0,    19,   132,   196,   133,     0,    20,   132,
   196,   133,     0,    22,   132,   196,   133,     0,    23,   132,
   196,   138,   196,   133,     0,    24,   132,   196,   133,     0,
    25,   132,   196,   133,     0,    26,   132,   196,   133,     0,
    27,   132,   196,   133,     0,    28,   132,   196,   133,     0,
    29,   132,   196,   133,     0,    30,   132,   196,   138,   196,
   133,     0,    31,   132,   196,   138,   196,   133,     0,    32,
   132,   196,   138,   196,   133,     0,    21,   132,   196,   133,
     0,    12,   134,   196,   135,     0,    13,   134,   196,   135,
     0,    14,   134,   196,   135,     0,    15,   134,   196,   135,
     0,    16,   134,   196,   135,     0,    17,   134,   196,   135,
     0,    18,   134,   196,   135,     0,    19,   134,   196,   135,
     0,    20,   134,   196,   135,     0,    22,   134,   196,   135,
     0,    23,   134,   196,   138,   196,   135,     0,    24,   134,
   196,   135,     0,    25,   134,   196,   135,     0,    26,   134,
   196,   135,     0,    27,   134,   196,   135,     0,    28,   134,
   196,   135,     0,    29,   134,   196,   135,     0,    30,   134,
   196,   138,   196,   135,     0,    31,   134,   196,   138,   196,
   135,     0,    32,   134,   196,   138,   196,   135,     0,    21,
   134,   196,   135,     0,     3,     0,     9,     0,    10,     0,
    11,     0,   104,     0,   105,     0,   106,     0,     4,     0,
     4,   141,   139,   196,   140,     0,     4,   134,   196,   135,
     0,   137,     4,   134,   135,     0,     4,   165,     0,     4,
   134,   196,   135,   165,     0,     4,   136,     4,     0,     4,
   134,   196,   135,   136,     4,     0,     4,   136,     4,   165,
     0,     4,   134,   196,   135,   136,     4,   165,     0,   103,
   132,     5,   138,   196,   133,     0,   199,     0,   122,   198,
     0,   121,   198,     0,   198,   122,   198,     0,   198,   121,
   198,     0,   139,   196,   138,   196,   138,   196,   138,   196,
   138,   196,   140,     0,   139,   196,   138,   196,   138,   196,
   138,   196,   140,     0,   139,   196,   138,   196,   138,   196,
   140,     0,   132,   196,   138,   196,   138,   196,   133,     0,
     0,   139,   201,   140,     0,   132,   201,   133,     0,   202,
     0,   201,   138,   202,     0,   196,     0,   203,     0,   139,
   140,     0,   139,   204,   140,     0,   122,   139,   204,   140,
     0,   196,     8,   196,     0,   196,     8,   196,     8,   196,
     0,    41,   139,   196,   140,     0,   169,     0,   172,     0,
   178,     0,     4,   134,   135,     0,   122,     4,   134,   135,
     0,     4,   134,   139,   204,   140,   135,     0,   122,     4,
   134,   139,   204,   140,   135,     0,   196,     0,   203,     0,
   204,   138,   196,     0,   204,   138,   203,     0,   139,   196,
   138,   196,   138,   196,   138,   196,   140,     0,   139,   196,
   138,   196,   138,   196,   140,     0,     4,     0,     4,   136,
    89,   136,     4,     0,   139,   207,   140,     0,     4,   134,
   196,   135,   136,    90,     0,   205,     0,   207,   138,   205,
     0,     5,     0,    40,     0,    35,   132,   208,   138,   208,
   133,     0,    36,   132,   208,   133,     0,    37,   132,   208,
   133,     0,    34,   132,   208,   133,     0,    34,   132,   208,
   138,   204,   133,     0,    34,   132,     4,   136,     4,   133,
     0,    34,   132,     4,   134,   196,   135,   136,     4,   133,
     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   141,   143,   148,   150,   153,   155,   156,   157,   158,   159,
   160,   161,   162,   163,   164,   165,   166,   167,   168,   171,
   176,   182,   188,   203,   216,   244,   252,   261,   269,   270,
   271,   272,   273,   274,   277,   280,   284,   287,   291,   482,
   500,   510,   516,   523,   531,   537,   543,   550,   558,   564,
   572,   577,   581,   590,   592,   593,   594,   595,   598,   600,
   603,   638,   677,   731,   748,   766,   777,   796,   810,   827,
   853,   880,   894,   911,   925,   942,   962,   985,   995,  1009,
  1014,  1021,  1041,  1057,  1064,  1086,  1104,  1122,  1140,  1166,
  1184,  1210,  1230,  1254,  1278,  1304,  1321,  1328,  1347,  1366,
  1405,  1430,  1449,  1468,  1484,  1504,  1521,  1538,  1558,  1564,
  1569,  1574,  1581,  1583,  1584,  1587,  1592,  1596,  1612,  1628,
  1644,  1664,  1679,  1685,  1691,  1702,  1712,  1722,  1737,  1755,
  1769,  1776,  1782,  1791,  1804,  1850,  1865,  1876,  1896,  1906,
  1928,  1932,  1937,  1942,  1952,  1969,  1985,  2011,  2038,  2070,
  2077,  2082,  2088,  2092,  2100,  2109,  2117,  2125,  2130,  2138,
  2143,  2151,  2156,  2166,  2173,  2180,  2187,  2194,  2201,  2208,
  2215,  2222,  2229,  2234,  2241,  2246,  2253,  2258,  2265,  2270,
  2277,  2282,  2289,  2294,  2301,  2306,  2313,  2318,  2325,  2330,
  2340,  2344,  2349,  2359,  2381,  2405,  2413,  2432,  2450,  2468,
  2497,  2532,  2537,  2564,  2578,  2596,  2603,  2609,  2612,  2618,
  2623,  2632,  2634,  2635,  2636,  2637,  2638,  2639,  2640,  2641,
  2648,  2649,  2650,  2651,  2652,  2653,  2654,  2655,  2656,  2657,
  2658,  2659,  2660,  2661,  2662,  2663,  2664,  2665,  2666,  2667,
  2668,  2669,  2670,  2671,  2672,  2673,  2674,  2675,  2676,  2677,
  2678,  2679,  2681,  2682,  2683,  2684,  2685,  2686,  2687,  2688,
  2689,  2690,  2691,  2692,  2693,  2694,  2695,  2696,  2697,  2698,
  2699,  2700,  2701,  2706,  2711,  2712,  2713,  2714,  2715,  2716,
  2720,  2736,  2751,  2771,  2785,  2798,  2821,  2839,  2857,  2875,
  2893,  2900,  2905,  2909,  2913,  2917,  2923,  2928,  2932,  2936,
  2942,  2946,  2950,  2956,  2962,  2969,  2975,  2979,  2984,  2988,
  2999,  3006,  3017,  3037,  3047,  3057,  3067,  3084,  3103,  3127,
  3155,  3161,  3165,  3169,  3181,  3186,  3198,  3205,  3226,  3231,
  3245,  3251,  3257,  3262,  3270,  3278,  3292,  3306,  3310,  3329,
  3351
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","tDOUBLE",
"tSTRING","tBIGSTR","tEND","tAFFECT","tDOTS","tPi","tMPI_Rank","tMPI_Size","tExp",
"tLog","tLog10","tSqrt","tSin","tAsin","tCos","tAcos","tTan","tRand","tAtan",
"tAtan2","tSinh","tCosh","tTanh","tFabs","tFloor","tCeil","tFmod","tModulo",
"tHypot","tPrintf","tSprintf","tStrCat","tStrPrefix","tStrRelative","tBoundingBox",
"tDraw","tToday","tPoint","tCircle","tEllipse","tLine","tSurface","tSpline",
"tVolume","tCharacteristic","tLength","tParametric","tElliptic","tPlane","tRuled",
"tTransfinite","tComplex","tPhysical","tUsing","tBump","tProgression","tPlugin",
"tRotate","tTranslate","tSymmetry","tDilate","tExtrude","tDuplicata","tLoop",
"tRecombine","tDelete","tCoherence","tIntersect","tAttractor","tLayers","tAlias",
"tAliasWithOptions","tText2D","tText3D","tInterpolationScheme","tTime","tGrain",
"tCombine","tBSpline","tBezier","tNurbs","tOrder","tWith","tBounds","tKnots",
"tColor","tColorTable","tFor","tIn","tEndFor","tIf","tEndIf","tExit","tReturn",
"tCall","tFunction","tTrimmed","tShow","tHide","tGetValue","tGMSH_MAJOR_VERSION",
"tGMSH_MINOR_VERSION","tGMSH_PATCH_VERSION","tAFFECTPLUS","tAFFECTMINUS","tAFFECTTIMES",
"tAFFECTDIVIDE","'?'","tOR","tAND","tEQUAL","tNOTEQUAL","tAPPROXEQUAL","'<'",
"tLESSOREQUAL","'>'","tGREATEROREQUAL","'+'","'-'","'*'","'/'","'%'","tCROSSPRODUCT",
"'!'","tPLUSPLUS","tMINUSMINUS","UNARYPREC","'^'","'('","')'","'['","']'","'.'",
"'#'","','","'{'","'}'","'~'","All","GeoFormatItems","GeoFormatItem","SendToFile",
"Printf","View","Views","ElementCoords","ElementValues","Element","@1","@2",
"Text2DValues","Text2D","@3","Text3DValues","Text3D","@4","InterpolationMatrix",
"Time","@5","Grain","NumericAffectation","NumericIncrement","Affectation","PhysicalId",
"Shape","Transform","MultipleShape","ListOfShapes","Duplicata","Delete","Colorify",
"Visibility","Command","Loop","Extrude","@6","@7","@8","@9","@10","@11","@12",
"@13","@14","@15","@16","@17","ExtrudeParameters","ExtrudeParameter","Transfinite",
"Embedding","Coherence","FExpr","FExpr_Single","VExpr","VExpr_Single","ListOfListOfDouble",
"RecursiveListOfListOfDouble","ListOfDouble","FExpr_Multi","RecursiveListOfDouble",
"ColorExpr","ListOfColor","RecursiveListOfColor","StringExpr", NULL
};
#endif

static const short yyr1[] = {     0,
   142,   142,   143,   143,   144,   144,   144,   144,   144,   144,
   144,   144,   144,   144,   144,   144,   144,   144,   144,   145,
   145,   146,   146,   146,   146,   147,   147,   148,   148,   148,
   148,   148,   148,   148,   149,   149,   150,   150,   152,   153,
   151,   154,   154,   156,   155,   157,   157,   159,   158,   160,
   162,   161,   163,   164,   164,   164,   164,   164,   165,   165,
   166,   166,   166,   166,   166,   166,   166,   166,   166,   166,
   166,   166,   166,   166,   166,   166,   166,   166,   166,   167,
   167,   168,   168,   168,   168,   168,   168,   168,   168,   168,
   168,   168,   168,   168,   168,   168,   168,   168,   168,   168,
   168,   168,   168,   168,   168,   168,   168,   168,   169,   169,
   169,   169,   170,   170,   170,   171,   171,   171,   171,   171,
   171,   172,   172,   172,   172,   173,   173,   173,   173,   174,
   175,   175,   175,   175,   176,   176,   176,   176,   176,   176,
   176,   176,   176,   176,   177,   177,   177,   177,   177,   177,
   177,   177,   177,   177,   178,   178,   178,   179,   178,   180,
   178,   181,   178,   178,   178,   178,   178,   178,   178,   178,
   178,   178,   182,   178,   183,   178,   184,   178,   185,   178,
   186,   178,   187,   178,   188,   178,   189,   178,   190,   178,
   191,   191,   192,   192,   192,   192,   193,   193,   193,   193,
   193,   193,   193,   193,   193,   194,   194,   194,   194,   195,
   195,   196,   196,   196,   196,   196,   196,   196,   196,   196,
   196,   196,   196,   196,   196,   196,   196,   196,   196,   196,
   196,   196,   196,   196,   196,   196,   196,   196,   196,   196,
   196,   196,   196,   196,   196,   196,   196,   196,   196,   196,
   196,   196,   196,   196,   196,   196,   196,   196,   196,   196,
   196,   196,   196,   196,   196,   196,   196,   196,   196,   196,
   196,   196,   196,   197,   197,   197,   197,   197,   197,   197,
   197,   197,   197,   197,   197,   197,   197,   197,   197,   197,
   197,   198,   198,   198,   198,   198,   199,   199,   199,   199,
   200,   200,   200,   201,   201,   202,   202,   202,   202,   202,
   203,   203,   203,   203,   203,   203,   203,   203,   203,   203,
   204,   204,   204,   204,   205,   205,   205,   205,   206,   206,
   207,   207,   208,   208,   208,   208,   208,   208,   208,   208,
   208
};

static const short yyr2[] = {     0,
     1,     2,     0,     2,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     2,     5,     7,     7,     9,     6,     8,     0,     2,     2,
     2,     2,     2,     2,     1,     3,     1,     3,     0,     0,
    10,     1,     3,     0,    13,     1,     3,     0,    15,     8,
     0,     6,     6,     1,     1,     1,     1,     1,     1,     1,
     4,     7,     9,     6,     6,     3,     6,     6,     9,     6,
     9,     5,     8,     8,    11,     6,     9,     9,     9,     1,
     1,     7,     8,    12,     6,     7,     7,     7,     9,     7,
     9,    17,     7,     7,    11,     8,    12,     8,     8,     8,
    12,    22,    20,     8,     8,     8,     7,     8,     5,    11,
     5,     9,     1,     1,     1,     0,     2,     6,     6,     6,
     6,     4,     6,     6,     6,     4,     6,     3,     4,     5,
     3,     3,     4,     4,     3,     7,     7,     3,     7,     3,
     2,     2,    15,     2,     6,     8,     8,    10,     1,     2,
     1,     3,     4,     1,     5,    11,    13,     0,     7,     0,
    13,     0,    15,     8,     8,     8,    12,    12,    12,    14,
    14,    14,     0,    12,     0,    12,     0,    12,     0,    16,
     0,    16,     0,    16,     0,    18,     0,    18,     0,    18,
     1,     2,     5,     7,     9,     2,     6,     9,     9,     8,
     9,     8,     8,     6,     4,     6,     6,     6,     6,     2,
     2,     1,     3,     2,     2,     2,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     5,     4,     4,     4,     4,     4,     4,     4,     4,     4,
     4,     6,     4,     4,     4,     4,     4,     4,     6,     6,
     6,     4,     4,     4,     4,     4,     4,     4,     4,     4,
     4,     4,     6,     4,     4,     4,     4,     4,     4,     6,
     6,     6,     4,     1,     1,     1,     1,     1,     1,     1,
     1,     5,     4,     4,     2,     5,     3,     6,     4,     7,
     6,     1,     2,     2,     3,     3,    11,     9,     7,     7,
     0,     3,     3,     1,     3,     1,     1,     2,     3,     4,
     3,     5,     4,     1,     1,     1,     3,     4,     6,     7,
     1,     1,     3,     3,     9,     7,     1,     5,     3,     6,
     1,     3,     1,     1,     6,     4,     4,     4,     6,     6,
     9
};

static const short yydefact[] = {     0,
     0,     1,     2,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   149,     0,   154,     0,   151,     0,     0,     0,
     0,     0,     4,     6,     5,     7,     8,     9,    10,    11,
    12,    13,    19,    18,    14,    15,    16,    17,   274,   281,
   333,    54,   275,   276,   277,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   334,     0,   278,   279,   280,    55,    56,    57,    58,     0,
     0,     0,    59,    60,     0,     0,     0,     0,     0,     0,
     0,   212,     0,     0,   142,     0,   144,   281,     0,     0,
     0,     0,   314,   315,   316,   306,     0,   307,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   292,     0,     0,
     0,     0,     0,     0,     0,     0,   116,     0,     0,   116,
   210,   211,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   327,     0,     0,     0,     0,     0,   141,     0,   150,
     0,   333,   116,     0,   116,     0,     0,     0,     0,     0,
   285,     0,    28,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   281,   215,   214,   216,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    66,   138,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   135,     0,     0,     0,     0,   281,     0,     0,     0,   308,
   321,   322,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   294,
   293,     0,     0,     0,     0,   116,   116,     0,     0,     0,
     0,     0,     0,     0,     0,   116,     0,     0,     0,     0,
   128,     0,     0,     0,     0,     0,     0,   140,     0,     0,
     0,     0,     0,     0,     0,   116,     0,     0,     0,   152,
     0,     0,   131,     0,   132,     0,     0,   287,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   213,     0,     0,     0,     0,    54,     0,     0,     0,     0,
     0,    61,     0,   230,   229,   227,   228,   223,   225,   224,
   226,   218,   217,   219,   220,   221,   222,     0,     0,     0,
   317,     0,     0,     0,     0,     0,   213,     0,   309,   311,
     0,     0,     0,     0,   213,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    80,    81,     0,     0,     0,     0,     0,     0,     0,
   296,   295,   115,     0,   114,   113,     0,     0,     0,     0,
     0,     0,     0,   158,     0,     0,     0,     0,     0,   122,
   117,   205,     0,   129,     0,   126,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   153,     0,   133,   134,     0,   283,   289,     0,    28,    39,
     0,     0,     0,    51,     0,     0,    29,    30,    31,    32,
    33,    34,   232,   253,   233,   254,   234,   255,   235,   256,
   236,   257,   237,   258,   238,   259,   239,   260,   240,   261,
   252,   273,   241,   262,     0,     0,   243,   264,   244,   265,
   245,   266,   246,   267,   247,   268,   248,   269,     0,     0,
     0,     0,     0,     0,     0,     0,   338,     0,     0,   336,
   337,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    72,     0,     0,     0,     0,   284,     0,    22,    20,     0,
     0,     0,     0,   283,   313,   318,     0,   310,     0,   323,
   324,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   109,   111,     0,     0,     0,     0,     0,   155,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   130,
     0,     0,     0,     0,     0,   286,     0,   282,     0,     0,
     0,     0,     0,     0,     0,    26,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    64,
    65,     0,     0,     0,     0,     0,    67,    68,    70,     0,
     0,   331,     0,    76,   231,    21,     0,     0,     0,     0,
     0,     0,   312,   206,     0,     0,     0,     0,   207,   208,
     0,   209,     0,     0,    85,     0,     0,     0,     0,   197,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   191,   123,     0,     0,     0,     0,     0,     0,   204,   127,
     0,     0,   124,   125,     0,     0,     0,   301,     0,   328,
     0,     0,     0,   145,     0,   137,   288,   136,     0,     0,
     0,     0,     0,   304,     0,     0,   242,   263,   249,   270,
   250,   271,   251,   272,     0,   340,   339,   335,   291,     0,
    54,     0,     0,     0,     0,    62,     0,     0,     0,   329,
    23,    24,     0,     0,   319,     0,    82,    88,     0,    90,
     0,     0,    86,     0,    87,   107,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   139,
     0,     0,     0,     0,   116,     0,   173,     0,   175,     0,
   177,     0,     0,   196,     0,   159,   192,     0,     0,     0,
     0,     0,     0,     0,     0,    93,    94,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   290,    27,     0,    35,
     0,     0,     0,     0,     0,    37,     0,     0,     0,     0,
     0,    73,     0,     0,    74,     0,   332,     0,     0,   320,
     0,     0,    96,   104,     0,   202,    99,   100,     0,     0,
     0,   200,   203,   106,    83,    98,   105,   108,     0,     0,
     0,   300,     0,   299,     0,     0,   164,     0,     0,   165,
     0,     0,   166,     0,     0,     0,   306,     0,   118,   119,
   120,   121,     0,     0,   301,     0,     0,     0,     0,     0,
   326,     0,   147,   146,     0,    40,     0,     0,     0,   305,
     0,     0,     0,     0,     0,    63,    69,    71,     0,    77,
     0,    25,     0,    89,    91,     0,   199,   198,   201,    78,
    79,   116,     0,   112,     0,     0,     0,     0,     0,     0,
   116,     0,     0,     0,     0,     0,     0,   303,   302,     0,
     0,     0,     0,     0,     0,    36,     0,     0,     0,    38,
    52,    53,   341,     0,   330,     0,     0,     0,     0,   298,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   160,
     0,   193,     0,     0,     0,     0,     0,     0,   325,   148,
     0,     0,     0,     0,     0,    75,     0,     0,   110,     0,
   179,     0,     0,   181,     0,     0,   183,     0,     0,   156,
     0,   116,     0,     0,     0,     0,     0,     0,    95,     0,
     0,    44,     0,    50,     0,     0,   297,   167,     0,     0,
   174,   168,     0,     0,   176,   169,     0,     0,   178,     0,
   162,     0,   194,    84,    97,     0,     0,   101,     0,     0,
     0,     0,     0,     0,   185,     0,   187,     0,   189,   161,
   157,     0,     0,     0,     0,    41,     0,    48,     0,     0,
     0,   170,     0,     0,   171,     0,     0,   172,     0,     0,
   195,     0,     0,     0,    42,     0,   143,     0,     0,     0,
     0,     0,     0,     0,   163,     0,     0,     0,     0,     0,
     0,   180,     0,   182,     0,   184,     0,     0,     0,    43,
    45,     0,    46,    92,     0,     0,     0,     0,     0,     0,
     0,   186,   188,   190,     0,     0,    47,    49,     0,     0,
     0,   103,     0,   102,     0,     0,     0
};

static const short yydefgoto[] = {  1225,
     2,    53,   630,    54,    55,   381,   919,   925,   557,   710,
  1045,  1174,   558,  1140,  1202,   559,  1176,   560,   561,   714,
   562,   119,   211,    56,   491,   521,   133,   504,   505,   134,
    60,    61,    62,    63,    64,   135,   679,  1101,  1152,   968,
   971,   974,  1119,  1123,  1127,  1163,  1166,  1169,   790,   791,
    66,    67,    68,   136,   122,   330,   168,   911,   823,   824,
   138,   303,   194,   625,   743,   493
};

static const short yypact[] = {  2774,
    21,  3171,-32768,  2316,  -114,    18,    29,  1719,   -84,   -63,
  1457,  1588,   -60,   -50,    70,    -9,    84,   121,   128,   558,
   132,   595,    74,   113,   -43,   -43,   119,   285,    10,   226,
    11,   293,   310,   147,   330,   343,   352,   227,   239,   -33,
    13,    19,-32768,   242,-32768,   318,-32768,   411,   417,   393,
    17,    24,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    12,
    15,-32768,-32768,-32768,-32768,   231,   250,   317,   398,   432,
   459,   495,   503,   520,   521,   539,   540,   602,   607,   629,
   648,   652,   679,   686,   700,   701,   263,   307,   321,   325,
-32768,   336,-32768,-32768,-32768,-32768,-32768,-32768,-32768,  2531,
  2531,  2531,-32768,-32768,  2531,  1917,    28,   472,  2531,   480,
   635,-32768,   505,   474,-32768,  2531,-32768,   424,   362,  2155,
  2531,  1308,-32768,-32768,-32768,  2588,   410,-32768,  2531,  2531,
   413,  2531,   450,   438,   491,  2531,  2531,  1850,  2531,   467,
   511,   543,  1850,   544,   550,   552,   565,   577,   578,   588,
   608,   -43,   -43,   -43,  2531,  2531,   167,-32768,   315,   -43,
   551,   574,   591,  2185,   320,   609,-32768,  1850,    34,-32768,
-32768,-32768,  1850,  1850,   617,   645,   732,  2531,  2531,   -31,
  2531,   649,  2531,   671,   722,  2531,  2531,-32768,   809,-32768,
   687,-32768,-32768,   831,-32768,   835,   719,  2531,   852,   721,
-32768,   -43,-32768,  2531,  2531,  2531,  2531,  2531,  2531,  2531,
  2531,  2531,  2531,  2531,  2531,  2531,  2531,  2531,  2531,  2531,
  2531,  2531,  2531,  2531,  2531,  2531,  2531,  2531,  2531,  2531,
  2531,  2531,  2531,  2531,  2531,  2531,  2531,  2531,  2531,  2531,
  2531,  2531,  2531,  2531,  2531,   610,   457,   457,   457,   860,
   735,   730,   730,   730,  5242,    14,  2366,  1644,   380,   746,
   859,   754,   681,-32768,-32768,  2531,  2531,  2531,  2531,  2531,
  2531,  2531,  2531,  2531,  2531,  2531,  2531,  2531,  2531,  2531,
-32768,   -94,  3725,  1981,  2531,   775,  2366,  5265,  2561,-32768,
  2588,-32768,   702,  2531,   847,  5288,  5311,  2531,  5334,   697,
  2531,   861,  5357,  5380,   900,  5403,  2531,  2531,  2531,   906,
  2531,  2531,  2531,  2496,  2496,  2496,  2496,   795,   -18,-32768,
-32768,  3747,  3769,   -43,   -43,   556,   556,   190,  2531,  2531,
  2531,  2185,  2185,  2531,   267,-32768,  2531,  2836,    85,   908,
-32768,  2531,  2857,   950,   958,  2531,  2531,-32768,  5426,  5449,
   828,  2531,  5472,   877,  3791,-32768,   843,  2603,  5495,-32768,
  2531,  2903,-32768,  2963,-32768,  2531,  1775,   139,  2531,   324,
    -3,  5518,  4517,  5541,  4542,  5564,  4567,  5587,  4592,  5610,
  4617,  5633,  4642,  5656,  4667,  5679,  4692,  5702,  4717,  5725,
  4742,  5748,  4767,  3813,  3835,  5771,  4792,  5794,  4817,  5817,
  4842,  5840,  4867,  5863,  4892,  5886,  4917,  3857,  3879,  3901,
  3923,  3945,  3967,   736,   -28,   845,   851,   857,   853,  2531,
-32768,  1850,  1850,   740,    73,   457,  2531,   979,   985,    16,
   862,-32768,  2618,   545,   650,   705,   705,   666,   666,   666,
   666,   375,   375,   730,   730,   730,   730,    20,  2366,  2531,
-32768,  2366,  4942,  2849,  2118,   743,   987,  2366,-32768,  2633,
  2531,   988,   989,  5909,   997,  2531,  2531,  5932,  2531,  1007,
  1008,  2531,  1009,  2976,  5955,  5978,  2531,  3193,  3217,  6001,
   884,  6369,-32768,   885,   887,   891,   890,   -43,  2531,  2531,
-32768,-32768,-32768,   889,   802,-32768,   893,  2531,  3989,  4011,
  4033,  3697,   -43,  2984,  4967,   -76,   -30,   -42,    32,-32768,
-32768,-32768,  2531,-32768,  4992,-32768,   895,   896,  5017,  5042,
  1021,  1031,   907,  6024,  1033,   905,  2531,  3030,  2531,  2531,
-32768,  6047,-32768,-32768,  5067,    31,-32768,  3241,-32768,-32768,
   910,   913,   909,-32768,   914,   986,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,  2531,  2531,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,  2531,  2531,
  2531,  2531,  2531,  2531,  2531,  1043,-32768,  2366,   457,-32768,
-32768,  2531,  1044,  1045,   918,    86,  2531,  1048,  1055,   825,
-32768,  1042,   940,    13,  1069,-32768,  2531,-32768,   960,   457,
   159,  4055,   749,   496,-32768,-32768,  2366,-32768,   -43,  2588,
-32768,  2531,   856,  1850,  1850,  1070,  1850,   888,   945,  1073,
  1016,  1850,  1850,  1078,   942,  1075,  1076,  1079,   604,  1080,
  1082,  1083,  1085,  1086,  1088,  1089,  1081,   322,  4077,  4099,
-32768,-32768,  3265,   -43,   -43,   -43,   344,-32768,   312,  1091,
  2531,  2366,  2531,  2366,  2366,  2366,  1148,  1092,  2531,  2531,
  1093,  1094,  1850,  1850,  2531,  1095,  1850,  1097,  4121,-32768,
  2648,   581,  1096,  1098,  1101,-32768,  1100,-32768,     7,   975,
  2531,  2531,  1850,   969,  2531,-32768,  6070,  5092,  6093,  5117,
  6116,  5142,  6139,  5167,  5192,   977,   248,   980,  6162,-32768,
-32768,    23,   440,   976,  1107,  1179,-32768,-32768,-32768,    13,
  2531,-32768,   758,-32768,  6369,-32768,  1109,    39,  2531,   981,
   759,     3,  6369,-32768,    64,    82,  1850,  1113,-32768,-32768,
  1850,-32768,  1115,  1116,-32768,  2531,  1850,  1850,  1850,-32768,
   350,  1850,  1850,  1850,  1850,  1850,  1850,  1850,   642,  2531,
  2531,  2531,   984,   187,   228,   391,  2185,  1118,   993,   -27,
-32768,-32768,  6185,   781,  6208,   782,   785,   786,-32768,-32768,
  4143,  4165,-32768,-32768,  1136,  1137,  6231,    68,  1056,-32768,
  2531,  2531,  2531,-32768,  1006,-32768,   139,-32768,  1140,  2531,
  4187,  4209,   789,-32768,  2531,  6254,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,  1012,-32768,-32768,-32768,-32768,  1850,
   457,  2531,  1143,  1146,    16,-32768,  1145,  5217,    13,-32768,
-32768,-32768,   457,  4231,-32768,  1017,-32768,-32768,   -43,-32768,
   -43,  1147,-32768,  1150,-32768,-32768,  4253,  1151,  1152,  1153,
  2531,  2531,   869,  1154,  1155,  1156,  1157,  1158,  1159,-32768,
  2496,  3289,  6277,  2343,   556,   -43,  1162,   -43,  1163,   -43,
  1165,  3313,   416,-32768,  1850,-32768,-32768,   987,  1166,   997,
  1167,  1168,  1169,  2531,  2531,-32768,-32768,  1170,  1850,  1850,
  1090,  1850,  2670,   279,  6300,  2531,-32768,-32768,   447,  6369,
  2531,  2531,  1850,  1037,   793,  6369,  1850,  1175,  1174,  1176,
  1233,-32768,  1180,  1188,-32768,  1071,-32768,  1200,  2531,-32768,
    56,    75,-32768,-32768,  2531,-32768,-32768,-32768,  1422,  1553,
  1204,-32768,-32768,-32768,-32768,-32768,-32768,-32768,  1684,  1205,
  1074,-32768,  2531,-32768,  1041,   419,-32768,  1077,   434,-32768,
  1084,   441,-32768,  1087,  1099,  2531,   403,  1105,-32768,-32768,
-32768,-32768,  4275,  4297,    68,   478,   794,  1114,  1127,  2531,
-32768,  2531,-32768,-32768,  4319,-32768,  2531,  4341,  4363,-32768,
  1850,  2531,  1208,  1211,  1102,-32768,-32768,-32768,    13,-32768,
  1128,-32768,  4385,-32768,-32768,  4407,-32768,-32768,-32768,-32768,
-32768,   556,  3163,-32768,  2185,   312,  2185,   312,  2185,   312,
-32768,  3337,  1213,  1850,  2531,  2531,  1132,-32768,-32768,  1850,
  2531,  3361,  3385,  1850,  1125,  6369,  2531,  2531,   814,  6369,
-32768,-32768,-32768,  1215,-32768,  2531,  1217,  1104,  2531,-32768,
  3409,   452,   -26,  3433,   454,    25,  3457,   456,   122,  3090,
  1135,-32768,   815,  3481,  3505,  1138,  1117,  1946,-32768,-32768,
  1112,  2531,  6323,  4429,  1218,-32768,  4451,  1119,-32768,  3529,
  1219,  2531,  1221,  1222,  2531,  1223,  1225,  2531,  1226,-32768,
   312,-32768,  1850,  1227,  1230,  1231,  1850,  1850,-32768,  1248,
   820,-32768,  2531,-32768,  2531,  1270,-32768,-32768,  1139,  3553,
-32768,-32768,  1141,  3577,-32768,-32768,  1142,  3601,-32768,   130,
  3111,  1144,-32768,-32768,-32768,  1171,  1149,-32768,  1276,  1177,
  6346,  3625,  1203,   312,  1280,   312,  1282,   312,  1289,-32768,
-32768,   312,  1299,  1850,  1191,-32768,   457,-32768,  1300,  1302,
   191,-32768,  1220,   192,-32768,  1224,   193,-32768,  1228,   237,
-32768,  1202,  1236,   823,-32768,  1237,-32768,  1238,  1309,   312,
  1337,   312,  1354,   312,-32768,  1229,  2531,   457,  1355,   457,
  1356,-32768,   278,-32768,   287,-32768,   289,  1240,  4473,-32768,
-32768,   824,-32768,-32768,  1359,  1360,  1371,  2531,  2531,   457,
  1374,-32768,-32768,-32768,  4495,  3649,-32768,-32768,  2531,  1375,
  3673,-32768,  1378,-32768,  1386,  1387,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,   560,-32768,-32768,   839,-32768,   308,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,  -263,     0,-32768,   -24,  1389,     5,  -334,  -172,     8,
-32768,-32768,-32768,-32768,-32768,  1390,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,  -732,  -690,
-32768,-32768,-32768,    -4,-32768,   397,-32768,   404,  -815,   473,
   -98,  -254,  -596,   548,-32768,    -2
};


#define	YYLAST		6500


static const short yytable[] = {   121,
   550,   123,   507,   120,   348,   437,    58,   353,   857,    59,
   550,   190,   434,   176,   179,   207,   192,   124,   212,   623,
   432,   202,   195,   125,   144,   628,     3,   742,   202,    72,
   372,   269,   374,   302,   127,   202,   141,   350,   458,   351,
   788,   788,   466,   459,   852,   789,   789,   139,   204,   206,
    97,    98,    99,   100,   361,   681,   101,    97,    98,    99,
   100,  1014,   682,   101,    97,    98,    99,   100,   140,   858,
   101,   146,   551,   552,   553,   554,   555,   163,   164,    72,
  1015,   147,   551,   552,   553,   554,   555,   860,   165,   733,
   522,   523,   788,   986,   987,   166,   685,   789,   191,   897,
   362,   683,   334,   335,   607,   262,   263,   264,   684,   608,
   265,   268,   896,  1093,   273,   859,   270,   271,   148,   498,
   433,   293,   149,   334,   335,   263,   298,   301,   150,   106,
   107,   108,   109,   861,   306,   307,   556,   309,   629,   113,
   114,   313,   314,   847,   316,   208,   819,   209,   177,   180,
   196,   193,   210,   213,   624,   203,   126,   629,   113,   114,
   332,   333,   205,   147,  1096,   151,   705,   352,   302,   333,
   686,   617,   152,   514,   734,   735,   334,   335,   156,   106,
   107,   108,   109,   359,   360,  1049,   363,   183,   365,   788,
   184,   368,   369,   538,   789,   334,   335,   788,   302,   909,
   113,   114,   789,   377,   631,   161,   910,   633,   616,   382,
   383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
   393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
   403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
   413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
   423,   162,   937,   425,   426,   427,   428,   170,   788,   788,
   788,  1099,   301,   789,   789,   789,   113,   114,   438,  1150,
   178,   443,   444,   445,   446,   447,   448,   449,   450,   451,
   452,   453,   454,   455,   456,   457,   992,   334,   335,   463,
   464,   748,   301,  1063,   263,  1066,   468,  1069,   181,   470,
   494,   495,   496,   474,   788,   336,   478,   334,   335,   789,
   334,   335,   484,   485,   486,   182,   488,   489,   490,   492,
   492,   492,   492,   198,   886,   171,   887,   508,   172,   173,
  1179,  1181,  1183,   185,   509,   510,   511,   262,   263,   512,
   503,   503,   515,   506,   506,   788,   186,   525,   334,   335,
   789,   529,   530,   727,   788,   187,   788,   534,   188,   789,
   302,   789,   214,   302,   215,   888,   542,   889,  1130,   641,
   189,   545,   897,   197,   548,   897,  1185,   547,   897,   788,
   837,   216,   751,   217,   789,   468,   436,   334,   335,   276,
   277,   278,   279,   280,   256,   281,   282,   283,   284,   285,
   286,   287,   288,   289,   513,   163,   164,   871,   872,   290,
   304,  1161,  1054,  1164,   199,  1167,   165,  1205,   993,  1170,
   200,   167,   169,   174,   175,   463,  1206,   794,  1207,   796,
   797,   798,   620,   619,   618,   334,   335,   201,   257,   897,
   334,   335,   334,   335,   334,   335,   841,  1193,   218,  1195,
   219,  1197,   258,   337,   301,   632,   259,   301,   346,   780,
   463,   202,   549,   640,   334,   335,   643,   260,   840,   842,
   897,   648,   649,   897,   651,   272,   897,   654,   292,   897,
   137,   787,   659,   143,   145,   274,   106,   107,   108,   109,
    97,    98,    99,   100,   669,   670,   101,   287,   288,   289,
   295,   305,   897,   673,   897,   290,   897,   113,   114,   302,
   291,   334,   335,   276,   277,   278,   279,   280,   687,   281,
   282,   283,   284,   285,   286,   287,   288,   289,   890,   220,
   891,   221,   699,   290,   701,   702,   334,   335,   302,   334,
   335,   310,  1033,   707,   308,   706,   106,   107,   108,   109,
   965,   113,   114,   976,   334,   335,  1025,   294,   329,   209,
   331,   334,   335,   222,   210,   223,   338,   113,   114,   311,
   345,  1027,   334,   335,   334,   335,   334,   335,  1029,   996,
   717,   718,   312,   302,   997,   302,   302,   302,   813,  1092,
   224,  1095,   225,  1098,   719,   720,   721,   722,   723,   724,
   725,   153,   154,   301,   155,   317,   728,   729,   380,   770,
  1038,   328,   736,   424,   202,   923,    24,    25,    26,    27,
   315,    29,   745,   113,   114,   320,   226,   747,   227,    35,
    36,   705,   301,   706,   228,   157,   229,   753,   158,   159,
   275,   160,   318,    97,    98,    99,   100,   880,   881,   101,
   349,   230,   232,   231,   233,   354,   355,   278,   279,   280,
   771,   281,   282,   283,   284,   285,   286,   287,   288,   289,
   234,   236,   235,   237,   319,   290,   793,   301,   795,   301,
   301,   301,   321,   323,   801,   802,   442,  1058,   322,   339,
   807,   276,   277,   278,   279,   280,   324,   281,   282,   283,
   284,   285,   286,   287,   288,   289,   821,   822,   325,   326,
   826,   290,   340,   814,   276,   277,   278,   279,   280,   327,
   281,   282,   283,   284,   285,   286,   287,   288,   289,   341,
   501,   502,   843,   238,   290,   239,   848,   358,   240,   331,
   241,   476,   347,   477,   854,   276,   277,   278,   279,   280,
   356,   281,   282,   283,   284,   285,   286,   287,   288,   289,
   242,   867,   243,   279,   280,   290,   281,   282,   283,   284,
   285,   286,   287,   288,   289,   882,   883,   884,   357,   244,
   290,   245,   892,   246,   364,   247,   285,   286,   287,   288,
   289,   276,   277,   278,   279,   280,   290,   281,   282,   283,
   284,   285,   286,   287,   288,   289,   913,   914,   915,   366,
   248,   290,   249,   367,   370,   920,   917,   250,   371,   251,
   926,   281,   282,   283,   284,   285,   286,   287,   288,   289,
   739,   252,   254,   253,   255,   290,   373,   931,   930,   468,
   375,   469,   516,     9,    10,   517,   518,    13,   519,    15,
   938,    16,   376,    18,    19,   378,    21,    22,  1070,   379,
   290,   754,   113,   114,   429,   440,   949,   950,   430,   605,
   209,   606,   951,    34,   952,   210,   959,   468,   960,   615,
   468,   439,   638,    38,    39,    40,   468,   441,   750,   503,
   977,   471,   506,   759,   668,   849,   468,   850,   856,   983,
   984,    50,   113,   114,   613,   614,   482,   479,   465,   677,
   209,   995,   487,   524,   533,   210,   998,   999,   468,   468,
   899,   901,   468,   468,   902,   903,   923,   497,   924,  1131,
  1002,   923,  1003,  1039,  1013,   276,   277,   278,   279,   280,
  1016,   281,   282,   283,   284,   285,   286,   287,   288,   289,
   760,   923,  1103,  1085,  1104,   290,   527,  1002,  1023,  1139,
  1188,  1210,  1189,  1211,   528,   536,   276,   277,   278,   279,
   280,  1032,   281,   282,   283,   284,   285,   286,   287,   288,
   289,   539,   609,   610,   621,  1042,   290,  1043,   622,   611,
   612,   716,  1046,   639,   644,   645,   626,  1050,   276,   277,
   278,   279,   280,   647,   281,   282,   283,   284,   285,   286,
   287,   288,   289,   652,   653,   655,   663,   664,   290,   665,
  1061,   762,  1064,   666,  1067,   667,   503,   693,   671,   506,
  1074,  1075,   672,   689,   690,   752,  1078,   694,   695,   697,
   698,   711,  1083,  1084,   712,   715,   726,   713,   740,   730,
   731,  1087,   732,   737,  1090,   276,   277,   278,   279,   280,
   738,   281,   282,   283,   284,   285,   286,   287,   288,   289,
   784,   785,   786,   741,   744,   290,   757,   926,   746,   761,
   766,   767,   768,   765,   779,   769,   772,  1120,   773,   774,
  1124,   775,   776,  1128,   777,   778,   792,   800,   803,   804,
   810,   808,   815,   816,   817,   818,   820,   825,  1141,   836,
  1142,   844,   838,   845,   851,   855,   755,   756,   863,   758,
   865,   866,   885,   894,   763,   764,   276,   277,   278,   279,
   280,   895,   281,   282,   283,   284,   285,   286,   287,   288,
   289,   906,   907,   912,   916,   918,   290,   928,   932,   933,
   935,   940,   943,   799,  1175,   944,   946,   947,   948,   953,
   954,   955,   956,   957,   958,   805,   806,   967,   970,   809,
   973,   979,   980,   981,   982,  1001,   985,   988,  1005,  1006,
  1024,  1007,  1199,   893,   846,  1200,  1009,  1203,   276,   277,
   278,   279,   280,  1010,   281,   282,   283,   284,   285,   286,
   287,   288,   289,  1215,  1216,  1012,  1011,  1217,   290,  1019,
  1021,  1041,  1022,  1051,  1221,  1026,  1052,  1055,  1072,  1076,
  1086,  1088,  1028,  1114,  1118,  1030,  1121,  1122,  1125,   862,
  1126,  1129,  1133,   864,  1053,  1134,  1135,  1031,  1008,   868,
   869,   870,  1034,  1089,   873,   874,   875,   876,   877,   878,
   879,  1110,  1040,  1138,  1108,   941,  1116,   942,   276,   277,
   278,   279,   280,  1082,   281,   282,   283,   284,   285,   286,
   287,   288,   289,  1102,  1143,  1173,  1107,  1144,   290,  1146,
  1148,  1156,   966,  1153,   969,  1162,   972,  1165,  1155,   276,
   277,   278,   279,   280,  1168,   281,   282,   283,   284,   285,
   286,   287,   288,   289,  1171,  1177,  1178,   853,  1154,   290,
    69,   128,   929,  1198,  1192,  1157,    73,    74,    75,    76,
    77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
    87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
  1160,  1186,  1194,   276,   277,   278,   279,   280,   129,   281,
   282,   283,   284,   285,   286,   287,   288,   289,  1180,  1196,
  1201,  1204,  1182,   290,  1212,  1213,  1184,   978,    24,    25,
    26,    27,    28,    29,  1187,  1190,  1214,  1191,  1208,  1218,
  1222,    35,    36,  1224,   989,  1226,  1227,   709,  1037,  1111,
    57,    65,   934,     0,     0,  1000,     0,     0,     0,  1004,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   102,   103,   104,   105,     0,     0,     0,     0,     0,     0,
     0,  1062,     0,  1065,     0,  1068,     0,  1017,   110,   299,
     0,     0,     0,     0,   112,     0,     0,     0,     0,   115,
     0,     0,     0,     0,   118,     0,     0,   300,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    69,
   128,     0,     0,     0,     0,    73,    74,    75,    76,    77,
    78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
    88,    89,    90,    91,    92,    93,    94,    95,    96,     0,
     0,     0,     0,     0,     0,     0,     0,   129,     0,     0,
     0,     0,     0,     0,     0,     0,  1073,     0,     0,     0,
     0,     0,  1077,     0,     0,     0,  1081,    24,    25,    26,
    27,    28,    29,   141,     0,     0,     0,     0,     0,     0,
    35,    36,   276,   277,   278,   279,   280,     0,   281,   282,
   283,   284,   285,   286,   287,   288,   289,     0,     0,     0,
     0,     0,   290,     0,     0,     0,     0,     0,  1018,   102,
   103,   104,   105,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,  1132,     0,   110,   130,  1136,
  1137,     0,     0,   112,     0,     0,     0,     0,   142,     0,
    69,   128,     0,   118,     0,   132,    73,    74,    75,    76,
    77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
    87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
     0,     0,     0,     0,     0,     0,  1172,     0,   129,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    24,    25,
    26,    27,    28,    29,   144,     0,     0,     0,     0,     0,
     0,    35,    36,   276,   277,   278,   279,   280,     0,   281,
   282,   283,   284,   285,   286,   287,   288,   289,     0,     0,
     0,     0,     0,   290,     0,     0,     0,     0,     0,  1020,
   102,   103,   104,   105,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   110,   130,
     0,     0,     0,     0,   112,     0,     0,     0,     0,   115,
     0,    69,   128,     0,   118,     0,   132,    73,    74,    75,
    76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
    86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
    96,     0,     0,     0,   276,   277,   278,   279,   280,   129,
   281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     0,     0,     0,     0,   290,     0,     0,     0,   435,    24,
    25,    26,    27,    28,    29,     0,     0,     0,     0,     0,
     0,     0,    35,    36,   276,   277,   278,   279,   280,     0,
   281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     0,     0,     0,     0,   290,     0,     0,     0,     0,     0,
     0,   102,   103,   104,   105,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   110,
   130,     0,     0,     0,     0,   112,     0,     0,     0,     0,
   131,     0,    69,   128,     0,   118,     0,   132,    73,    74,
    75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
    85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
    95,    96,     0,     0,     0,   276,   277,   278,   279,   280,
   129,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     0,     0,     0,     0,     0,   290,     0,     0,     0,   546,
    24,    25,    26,    27,    28,    29,     0,     0,     0,    69,
   261,     0,     0,    35,    36,    73,    74,    75,    76,    77,
    78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
    88,    89,    90,    91,    92,    93,    94,    95,    96,     0,
     0,  1109,   102,   103,   104,   105,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   110,   130,     0,     0,     0,     0,   112,     0,     0,     0,
     0,   115,     0,    69,   261,     0,   118,     0,   132,    73,
    74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
    84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
    94,    95,    96,     0,     0,     0,     0,     0,     0,   102,
   103,   104,   105,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   110,   111,     0,
     0,     0,     0,   112,     0,     0,     0,     0,   115,     0,
     0,   266,     0,   118,     0,   267,   276,   277,   278,   279,
   280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
   289,     0,     0,     0,     0,     0,   290,     0,     0,     0,
     0,     0,     0,   102,   103,   104,   105,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   110,   111,     0,     0,     0,     0,   112,     0,     0,
     0,     0,   115,     0,     0,   461,     0,   118,     0,   462,
    69,   261,     0,     0,     0,     0,    73,    74,    75,    76,
    77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
    87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
     0,     0,     0,     0,     0,     0,     0,    69,   296,     0,
     0,     0,     0,    73,    74,    75,    76,    77,    78,    79,
    80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
    90,    91,    92,    93,    94,    95,    96,    69,   261,     0,
     0,     0,     0,    73,    74,    75,    76,    77,    78,    79,
    80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
    90,    91,    92,    93,    94,    95,    96,     0,     0,     0,
   102,   103,   104,   105,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   110,   111,
     0,     0,     0,     0,   112,     0,     0,     0,     0,   115,
     0,     0,   636,     0,   118,     0,   637,   102,   103,   104,
   105,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   110,   111,     0,     0,     0,
     0,   112,     0,     0,     0,     0,   115,   102,   103,   104,
   105,   118,     0,   297,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   342,   343,     0,     0,     0,
     0,   112,     0,     0,     0,     0,   344,     0,    69,    70,
    71,   118,    72,   166,    73,    74,    75,    76,    77,    78,
    79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
    89,    90,    91,    92,    93,    94,    95,    96,     0,    97,
    98,    99,   100,     0,     0,   101,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    69,   128,
     0,     0,     0,     0,    73,    74,    75,    76,    77,    78,
    79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
    89,    90,    91,    92,    93,    94,    95,    96,     0,     0,
     0,     0,     0,     0,     0,     0,   129,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   102,   103,
   104,   105,   106,   107,   108,   109,    24,    25,    26,    27,
    28,    29,     0,     0,     0,     0,   110,   111,     0,    35,
    36,     0,   112,   113,   114,     0,     0,   115,     0,   116,
     0,   117,   118,   276,   277,   278,   279,   280,     0,   281,
   282,   283,   284,   285,   286,   287,   288,   289,   102,   103,
   104,   105,     0,   290,     0,     0,     0,     0,     0,     0,
   963,     0,   964,     0,     0,     0,   110,   299,     0,     0,
     0,     0,   112,     0,     0,     0,     0,   115,    69,   261,
   202,     0,   118,     0,    73,    74,    75,    76,    77,    78,
    79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
    89,    90,    91,    92,    93,    94,    95,    96,     0,    97,
    98,    99,   100,    69,   261,   101,     0,     0,     0,    73,
    74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
    84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
    94,    95,    96,    69,   296,     0,     0,     0,     0,    73,
    74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
    84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
    94,    95,    96,     0,     0,   304,     0,     0,   102,   103,
   104,   105,     0,     0,     0,     0,     0,     0,     0,     0,
   540,     0,     0,     0,     0,     0,   110,   111,     0,     0,
     0,     0,   112,     0,     0,   627,     0,   115,     0,     0,
     0,     0,   118,   102,   103,   104,   105,     0,     0,     0,
   642,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   110,   111,     0,     0,   812,     0,   112,     0,     0,
     0,     0,   115,   102,   103,   104,   105,   118,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   110,   111,     0,     0,     0,     0,   112,     0,     0,
     0,     0,   115,     0,     0,     0,     0,   118,   276,   277,
   278,   279,   280,     0,   281,   282,   283,   284,   285,   286,
   287,   288,   289,   276,   277,   278,   279,   280,   290,   281,
   282,   283,   284,   285,   286,   287,   288,   289,   276,   277,
   278,   279,   280,   290,   281,   282,   283,   284,   285,   286,
   287,   288,   289,   276,   277,   278,   279,   280,   290,   281,
   282,   283,   284,   285,   286,   287,   288,   289,   276,   277,
   278,   279,   280,   290,   281,   282,   283,   284,   285,   286,
   287,   288,   289,    -3,     1,     0,     0,    -3,   290,     0,
   276,   277,   278,   279,   280,     0,   281,   282,   283,   284,
   285,   286,   287,   288,   289,     0,     0,     0,     0,     0,
   290,     0,     0,     0,     0,     0,    -3,   990,     0,   991,
     0,    -3,    -3,     0,    -3,    -3,    -3,    -3,    -3,    -3,
    -3,    -3,     0,    -3,    -3,    -3,    -3,    -3,    -3,    -3,
     0,     0,     0,    -3,    -3,    -3,    -3,    -3,    -3,    -3,
     0,    -3,    -3,    -3,    -3,    -3,     0,    -3,    -3,     0,
     0,     0,     0,     0,    -3,    -3,    -3,    -3,     0,     0,
     0,     0,    -3,     0,    -3,     0,    -3,    -3,    -3,    -3,
    -3,    -3,    -3,    -3,    -3,    -3,   516,     9,    10,   517,
   518,    13,   519,    15,     0,    16,     0,    18,    19,     0,
    21,    22,     0,     0,     0,     0,     0,   516,     9,    10,
   517,   518,    13,   519,    15,     0,    16,    34,    18,    19,
     0,    21,    22,     0,     0,     0,     0,    38,    39,    40,
     0,     0,     0,     0,     0,     0,     0,     0,    34,     0,
     0,     0,     0,     0,     0,    50,     0,     0,    38,    39,
    40,     0,     0,   516,     9,    10,   517,   518,    13,   519,
    15,     0,    16,     0,    18,    19,    50,    21,    22,   276,
   277,   278,   279,   280,     0,   281,   282,   283,   284,   285,
   286,   287,   288,   289,    34,   520,     0,     0,     0,   290,
     0,     0,     0,     0,    38,    39,    40,     0,   635,     0,
     0,     0,     0,     0,     0,     0,   526,     0,     0,     0,
     0,     0,    50,   516,     9,    10,   517,   518,    13,   519,
    15,     0,    16,     0,    18,    19,     0,    21,    22,     0,
     0,     0,     0,     0,   516,     9,    10,   517,   518,    13,
   519,    15,     0,    16,    34,    18,    19,     0,    21,    22,
     0,     0,   543,     0,    38,    39,    40,     0,     0,     0,
     0,     0,     0,     0,     0,    34,     0,     0,     0,     0,
     0,     0,    50,     0,     0,    38,    39,    40,     0,     0,
   516,     9,    10,   517,   518,    13,   519,    15,     0,    16,
     0,    18,    19,    50,    21,    22,   276,   277,   278,   279,
   280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
   289,    34,   544,     0,     0,     0,   290,     0,     0,     0,
     0,    38,    39,    40,     0,   656,     0,     0,     0,     0,
     0,     0,     0,   678,     0,     0,     0,     0,     0,    50,
   516,     9,    10,   517,   518,    13,   519,    15,     0,    16,
     0,    18,    19,     0,    21,    22,     0,     0,     0,     0,
     0,   516,     9,    10,   517,   518,    13,   519,    15,     0,
    16,    34,    18,    19,     0,    21,    22,     0,     0,   700,
     0,    38,    39,    40,     4,     0,     0,     0,     0,     0,
     0,     0,    34,     0,     0,     0,     0,     0,     0,    50,
     0,     0,    38,    39,    40,     0,     0,     0,     0,     0,
     0,     0,     0,     5,     0,     0,     0,     0,     6,     7,
    50,     8,     9,    10,    11,    12,    13,    14,    15,     0,
    16,    17,    18,    19,    20,    21,    22,     0,     0,  1100,
    23,    24,    25,    26,    27,    28,    29,     0,    30,    31,
    32,    33,    34,     0,    35,    36,     0,     0,     0,     0,
  1151,    37,    38,    39,    40,     0,     0,     0,     0,    41,
     0,    42,     0,    43,    44,    45,    46,    47,    48,    49,
    50,    51,    52,   276,   277,   278,   279,   280,     0,   281,
   282,   283,   284,   285,   286,   287,   288,   289,     0,     0,
     0,     0,     0,   290,     0,     0,     0,     0,     0,     0,
  1059,     0,  1060,   276,   277,   278,   279,   280,     0,   281,
   282,   283,   284,   285,   286,   287,   288,   289,     0,     0,
     0,     0,     0,   290,     0,     0,     0,   276,   277,   278,
   279,   280,   660,   281,   282,   283,   284,   285,   286,   287,
   288,   289,     0,     0,     0,     0,     0,   290,     0,     0,
     0,   276,   277,   278,   279,   280,   661,   281,   282,   283,
   284,   285,   286,   287,   288,   289,     0,     0,     0,     0,
     0,   290,     0,     0,     0,   276,   277,   278,   279,   280,
   708,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     0,     0,     0,     0,     0,   290,     0,     0,     0,   276,
   277,   278,   279,   280,   783,   281,   282,   283,   284,   285,
   286,   287,   288,   289,     0,     0,     0,     0,     0,   290,
     0,     0,     0,   276,   277,   278,   279,   280,   961,   281,
   282,   283,   284,   285,   286,   287,   288,   289,     0,     0,
     0,     0,     0,   290,     0,     0,     0,   276,   277,   278,
   279,   280,   975,   281,   282,   283,   284,   285,   286,   287,
   288,   289,     0,     0,     0,     0,     0,   290,     0,     0,
     0,   276,   277,   278,   279,   280,  1071,   281,   282,   283,
   284,   285,   286,   287,   288,   289,     0,     0,     0,     0,
     0,   290,     0,     0,     0,   276,   277,   278,   279,   280,
  1079,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     0,     0,     0,     0,     0,   290,     0,     0,     0,   276,
   277,   278,   279,   280,  1080,   281,   282,   283,   284,   285,
   286,   287,   288,   289,     0,     0,     0,     0,     0,   290,
     0,     0,     0,   276,   277,   278,   279,   280,  1091,   281,
   282,   283,   284,   285,   286,   287,   288,   289,     0,     0,
     0,     0,     0,   290,     0,     0,     0,   276,   277,   278,
   279,   280,  1094,   281,   282,   283,   284,   285,   286,   287,
   288,   289,     0,     0,     0,     0,     0,   290,     0,     0,
     0,   276,   277,   278,   279,   280,  1097,   281,   282,   283,
   284,   285,   286,   287,   288,   289,     0,     0,     0,     0,
     0,   290,     0,     0,     0,   276,   277,   278,   279,   280,
  1105,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     0,     0,     0,     0,     0,   290,     0,     0,     0,   276,
   277,   278,   279,   280,  1106,   281,   282,   283,   284,   285,
   286,   287,   288,   289,     0,     0,     0,     0,     0,   290,
     0,     0,     0,   276,   277,   278,   279,   280,  1117,   281,
   282,   283,   284,   285,   286,   287,   288,   289,     0,     0,
     0,     0,     0,   290,     0,     0,     0,   276,   277,   278,
   279,   280,  1145,   281,   282,   283,   284,   285,   286,   287,
   288,   289,     0,     0,     0,     0,     0,   290,     0,     0,
     0,   276,   277,   278,   279,   280,  1147,   281,   282,   283,
   284,   285,   286,   287,   288,   289,     0,     0,     0,     0,
     0,   290,     0,     0,     0,   276,   277,   278,   279,   280,
  1149,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     0,     0,     0,     0,     0,   290,     0,     0,     0,   276,
   277,   278,   279,   280,  1159,   281,   282,   283,   284,   285,
   286,   287,   288,   289,     0,     0,     0,     0,     0,   290,
     0,     0,     0,   276,   277,   278,   279,   280,  1220,   281,
   282,   283,   284,   285,   286,   287,   288,   289,     0,     0,
     0,     0,     0,   290,     0,     0,     0,   276,   277,   278,
   279,   280,  1223,   281,   282,   283,   284,   285,   286,   287,
   288,   289,     0,     0,     0,     0,     0,   290,     0,   431,
     0,     0,     0,     0,   499,   276,   277,   278,   279,   280,
     0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     0,     0,     0,     0,     0,   290,     0,   276,   277,   278,
   279,   280,   460,   281,   282,   283,   284,   285,   286,   287,
   288,   289,     0,     0,     0,     0,     0,   290,     0,   276,
   277,   278,   279,   280,   499,   281,   282,   283,   284,   285,
   286,   287,   288,   289,     0,     0,     0,     0,     0,   290,
     0,   276,   277,   278,   279,   280,   500,   281,   282,   283,
   284,   285,   286,   287,   288,   289,     0,     0,     0,     0,
     0,   290,     0,   276,   277,   278,   279,   280,   537,   281,
   282,   283,   284,   285,   286,   287,   288,   289,     0,     0,
     0,     0,     0,   290,     0,   276,   277,   278,   279,   280,
   585,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     0,     0,     0,     0,     0,   290,     0,   276,   277,   278,
   279,   280,   586,   281,   282,   283,   284,   285,   286,   287,
   288,   289,     0,     0,     0,     0,     0,   290,     0,   276,
   277,   278,   279,   280,   599,   281,   282,   283,   284,   285,
   286,   287,   288,   289,     0,     0,     0,     0,     0,   290,
     0,   276,   277,   278,   279,   280,   600,   281,   282,   283,
   284,   285,   286,   287,   288,   289,     0,     0,     0,     0,
     0,   290,     0,   276,   277,   278,   279,   280,   601,   281,
   282,   283,   284,   285,   286,   287,   288,   289,     0,     0,
     0,     0,     0,   290,     0,   276,   277,   278,   279,   280,
   602,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     0,     0,     0,     0,     0,   290,     0,   276,   277,   278,
   279,   280,   603,   281,   282,   283,   284,   285,   286,   287,
   288,   289,     0,     0,     0,     0,     0,   290,     0,   276,
   277,   278,   279,   280,   604,   281,   282,   283,   284,   285,
   286,   287,   288,   289,     0,     0,     0,     0,     0,   290,
     0,   276,   277,   278,   279,   280,   674,   281,   282,   283,
   284,   285,   286,   287,   288,   289,     0,     0,     0,     0,
     0,   290,     0,   276,   277,   278,   279,   280,   675,   281,
   282,   283,   284,   285,   286,   287,   288,   289,     0,     0,
     0,     0,     0,   290,     0,   276,   277,   278,   279,   280,
   676,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     0,     0,     0,     0,     0,   290,     0,   276,   277,   278,
   279,   280,   749,   281,   282,   283,   284,   285,   286,   287,
   288,   289,     0,     0,     0,     0,     0,   290,     0,   276,
   277,   278,   279,   280,   781,   281,   282,   283,   284,   285,
   286,   287,   288,   289,     0,     0,     0,     0,     0,   290,
     0,   276,   277,   278,   279,   280,   782,   281,   282,   283,
   284,   285,   286,   287,   288,   289,     0,     0,     0,     0,
     0,   290,     0,   276,   277,   278,   279,   280,   811,   281,
   282,   283,   284,   285,   286,   287,   288,   289,     0,     0,
     0,     0,     0,   290,     0,   276,   277,   278,   279,   280,
   904,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     0,     0,     0,     0,     0,   290,     0,   276,   277,   278,
   279,   280,   905,   281,   282,   283,   284,   285,   286,   287,
   288,   289,     0,     0,     0,     0,     0,   290,     0,   276,
   277,   278,   279,   280,   921,   281,   282,   283,   284,   285,
   286,   287,   288,   289,     0,     0,     0,     0,     0,   290,
     0,   276,   277,   278,   279,   280,   922,   281,   282,   283,
   284,   285,   286,   287,   288,   289,     0,     0,     0,     0,
     0,   290,     0,   276,   277,   278,   279,   280,   939,   281,
   282,   283,   284,   285,   286,   287,   288,   289,     0,     0,
     0,     0,     0,   290,     0,   276,   277,   278,   279,   280,
   945,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     0,     0,     0,     0,     0,   290,     0,   276,   277,   278,
   279,   280,  1035,   281,   282,   283,   284,   285,   286,   287,
   288,   289,     0,     0,     0,     0,     0,   290,     0,   276,
   277,   278,   279,   280,  1036,   281,   282,   283,   284,   285,
   286,   287,   288,   289,     0,     0,     0,     0,     0,   290,
     0,   276,   277,   278,   279,   280,  1044,   281,   282,   283,
   284,   285,   286,   287,   288,   289,     0,     0,     0,     0,
     0,   290,     0,   276,   277,   278,   279,   280,  1047,   281,
   282,   283,   284,   285,   286,   287,   288,   289,     0,     0,
     0,     0,     0,   290,     0,   276,   277,   278,   279,   280,
  1048,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     0,     0,     0,     0,     0,   290,     0,   276,   277,   278,
   279,   280,  1056,   281,   282,   283,   284,   285,   286,   287,
   288,   289,     0,     0,     0,     0,     0,   290,     0,   276,
   277,   278,   279,   280,  1057,   281,   282,   283,   284,   285,
   286,   287,   288,   289,     0,     0,     0,     0,     0,   290,
     0,   276,   277,   278,   279,   280,  1113,   281,   282,   283,
   284,   285,   286,   287,   288,   289,     0,     0,     0,     0,
     0,   290,     0,   276,   277,   278,   279,   280,  1115,   281,
   282,   283,   284,   285,   286,   287,   288,   289,     0,     0,
     0,     0,     0,   290,     0,   276,   277,   278,   279,   280,
  1209,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     0,     0,     0,     0,     0,   290,     0,   276,   277,   278,
   279,   280,  1219,   281,   282,   283,   284,   285,   286,   287,
   288,   289,     0,     0,     0,     0,     0,   290,     0,     0,
     0,   564,   276,   277,   278,   279,   280,     0,   281,   282,
   283,   284,   285,   286,   287,   288,   289,     0,     0,     0,
     0,     0,   290,     0,     0,     0,   566,   276,   277,   278,
   279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
   288,   289,     0,     0,     0,     0,     0,   290,     0,     0,
     0,   568,   276,   277,   278,   279,   280,     0,   281,   282,
   283,   284,   285,   286,   287,   288,   289,     0,     0,     0,
     0,     0,   290,     0,     0,     0,   570,   276,   277,   278,
   279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
   288,   289,     0,     0,     0,     0,     0,   290,     0,     0,
     0,   572,   276,   277,   278,   279,   280,     0,   281,   282,
   283,   284,   285,   286,   287,   288,   289,     0,     0,     0,
     0,     0,   290,     0,     0,     0,   574,   276,   277,   278,
   279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
   288,   289,     0,     0,     0,     0,     0,   290,     0,     0,
     0,   576,   276,   277,   278,   279,   280,     0,   281,   282,
   283,   284,   285,   286,   287,   288,   289,     0,     0,     0,
     0,     0,   290,     0,     0,     0,   578,   276,   277,   278,
   279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
   288,   289,     0,     0,     0,     0,     0,   290,     0,     0,
     0,   580,   276,   277,   278,   279,   280,     0,   281,   282,
   283,   284,   285,   286,   287,   288,   289,     0,     0,     0,
     0,     0,   290,     0,     0,     0,   582,   276,   277,   278,
   279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
   288,   289,     0,     0,     0,     0,     0,   290,     0,     0,
     0,   584,   276,   277,   278,   279,   280,     0,   281,   282,
   283,   284,   285,   286,   287,   288,   289,     0,     0,     0,
     0,     0,   290,     0,     0,     0,   588,   276,   277,   278,
   279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
   288,   289,     0,     0,     0,     0,     0,   290,     0,     0,
     0,   590,   276,   277,   278,   279,   280,     0,   281,   282,
   283,   284,   285,   286,   287,   288,   289,     0,     0,     0,
     0,     0,   290,     0,     0,     0,   592,   276,   277,   278,
   279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
   288,   289,     0,     0,     0,     0,     0,   290,     0,     0,
     0,   594,   276,   277,   278,   279,   280,     0,   281,   282,
   283,   284,   285,   286,   287,   288,   289,     0,     0,     0,
     0,     0,   290,     0,     0,     0,   596,   276,   277,   278,
   279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
   288,   289,     0,     0,     0,     0,     0,   290,     0,     0,
     0,   598,   276,   277,   278,   279,   280,     0,   281,   282,
   283,   284,   285,   286,   287,   288,   289,     0,     0,     0,
     0,     0,   290,     0,     0,     0,   634,   276,   277,   278,
   279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
   288,   289,     0,     0,     0,     0,     0,   290,     0,     0,
     0,   680,   276,   277,   278,   279,   280,     0,   281,   282,
   283,   284,   285,   286,   287,   288,   289,     0,     0,     0,
     0,     0,   290,     0,     0,     0,   688,   276,   277,   278,
   279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
   288,   289,     0,     0,     0,     0,     0,   290,     0,     0,
     0,   691,   276,   277,   278,   279,   280,     0,   281,   282,
   283,   284,   285,   286,   287,   288,   289,     0,     0,     0,
     0,     0,   290,     0,     0,     0,   692,   276,   277,   278,
   279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
   288,   289,     0,     0,     0,     0,     0,   290,     0,     0,
     0,   704,   276,   277,   278,   279,   280,     0,   281,   282,
   283,   284,   285,   286,   287,   288,   289,     0,     0,     0,
     0,     0,   290,     0,     0,     0,   828,   276,   277,   278,
   279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
   288,   289,     0,     0,     0,     0,     0,   290,     0,     0,
     0,   830,   276,   277,   278,   279,   280,     0,   281,   282,
   283,   284,   285,   286,   287,   288,   289,     0,     0,     0,
     0,     0,   290,     0,     0,     0,   832,   276,   277,   278,
   279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
   288,   289,     0,     0,     0,     0,     0,   290,     0,     0,
     0,   834,   276,   277,   278,   279,   280,     0,   281,   282,
   283,   284,   285,   286,   287,   288,   289,     0,     0,     0,
     0,     0,   290,     0,     0,     0,   835,   276,   277,   278,
   279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
   288,   289,     0,     0,     0,     0,     0,   290,     0,     0,
     0,   936,   276,   277,   278,   279,   280,     0,   281,   282,
   283,   284,   285,   286,   287,   288,   289,     0,     0,     0,
     0,     0,   290,     0,   431,   276,   277,   278,   279,   280,
     0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     0,     0,     0,     0,     0,   290,     0,   467,   276,   277,
   278,   279,   280,     0,   281,   282,   283,   284,   285,   286,
   287,   288,   289,     0,     0,     0,     0,     0,   290,     0,
   472,   276,   277,   278,   279,   280,     0,   281,   282,   283,
   284,   285,   286,   287,   288,   289,     0,     0,     0,     0,
     0,   290,     0,   473,   276,   277,   278,   279,   280,     0,
   281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     0,     0,     0,     0,   290,     0,   475,   276,   277,   278,
   279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
   288,   289,     0,     0,     0,     0,     0,   290,     0,   480,
   276,   277,   278,   279,   280,     0,   281,   282,   283,   284,
   285,   286,   287,   288,   289,     0,     0,     0,     0,     0,
   290,     0,   481,   276,   277,   278,   279,   280,     0,   281,
   282,   283,   284,   285,   286,   287,   288,   289,     0,     0,
     0,     0,     0,   290,     0,   483,   276,   277,   278,   279,
   280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
   289,     0,     0,     0,     0,     0,   290,     0,   531,   276,
   277,   278,   279,   280,     0,   281,   282,   283,   284,   285,
   286,   287,   288,   289,     0,     0,     0,     0,     0,   290,
     0,   532,   276,   277,   278,   279,   280,     0,   281,   282,
   283,   284,   285,   286,   287,   288,   289,     0,     0,     0,
     0,     0,   290,     0,   535,   276,   277,   278,   279,   280,
     0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     0,     0,     0,     0,     0,   290,     0,   541,   276,   277,
   278,   279,   280,     0,   281,   282,   283,   284,   285,   286,
   287,   288,   289,     0,     0,     0,     0,     0,   290,     0,
   563,   276,   277,   278,   279,   280,     0,   281,   282,   283,
   284,   285,   286,   287,   288,   289,     0,     0,     0,     0,
     0,   290,     0,   565,   276,   277,   278,   279,   280,     0,
   281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     0,     0,     0,     0,   290,     0,   567,   276,   277,   278,
   279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
   288,   289,     0,     0,     0,     0,     0,   290,     0,   569,
   276,   277,   278,   279,   280,     0,   281,   282,   283,   284,
   285,   286,   287,   288,   289,     0,     0,     0,     0,     0,
   290,     0,   571,   276,   277,   278,   279,   280,     0,   281,
   282,   283,   284,   285,   286,   287,   288,   289,     0,     0,
     0,     0,     0,   290,     0,   573,   276,   277,   278,   279,
   280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
   289,     0,     0,     0,     0,     0,   290,     0,   575,   276,
   277,   278,   279,   280,     0,   281,   282,   283,   284,   285,
   286,   287,   288,   289,     0,     0,     0,     0,     0,   290,
     0,   577,   276,   277,   278,   279,   280,     0,   281,   282,
   283,   284,   285,   286,   287,   288,   289,     0,     0,     0,
     0,     0,   290,     0,   579,   276,   277,   278,   279,   280,
     0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     0,     0,     0,     0,     0,   290,     0,   581,   276,   277,
   278,   279,   280,     0,   281,   282,   283,   284,   285,   286,
   287,   288,   289,     0,     0,     0,     0,     0,   290,     0,
   583,   276,   277,   278,   279,   280,     0,   281,   282,   283,
   284,   285,   286,   287,   288,   289,     0,     0,     0,     0,
     0,   290,     0,   587,   276,   277,   278,   279,   280,     0,
   281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     0,     0,     0,     0,   290,     0,   589,   276,   277,   278,
   279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
   288,   289,     0,     0,     0,     0,     0,   290,     0,   591,
   276,   277,   278,   279,   280,     0,   281,   282,   283,   284,
   285,   286,   287,   288,   289,     0,     0,     0,     0,     0,
   290,     0,   593,   276,   277,   278,   279,   280,     0,   281,
   282,   283,   284,   285,   286,   287,   288,   289,     0,     0,
     0,     0,     0,   290,     0,   595,   276,   277,   278,   279,
   280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
   289,     0,     0,     0,     0,     0,   290,     0,   597,   276,
   277,   278,   279,   280,     0,   281,   282,   283,   284,   285,
   286,   287,   288,   289,     0,     0,     0,     0,     0,   290,
     0,   646,   276,   277,   278,   279,   280,     0,   281,   282,
   283,   284,   285,   286,   287,   288,   289,     0,     0,     0,
     0,     0,   290,     0,   650,   276,   277,   278,   279,   280,
     0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     0,     0,     0,     0,     0,   290,     0,   657,   276,   277,
   278,   279,   280,     0,   281,   282,   283,   284,   285,   286,
   287,   288,   289,     0,     0,     0,     0,     0,   290,     0,
   658,   276,   277,   278,   279,   280,     0,   281,   282,   283,
   284,   285,   286,   287,   288,   289,     0,     0,     0,     0,
     0,   290,     0,   662,   276,   277,   278,   279,   280,     0,
   281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     0,     0,     0,     0,   290,     0,   696,   276,   277,   278,
   279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
   288,   289,     0,     0,     0,     0,     0,   290,     0,   703,
   276,   277,   278,   279,   280,     0,   281,   282,   283,   284,
   285,   286,   287,   288,   289,     0,     0,     0,     0,     0,
   290,     0,   827,   276,   277,   278,   279,   280,     0,   281,
   282,   283,   284,   285,   286,   287,   288,   289,     0,     0,
     0,     0,     0,   290,     0,   829,   276,   277,   278,   279,
   280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
   289,     0,     0,     0,     0,     0,   290,     0,   831,   276,
   277,   278,   279,   280,     0,   281,   282,   283,   284,   285,
   286,   287,   288,   289,     0,     0,     0,     0,     0,   290,
     0,   833,   276,   277,   278,   279,   280,     0,   281,   282,
   283,   284,   285,   286,   287,   288,   289,     0,     0,     0,
     0,     0,   290,     0,   839,   276,   277,   278,   279,   280,
     0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     0,     0,     0,     0,     0,   290,     0,   898,   276,   277,
   278,   279,   280,     0,   281,   282,   283,   284,   285,   286,
   287,   288,   289,     0,     0,     0,     0,     0,   290,     0,
   900,   276,   277,   278,   279,   280,     0,   281,   282,   283,
   284,   285,   286,   287,   288,   289,     0,     0,     0,     0,
     0,   290,     0,   908,   276,   277,   278,   279,   280,     0,
   281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     0,     0,     0,     0,   290,     0,   927,   276,   277,   278,
   279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
   288,   289,     0,     0,     0,     0,     0,   290,     0,   962,
   276,   277,   278,   279,   280,     0,   281,   282,   283,   284,
   285,   286,   287,   288,   289,     0,     0,     0,     0,     0,
   290,     0,   994,   276,   277,   278,   279,   280,     0,   281,
   282,   283,   284,   285,   286,   287,   288,   289,     0,     0,
     0,     0,     0,   290,     0,  1112,   276,   277,   278,   279,
   280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
   289,     0,     0,     0,     0,     0,   290,     0,  1158,   276,
   277,   278,   279,   280,     0,   281,   282,   283,   284,   285,
   286,   287,   288,   289,     0,     0,     0,     0,     0,   290
};

static const short yycheck[] = {     4,
     4,     4,   337,     4,   177,   269,     2,   180,     6,     2,
     4,    45,   267,     4,     4,     4,     4,   132,     4,     4,
     7,     5,     4,     6,    67,     6,     6,   624,     5,     7,
   203,     4,   205,   132,     6,     5,    67,     4,   133,     6,
    68,    68,   297,   138,     6,    73,    73,   132,    51,    52,
    34,    35,    36,    37,    86,   132,    40,    34,    35,    36,
    37,     6,   139,    40,    34,    35,    36,    37,   132,     6,
    40,   132,    76,    77,    78,    79,    80,   121,   122,     7,
     6,   132,    76,    77,    78,    79,    80,     6,   132,     4,
     6,     7,    68,   909,   910,   139,   139,    73,   132,   790,
   132,   132,   121,   122,   133,   110,   111,   112,   139,   138,
   115,   116,   140,   140,   119,    52,    89,    90,    49,   138,
   107,   126,   132,   121,   122,   130,   131,   132,    45,   107,
   108,   109,   110,    52,   139,   140,   140,   142,   119,   128,
   129,   146,   147,   740,   149,   134,   140,   136,   139,   139,
   132,   139,   141,   139,   139,   139,   139,   119,   128,   129,
   165,   166,   139,   132,   140,    45,   136,   134,   267,   174,
   139,   435,    45,   346,    89,    90,   121,   122,    47,   107,
   108,   109,   110,   188,   189,  1001,   191,    41,   193,    68,
    44,   196,   197,   366,    73,   121,   122,    68,   297,   132,
   128,   129,    73,   208,   459,   132,   139,   462,   136,   214,
   215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
   225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
   235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
   245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
   255,   139,   849,   256,   257,   258,   259,   139,    68,    68,
    68,   140,   267,    73,    73,    73,   128,   129,   269,   140,
    45,   276,   277,   278,   279,   280,   281,   282,   283,   284,
   285,   286,   287,   288,   289,   290,     8,   121,   122,   294,
   295,   133,   297,  1026,   299,  1028,   138,  1030,     6,   304,
   325,   326,   327,   308,    68,   139,   311,   121,   122,    73,
   121,   122,   317,   318,   319,     6,   321,   322,   323,   324,
   325,   326,   327,     6,   138,    41,   140,   138,    44,    45,
   140,   140,   140,     4,   339,   340,   341,   342,   343,   344,
   336,   337,   347,   336,   337,    68,     4,   352,   121,   122,
    73,   356,   357,   608,    68,     4,    68,   362,   132,    73,
   459,    73,   132,   462,   134,   138,   371,   140,  1101,   468,
   132,   376,  1063,   132,   379,  1066,   140,   378,  1069,    68,
   133,   132,   637,   134,    73,   138,     7,   121,   122,   111,
   112,   113,   114,   115,   132,   117,   118,   119,   120,   121,
   122,   123,   124,   125,   138,   121,   122,    58,    59,   131,
     8,  1144,  1009,  1146,     4,  1148,   132,   140,   140,  1152,
     4,    25,    26,   139,    28,   430,   140,   682,   140,   684,
   685,   686,   437,   436,   435,   121,   122,    45,   132,  1130,
   121,   122,   121,   122,   121,   122,     7,  1180,   132,  1182,
   134,  1184,   132,   139,   459,   460,   132,   462,   139,   138,
   465,     5,   139,   468,   121,   122,   471,   132,   732,   733,
  1161,   476,   477,  1164,   479,     4,  1167,   482,     5,  1170,
     8,   138,   487,    11,    12,     6,   107,   108,   109,   110,
    34,    35,    36,    37,   499,   500,    40,   123,   124,   125,
   139,    92,  1193,   508,  1195,   131,  1197,   128,   129,   608,
     6,   121,   122,   111,   112,   113,   114,   115,   523,   117,
   118,   119,   120,   121,   122,   123,   124,   125,   138,   132,
   140,   134,   537,   131,   539,   540,   121,   122,   637,   121,
   122,    92,   140,   546,   132,   546,   107,   108,   109,   110,
   885,   128,   129,   138,   121,   122,   138,   134,   162,   136,
   164,   121,   122,   132,   141,   134,   170,   128,   129,   132,
   174,   138,   121,   122,   121,   122,   121,   122,   138,   133,
   585,   586,    92,   682,   138,   684,   685,   686,     8,   138,
   132,   138,   134,   138,   599,   600,   601,   602,   603,   604,
   605,    44,    45,   608,    47,   139,   609,   612,   212,     6,
   133,     4,   617,     4,     5,   138,    61,    62,    63,    64,
   148,    66,   627,   128,   129,   153,   132,   630,   134,    74,
    75,   136,   637,   634,   132,    41,   134,   642,    44,    45,
     6,    47,   132,    34,    35,    36,    37,     6,     7,    40,
   178,   132,   132,   134,   134,   183,   184,   113,   114,   115,
    57,   117,   118,   119,   120,   121,   122,   123,   124,   125,
   132,   132,   134,   134,   132,   131,   681,   682,   683,   684,
   685,   686,   139,   132,   689,   690,     6,  1022,   139,   139,
   695,   111,   112,   113,   114,   115,   132,   117,   118,   119,
   120,   121,   122,   123,   124,   125,   711,   712,   132,   132,
   715,   131,   139,   133,   111,   112,   113,   114,   115,   132,
   117,   118,   119,   120,   121,   122,   123,   124,   125,   139,
   334,   335,   733,   132,   131,   134,   741,     6,   132,   343,
   134,    45,   134,    47,   749,   111,   112,   113,   114,   115,
   134,   117,   118,   119,   120,   121,   122,   123,   124,   125,
   132,   766,   134,   114,   115,   131,   117,   118,   119,   120,
   121,   122,   123,   124,   125,   780,   781,   782,   134,   132,
   131,   134,   787,   132,   136,   134,   121,   122,   123,   124,
   125,   111,   112,   113,   114,   115,   131,   117,   118,   119,
   120,   121,   122,   123,   124,   125,   811,   812,   813,   139,
   132,   131,   134,    92,     6,   820,   817,   132,   132,   134,
   825,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     6,   132,   132,   134,   134,   131,     6,   842,   841,   138,
     6,   140,    41,    42,    43,    44,    45,    46,    47,    48,
   853,    50,   134,    52,    53,     4,    55,    56,  1031,   139,
   131,     6,   128,   129,     5,     7,   871,   872,   134,   134,
   136,   136,     4,    72,     6,   141,   881,   138,   881,   140,
   138,   136,   140,    82,    83,    84,   138,   134,   140,   885,
   895,    45,   885,     6,   498,   138,   138,   140,   140,   904,
   905,   100,   128,   129,   432,   433,     7,    47,   134,   513,
   136,   916,     7,     6,    87,   141,   921,   922,   138,   138,
   140,   140,   138,   138,   140,   140,   138,   133,   140,  1102,
   138,   138,   140,   140,   939,   111,   112,   113,   114,   115,
   945,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     6,   138,   138,   140,   140,   131,     7,   138,   963,   140,
   138,   138,   140,   140,     7,    89,   111,   112,   113,   114,
   115,   976,   117,   118,   119,   120,   121,   122,   123,   124,
   125,   139,   138,   133,     6,   990,   131,   992,     4,   133,
   138,     6,   997,     7,     7,     7,   135,  1002,   111,   112,
   113,   114,   115,     7,   117,   118,   119,   120,   121,   122,
   123,   124,   125,     7,     7,     7,   133,   133,   131,   133,
  1025,     6,  1027,   133,  1029,   136,  1022,     7,   140,  1022,
  1035,  1036,   140,   139,   139,   639,  1041,     7,   132,     7,
   136,   132,  1047,  1048,   132,   132,     4,   139,     7,     6,
     6,  1056,   135,     6,  1059,   111,   112,   113,   114,   115,
     6,   117,   118,   119,   120,   121,   122,   123,   124,   125,
   674,   675,   676,   134,     6,   131,     7,  1082,   119,     7,
   139,     7,     7,     6,     4,     7,     7,  1092,     7,     7,
  1095,     7,     7,  1098,     7,     7,     6,     6,     6,     6,
     4,     7,     7,     6,     4,     6,   132,   139,  1113,   133,
  1115,   136,   133,     7,     6,   135,   644,   645,     6,   647,
     6,     6,   139,     6,   652,   653,   111,   112,   113,   114,
   115,   139,   117,   118,   119,   120,   121,   122,   123,   124,
   125,     6,     6,    88,   139,     6,   131,   136,     6,     4,
     6,   135,     6,     6,  1157,     6,     6,     6,     6,     6,
     6,     6,     6,     6,     6,   693,   694,     6,     6,   697,
     6,     6,     6,     6,     6,   139,     7,    88,     4,     6,
   140,     6,  1187,   787,     6,  1188,     7,  1190,   111,   112,
   113,   114,   115,     6,   117,   118,   119,   120,   121,   122,
   123,   124,   125,  1208,  1209,     6,   136,  1210,   131,     6,
     6,    85,   139,     6,  1219,   139,     6,    90,     6,    88,
     6,     5,   139,     6,     6,   139,     6,     6,     6,   757,
     6,     6,     6,   761,   133,     6,     6,   139,     6,   767,
   768,   769,   138,   140,   772,   773,   774,   775,   776,   777,
   778,   140,   139,     6,   138,   859,   138,   861,   111,   112,
   113,   114,   115,   139,   117,   118,   119,   120,   121,   122,
   123,   124,   125,   139,     5,    85,   139,   139,   131,   139,
   139,     6,   886,   140,   888,     6,   890,     6,   140,   111,
   112,   113,   114,   115,     6,   117,   118,   119,   120,   121,
   122,   123,   124,   125,     6,     6,     5,   748,   138,   131,
     3,     4,   840,    85,     6,   139,     9,    10,    11,    12,
    13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
    23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
   138,   140,     6,   111,   112,   113,   114,   115,    41,   117,
   118,   119,   120,   121,   122,   123,   124,   125,   139,     6,
     6,     6,   139,   131,     6,     6,   139,   895,    61,    62,
    63,    64,    65,    66,   139,   139,     6,   140,   139,     6,
     6,    74,    75,     6,   912,     0,     0,   549,   985,  1082,
     2,     2,   845,    -1,    -1,   923,    -1,    -1,    -1,   927,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
   103,   104,   105,   106,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,  1025,    -1,  1027,    -1,  1029,    -1,     6,   121,   122,
    -1,    -1,    -1,    -1,   127,    -1,    -1,    -1,    -1,   132,
    -1,    -1,    -1,    -1,   137,    -1,    -1,   140,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
     4,    -1,    -1,    -1,    -1,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    24,    25,    26,    27,    28,    29,    30,    31,    32,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    41,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,  1034,    -1,    -1,    -1,
    -1,    -1,  1040,    -1,    -1,    -1,  1044,    61,    62,    63,
    64,    65,    66,    67,    -1,    -1,    -1,    -1,    -1,    -1,
    74,    75,   111,   112,   113,   114,   115,    -1,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,    -1,   131,    -1,    -1,    -1,    -1,    -1,     6,   103,
   104,   105,   106,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,  1103,    -1,   121,   122,  1107,
  1108,    -1,    -1,   127,    -1,    -1,    -1,    -1,   132,    -1,
     3,     4,    -1,   137,    -1,   139,     9,    10,    11,    12,
    13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
    23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
    -1,    -1,    -1,    -1,    -1,    -1,  1154,    -1,    41,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,    62,
    63,    64,    65,    66,    67,    -1,    -1,    -1,    -1,    -1,
    -1,    74,    75,   111,   112,   113,   114,   115,    -1,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,    -1,   131,    -1,    -1,    -1,    -1,    -1,     6,
   103,   104,   105,   106,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   121,   122,
    -1,    -1,    -1,    -1,   127,    -1,    -1,    -1,    -1,   132,
    -1,     3,     4,    -1,   137,    -1,   139,     9,    10,    11,
    12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
    22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
    32,    -1,    -1,    -1,   111,   112,   113,   114,   115,    41,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,    -1,    -1,    -1,   131,    -1,    -1,    -1,   135,    61,
    62,    63,    64,    65,    66,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    74,    75,   111,   112,   113,   114,   115,    -1,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,    -1,    -1,    -1,   131,    -1,    -1,    -1,    -1,    -1,
    -1,   103,   104,   105,   106,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   121,
   122,    -1,    -1,    -1,    -1,   127,    -1,    -1,    -1,    -1,
   132,    -1,     3,     4,    -1,   137,    -1,   139,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
    31,    32,    -1,    -1,    -1,   111,   112,   113,   114,   115,
    41,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,    -1,   135,
    61,    62,    63,    64,    65,    66,    -1,    -1,    -1,     3,
     4,    -1,    -1,    74,    75,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    24,    25,    26,    27,    28,    29,    30,    31,    32,    -1,
    -1,     6,   103,   104,   105,   106,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
   121,   122,    -1,    -1,    -1,    -1,   127,    -1,    -1,    -1,
    -1,   132,    -1,     3,     4,    -1,   137,    -1,   139,     9,
    10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,   103,
   104,   105,   106,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,   121,   122,    -1,
    -1,    -1,    -1,   127,    -1,    -1,    -1,    -1,   132,    -1,
    -1,   135,    -1,   137,    -1,   139,   111,   112,   113,   114,
   115,    -1,   117,   118,   119,   120,   121,   122,   123,   124,
   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,    -1,
    -1,    -1,    -1,   103,   104,   105,   106,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,   121,   122,    -1,    -1,    -1,    -1,   127,    -1,    -1,
    -1,    -1,   132,    -1,    -1,   135,    -1,   137,    -1,   139,
     3,     4,    -1,    -1,    -1,    -1,     9,    10,    11,    12,
    13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
    23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,    -1,
    -1,    -1,    -1,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,     3,     4,    -1,
    -1,    -1,    -1,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    -1,    -1,    -1,
   103,   104,   105,   106,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   121,   122,
    -1,    -1,    -1,    -1,   127,    -1,    -1,    -1,    -1,   132,
    -1,    -1,   135,    -1,   137,    -1,   139,   103,   104,   105,
   106,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,   121,   122,    -1,    -1,    -1,
    -1,   127,    -1,    -1,    -1,    -1,   132,   103,   104,   105,
   106,   137,    -1,   139,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,   121,   122,    -1,    -1,    -1,
    -1,   127,    -1,    -1,    -1,    -1,   132,    -1,     3,     4,
     5,   137,     7,   139,     9,    10,    11,    12,    13,    14,
    15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
    25,    26,    27,    28,    29,    30,    31,    32,    -1,    34,
    35,    36,    37,    -1,    -1,    40,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,
    -1,    -1,    -1,    -1,     9,    10,    11,    12,    13,    14,
    15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
    25,    26,    27,    28,    29,    30,    31,    32,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    41,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   103,   104,
   105,   106,   107,   108,   109,   110,    61,    62,    63,    64,
    65,    66,    -1,    -1,    -1,    -1,   121,   122,    -1,    74,
    75,    -1,   127,   128,   129,    -1,    -1,   132,    -1,   134,
    -1,   136,   137,   111,   112,   113,   114,   115,    -1,   117,
   118,   119,   120,   121,   122,   123,   124,   125,   103,   104,
   105,   106,    -1,   131,    -1,    -1,    -1,    -1,    -1,    -1,
   138,    -1,   140,    -1,    -1,    -1,   121,   122,    -1,    -1,
    -1,    -1,   127,    -1,    -1,    -1,    -1,   132,     3,     4,
     5,    -1,   137,    -1,     9,    10,    11,    12,    13,    14,
    15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
    25,    26,    27,    28,    29,    30,    31,    32,    -1,    34,
    35,    36,    37,     3,     4,    40,    -1,    -1,    -1,     9,
    10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
    30,    31,    32,     3,     4,    -1,    -1,    -1,    -1,     9,
    10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
    30,    31,    32,    -1,    -1,     8,    -1,    -1,   103,   104,
   105,   106,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     8,    -1,    -1,    -1,    -1,    -1,   121,   122,    -1,    -1,
    -1,    -1,   127,    -1,    -1,     8,    -1,   132,    -1,    -1,
    -1,    -1,   137,   103,   104,   105,   106,    -1,    -1,    -1,
     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,   121,   122,    -1,    -1,     8,    -1,   127,    -1,    -1,
    -1,    -1,   132,   103,   104,   105,   106,   137,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,   121,   122,    -1,    -1,    -1,    -1,   127,    -1,    -1,
    -1,    -1,   132,    -1,    -1,    -1,    -1,   137,   111,   112,
   113,   114,   115,    -1,   117,   118,   119,   120,   121,   122,
   123,   124,   125,   111,   112,   113,   114,   115,   131,   117,
   118,   119,   120,   121,   122,   123,   124,   125,   111,   112,
   113,   114,   115,   131,   117,   118,   119,   120,   121,   122,
   123,   124,   125,   111,   112,   113,   114,   115,   131,   117,
   118,   119,   120,   121,   122,   123,   124,   125,   111,   112,
   113,   114,   115,   131,   117,   118,   119,   120,   121,   122,
   123,   124,   125,     0,     1,    -1,    -1,     4,   131,    -1,
   111,   112,   113,   114,   115,    -1,   117,   118,   119,   120,
   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,    -1,
   131,    -1,    -1,    -1,    -1,    -1,    33,   138,    -1,   140,
    -1,    38,    39,    -1,    41,    42,    43,    44,    45,    46,
    47,    48,    -1,    50,    51,    52,    53,    54,    55,    56,
    -1,    -1,    -1,    60,    61,    62,    63,    64,    65,    66,
    -1,    68,    69,    70,    71,    72,    -1,    74,    75,    -1,
    -1,    -1,    -1,    -1,    81,    82,    83,    84,    -1,    -1,
    -1,    -1,    89,    -1,    91,    -1,    93,    94,    95,    96,
    97,    98,    99,   100,   101,   102,    41,    42,    43,    44,
    45,    46,    47,    48,    -1,    50,    -1,    52,    53,    -1,
    55,    56,    -1,    -1,    -1,    -1,    -1,    41,    42,    43,
    44,    45,    46,    47,    48,    -1,    50,    72,    52,    53,
    -1,    55,    56,    -1,    -1,    -1,    -1,    82,    83,    84,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    72,    -1,
    -1,    -1,    -1,    -1,    -1,   100,    -1,    -1,    82,    83,
    84,    -1,    -1,    41,    42,    43,    44,    45,    46,    47,
    48,    -1,    50,    -1,    52,    53,   100,    55,    56,   111,
   112,   113,   114,   115,    -1,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    72,   140,    -1,    -1,    -1,   131,
    -1,    -1,    -1,    -1,    82,    83,    84,    -1,   140,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,   140,    -1,    -1,    -1,
    -1,    -1,   100,    41,    42,    43,    44,    45,    46,    47,
    48,    -1,    50,    -1,    52,    53,    -1,    55,    56,    -1,
    -1,    -1,    -1,    -1,    41,    42,    43,    44,    45,    46,
    47,    48,    -1,    50,    72,    52,    53,    -1,    55,    56,
    -1,    -1,   140,    -1,    82,    83,    84,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    72,    -1,    -1,    -1,    -1,
    -1,    -1,   100,    -1,    -1,    82,    83,    84,    -1,    -1,
    41,    42,    43,    44,    45,    46,    47,    48,    -1,    50,
    -1,    52,    53,   100,    55,    56,   111,   112,   113,   114,
   115,    -1,   117,   118,   119,   120,   121,   122,   123,   124,
   125,    72,   140,    -1,    -1,    -1,   131,    -1,    -1,    -1,
    -1,    82,    83,    84,    -1,   140,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,   140,    -1,    -1,    -1,    -1,    -1,   100,
    41,    42,    43,    44,    45,    46,    47,    48,    -1,    50,
    -1,    52,    53,    -1,    55,    56,    -1,    -1,    -1,    -1,
    -1,    41,    42,    43,    44,    45,    46,    47,    48,    -1,
    50,    72,    52,    53,    -1,    55,    56,    -1,    -1,   140,
    -1,    82,    83,    84,     4,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    72,    -1,    -1,    -1,    -1,    -1,    -1,   100,
    -1,    -1,    82,    83,    84,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    33,    -1,    -1,    -1,    -1,    38,    39,
   100,    41,    42,    43,    44,    45,    46,    47,    48,    -1,
    50,    51,    52,    53,    54,    55,    56,    -1,    -1,   140,
    60,    61,    62,    63,    64,    65,    66,    -1,    68,    69,
    70,    71,    72,    -1,    74,    75,    -1,    -1,    -1,    -1,
   140,    81,    82,    83,    84,    -1,    -1,    -1,    -1,    89,
    -1,    91,    -1,    93,    94,    95,    96,    97,    98,    99,
   100,   101,   102,   111,   112,   113,   114,   115,    -1,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,    -1,   131,    -1,    -1,    -1,    -1,    -1,    -1,
   138,    -1,   140,   111,   112,   113,   114,   115,    -1,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,    -1,   131,    -1,    -1,    -1,   111,   112,   113,
   114,   115,   140,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,
    -1,   111,   112,   113,   114,   115,   140,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
    -1,   131,    -1,    -1,    -1,   111,   112,   113,   114,   115,
   140,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,    -1,   111,
   112,   113,   114,   115,   140,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,    -1,   131,
    -1,    -1,    -1,   111,   112,   113,   114,   115,   140,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,    -1,   131,    -1,    -1,    -1,   111,   112,   113,
   114,   115,   140,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,
    -1,   111,   112,   113,   114,   115,   140,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
    -1,   131,    -1,    -1,    -1,   111,   112,   113,   114,   115,
   140,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,    -1,   111,
   112,   113,   114,   115,   140,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,    -1,   131,
    -1,    -1,    -1,   111,   112,   113,   114,   115,   140,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,    -1,   131,    -1,    -1,    -1,   111,   112,   113,
   114,   115,   140,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,
    -1,   111,   112,   113,   114,   115,   140,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
    -1,   131,    -1,    -1,    -1,   111,   112,   113,   114,   115,
   140,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,    -1,   111,
   112,   113,   114,   115,   140,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,    -1,   131,
    -1,    -1,    -1,   111,   112,   113,   114,   115,   140,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,    -1,   131,    -1,    -1,    -1,   111,   112,   113,
   114,   115,   140,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,
    -1,   111,   112,   113,   114,   115,   140,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
    -1,   131,    -1,    -1,    -1,   111,   112,   113,   114,   115,
   140,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,    -1,   111,
   112,   113,   114,   115,   140,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,    -1,   131,
    -1,    -1,    -1,   111,   112,   113,   114,   115,   140,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,    -1,   131,    -1,    -1,    -1,   111,   112,   113,
   114,   115,   140,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,   133,
    -1,    -1,    -1,    -1,   138,   111,   112,   113,   114,   115,
    -1,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,    -1,   131,    -1,   111,   112,   113,
   114,   115,   138,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,   111,
   112,   113,   114,   115,   138,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,    -1,   131,
    -1,   111,   112,   113,   114,   115,   138,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
    -1,   131,    -1,   111,   112,   113,   114,   115,   138,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,    -1,   131,    -1,   111,   112,   113,   114,   115,
   138,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,    -1,   131,    -1,   111,   112,   113,
   114,   115,   138,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,   111,
   112,   113,   114,   115,   138,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,    -1,   131,
    -1,   111,   112,   113,   114,   115,   138,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
    -1,   131,    -1,   111,   112,   113,   114,   115,   138,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,    -1,   131,    -1,   111,   112,   113,   114,   115,
   138,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,    -1,   131,    -1,   111,   112,   113,
   114,   115,   138,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,   111,
   112,   113,   114,   115,   138,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,    -1,   131,
    -1,   111,   112,   113,   114,   115,   138,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
    -1,   131,    -1,   111,   112,   113,   114,   115,   138,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,    -1,   131,    -1,   111,   112,   113,   114,   115,
   138,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,    -1,   131,    -1,   111,   112,   113,
   114,   115,   138,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,   111,
   112,   113,   114,   115,   138,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,    -1,   131,
    -1,   111,   112,   113,   114,   115,   138,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
    -1,   131,    -1,   111,   112,   113,   114,   115,   138,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,    -1,   131,    -1,   111,   112,   113,   114,   115,
   138,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,    -1,   131,    -1,   111,   112,   113,
   114,   115,   138,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,   111,
   112,   113,   114,   115,   138,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,    -1,   131,
    -1,   111,   112,   113,   114,   115,   138,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
    -1,   131,    -1,   111,   112,   113,   114,   115,   138,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,    -1,   131,    -1,   111,   112,   113,   114,   115,
   138,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,    -1,   131,    -1,   111,   112,   113,
   114,   115,   138,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,   111,
   112,   113,   114,   115,   138,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,    -1,   131,
    -1,   111,   112,   113,   114,   115,   138,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
    -1,   131,    -1,   111,   112,   113,   114,   115,   138,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,    -1,   131,    -1,   111,   112,   113,   114,   115,
   138,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,    -1,   131,    -1,   111,   112,   113,
   114,   115,   138,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,   111,
   112,   113,   114,   115,   138,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,    -1,   131,
    -1,   111,   112,   113,   114,   115,   138,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
    -1,   131,    -1,   111,   112,   113,   114,   115,   138,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,    -1,   131,    -1,   111,   112,   113,   114,   115,
   138,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,    -1,   131,    -1,   111,   112,   113,
   114,   115,   138,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,
    -1,   135,   111,   112,   113,   114,   115,    -1,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,    -1,   131,    -1,    -1,    -1,   135,   111,   112,   113,
   114,   115,    -1,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,
    -1,   135,   111,   112,   113,   114,   115,    -1,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,    -1,   131,    -1,    -1,    -1,   135,   111,   112,   113,
   114,   115,    -1,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,
    -1,   135,   111,   112,   113,   114,   115,    -1,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,    -1,   131,    -1,    -1,    -1,   135,   111,   112,   113,
   114,   115,    -1,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,
    -1,   135,   111,   112,   113,   114,   115,    -1,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,    -1,   131,    -1,    -1,    -1,   135,   111,   112,   113,
   114,   115,    -1,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,
    -1,   135,   111,   112,   113,   114,   115,    -1,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,    -1,   131,    -1,    -1,    -1,   135,   111,   112,   113,
   114,   115,    -1,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,
    -1,   135,   111,   112,   113,   114,   115,    -1,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,    -1,   131,    -1,    -1,    -1,   135,   111,   112,   113,
   114,   115,    -1,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,
    -1,   135,   111,   112,   113,   114,   115,    -1,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,    -1,   131,    -1,    -1,    -1,   135,   111,   112,   113,
   114,   115,    -1,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,
    -1,   135,   111,   112,   113,   114,   115,    -1,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,    -1,   131,    -1,    -1,    -1,   135,   111,   112,   113,
   114,   115,    -1,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,
    -1,   135,   111,   112,   113,   114,   115,    -1,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,    -1,   131,    -1,    -1,    -1,   135,   111,   112,   113,
   114,   115,    -1,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,
    -1,   135,   111,   112,   113,   114,   115,    -1,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,    -1,   131,    -1,    -1,    -1,   135,   111,   112,   113,
   114,   115,    -1,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,
    -1,   135,   111,   112,   113,   114,   115,    -1,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,    -1,   131,    -1,    -1,    -1,   135,   111,   112,   113,
   114,   115,    -1,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,
    -1,   135,   111,   112,   113,   114,   115,    -1,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,    -1,   131,    -1,    -1,    -1,   135,   111,   112,   113,
   114,   115,    -1,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,
    -1,   135,   111,   112,   113,   114,   115,    -1,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,    -1,   131,    -1,    -1,    -1,   135,   111,   112,   113,
   114,   115,    -1,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,
    -1,   135,   111,   112,   113,   114,   115,    -1,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,    -1,   131,    -1,    -1,    -1,   135,   111,   112,   113,
   114,   115,    -1,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,
    -1,   135,   111,   112,   113,   114,   115,    -1,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,    -1,   131,    -1,   133,   111,   112,   113,   114,   115,
    -1,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,    -1,   131,    -1,   133,   111,   112,
   113,   114,   115,    -1,   117,   118,   119,   120,   121,   122,
   123,   124,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,
   133,   111,   112,   113,   114,   115,    -1,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
    -1,   131,    -1,   133,   111,   112,   113,   114,   115,    -1,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,    -1,    -1,    -1,   131,    -1,   133,   111,   112,   113,
   114,   115,    -1,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,   133,
   111,   112,   113,   114,   115,    -1,   117,   118,   119,   120,
   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,    -1,
   131,    -1,   133,   111,   112,   113,   114,   115,    -1,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,    -1,   131,    -1,   133,   111,   112,   113,   114,
   115,    -1,   117,   118,   119,   120,   121,   122,   123,   124,
   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,   133,   111,
   112,   113,   114,   115,    -1,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,    -1,   131,
    -1,   133,   111,   112,   113,   114,   115,    -1,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,    -1,   131,    -1,   133,   111,   112,   113,   114,   115,
    -1,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,    -1,   131,    -1,   133,   111,   112,
   113,   114,   115,    -1,   117,   118,   119,   120,   121,   122,
   123,   124,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,
   133,   111,   112,   113,   114,   115,    -1,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
    -1,   131,    -1,   133,   111,   112,   113,   114,   115,    -1,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,    -1,    -1,    -1,   131,    -1,   133,   111,   112,   113,
   114,   115,    -1,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,   133,
   111,   112,   113,   114,   115,    -1,   117,   118,   119,   120,
   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,    -1,
   131,    -1,   133,   111,   112,   113,   114,   115,    -1,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,    -1,   131,    -1,   133,   111,   112,   113,   114,
   115,    -1,   117,   118,   119,   120,   121,   122,   123,   124,
   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,   133,   111,
   112,   113,   114,   115,    -1,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,    -1,   131,
    -1,   133,   111,   112,   113,   114,   115,    -1,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,    -1,   131,    -1,   133,   111,   112,   113,   114,   115,
    -1,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,    -1,   131,    -1,   133,   111,   112,
   113,   114,   115,    -1,   117,   118,   119,   120,   121,   122,
   123,   124,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,
   133,   111,   112,   113,   114,   115,    -1,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
    -1,   131,    -1,   133,   111,   112,   113,   114,   115,    -1,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,    -1,    -1,    -1,   131,    -1,   133,   111,   112,   113,
   114,   115,    -1,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,   133,
   111,   112,   113,   114,   115,    -1,   117,   118,   119,   120,
   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,    -1,
   131,    -1,   133,   111,   112,   113,   114,   115,    -1,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,    -1,   131,    -1,   133,   111,   112,   113,   114,
   115,    -1,   117,   118,   119,   120,   121,   122,   123,   124,
   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,   133,   111,
   112,   113,   114,   115,    -1,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,    -1,   131,
    -1,   133,   111,   112,   113,   114,   115,    -1,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,    -1,   131,    -1,   133,   111,   112,   113,   114,   115,
    -1,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,    -1,   131,    -1,   133,   111,   112,
   113,   114,   115,    -1,   117,   118,   119,   120,   121,   122,
   123,   124,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,
   133,   111,   112,   113,   114,   115,    -1,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
    -1,   131,    -1,   133,   111,   112,   113,   114,   115,    -1,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,    -1,    -1,    -1,   131,    -1,   133,   111,   112,   113,
   114,   115,    -1,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,   133,
   111,   112,   113,   114,   115,    -1,   117,   118,   119,   120,
   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,    -1,
   131,    -1,   133,   111,   112,   113,   114,   115,    -1,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,    -1,   131,    -1,   133,   111,   112,   113,   114,
   115,    -1,   117,   118,   119,   120,   121,   122,   123,   124,
   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,   133,   111,
   112,   113,   114,   115,    -1,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,    -1,   131,
    -1,   133,   111,   112,   113,   114,   115,    -1,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,    -1,   131,    -1,   133,   111,   112,   113,   114,   115,
    -1,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,    -1,   131,    -1,   133,   111,   112,
   113,   114,   115,    -1,   117,   118,   119,   120,   121,   122,
   123,   124,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,
   133,   111,   112,   113,   114,   115,    -1,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
    -1,   131,    -1,   133,   111,   112,   113,   114,   115,    -1,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,    -1,    -1,    -1,   131,    -1,   133,   111,   112,   113,
   114,   115,    -1,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,   133,
   111,   112,   113,   114,   115,    -1,   117,   118,   119,   120,
   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,    -1,
   131,    -1,   133,   111,   112,   113,   114,   115,    -1,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,    -1,   131,    -1,   133,   111,   112,   113,   114,
   115,    -1,   117,   118,   119,   120,   121,   122,   123,   124,
   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,   133,   111,
   112,   113,   114,   115,    -1,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,    -1,   131
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 2:
#line 143 "Gmsh.y"
{ yyerrok; return 1; ;
    break;}
case 5:
#line 154 "Gmsh.y"
{ return 1; ;
    break;}
case 6:
#line 155 "Gmsh.y"
{ return 1; ;
    break;}
case 7:
#line 156 "Gmsh.y"
{ return 1; ;
    break;}
case 8:
#line 157 "Gmsh.y"
{ return 1; ;
    break;}
case 9:
#line 158 "Gmsh.y"
{ List_Delete(yyvsp[0].l); return 1; ;
    break;}
case 10:
#line 159 "Gmsh.y"
{ List_Delete(yyvsp[0].l); return 1; ;
    break;}
case 11:
#line 160 "Gmsh.y"
{ return 1; ;
    break;}
case 12:
#line 161 "Gmsh.y"
{ return 1; ;
    break;}
case 13:
#line 162 "Gmsh.y"
{ return 1; ;
    break;}
case 14:
#line 163 "Gmsh.y"
{ List_Delete(yyvsp[0].l); return 1; ;
    break;}
case 15:
#line 164 "Gmsh.y"
{ return 1; ;
    break;}
case 16:
#line 165 "Gmsh.y"
{ return 1; ;
    break;}
case 17:
#line 166 "Gmsh.y"
{ return 1; ;
    break;}
case 18:
#line 167 "Gmsh.y"
{ return 1; ;
    break;}
case 19:
#line 168 "Gmsh.y"
{ return 1; ;
    break;}
case 20:
#line 173 "Gmsh.y"
{
      yyval.c = "w";
    ;
    break;}
case 21:
#line 177 "Gmsh.y"
{
      yyval.c = "a";
    ;
    break;}
case 22:
#line 184 "Gmsh.y"
{
      Msg(DIRECT, yyvsp[-2].c);
      Free(yyvsp[-2].c);
    ;
    break;}
case 23:
#line 189 "Gmsh.y"
{
      char tmpstring[1024];
      FixRelativePath(yyvsp[-1].c, tmpstring);
      FILE *fp = fopen(tmpstring, yyvsp[-2].c);
      if(!fp){
	yymsg(GERROR, "Unable to open file '%s'", tmpstring);
      }
      else{
	fprintf(fp, "%s\n", yyvsp[-4].c);
	fclose(fp);
      }
      Free(yyvsp[-4].c);
      Free(yyvsp[-1].c);
    ;
    break;}
case 24:
#line 204 "Gmsh.y"
{
      char tmpstring[1024];
      int i = PrintListOfDouble(yyvsp[-4].c, yyvsp[-2].l, tmpstring);
      if(i < 0) 
	yymsg(GERROR, "Too few arguments in Printf");
      else if(i > 0)
	yymsg(GERROR, "%d extra argument%s in Printf", i, (i>1)?"s":"");
      else
	Msg(DIRECT, tmpstring);
      Free(yyvsp[-4].c);
      List_Delete(yyvsp[-2].l);
    ;
    break;}
case 25:
#line 217 "Gmsh.y"
{
      char tmpstring[1024];
      int i = PrintListOfDouble(yyvsp[-6].c, yyvsp[-4].l, tmpstring);
      if(i < 0) 
	yymsg(GERROR, "Too few arguments in Printf");
      else if(i > 0)
	yymsg(GERROR, "%d extra argument%s in Printf", i, (i>1)?"s":"");
      else{
	char tmpstring2[1024];
	FixRelativePath(yyvsp[-1].c, tmpstring2);
	FILE *fp = fopen(tmpstring2, yyvsp[-2].c);
	if(!fp){
	  yymsg(GERROR, "Unable to open file '%s'", tmpstring2);
	}
	else{
	  fprintf(fp, "%s\n", tmpstring);
	  fclose(fp);
	}
      }
      Free(yyvsp[-6].c);
      Free(yyvsp[-1].c);
      List_Delete(yyvsp[-4].l);
    ;
    break;}
case 26:
#line 246 "Gmsh.y"
{ 
      if(!strcmp(yyvsp[-5].c, "View") && !CheckViewErrorFlags(View)){
	EndView(View, 0, yyname, yyvsp[-4].c);
      }
      Free(yyvsp[-5].c); Free(yyvsp[-4].c);
    ;
    break;}
case 27:
#line 253 "Gmsh.y"
{
      if(!strcmp(yyvsp[-7].c, "View") && !CheckViewErrorFlags(View)){
	EndView(View, 0, yyname, yyvsp[-6].c);
      }
      Free(yyvsp[-7].c); Free(yyvsp[-6].c); Free(yyvsp[-5].c);
    ;
    break;}
case 28:
#line 263 "Gmsh.y"
{
      View = BeginView(1); 
      for(int i = 0; i < VIEW_NB_ELEMENT_TYPES; i++){
	ViewErrorFlags[i] = 0;
      }
    ;
    break;}
case 35:
#line 279 "Gmsh.y"
{ ViewCoord[ViewCoordIdx] = yyvsp[0].d; ViewCoordIdx++; ;
    break;}
case 36:
#line 281 "Gmsh.y"
{ ViewCoord[ViewCoordIdx] = yyvsp[0].d; ViewCoordIdx++; ;
    break;}
case 37:
#line 286 "Gmsh.y"
{ if(ViewValueList) List_Add(ViewValueList, &yyvsp[0].d); ;
    break;}
case 38:
#line 288 "Gmsh.y"
{ if(ViewValueList) List_Add(ViewValueList, &yyvsp[0].d); ;
    break;}
case 39:
#line 293 "Gmsh.y"
{
      if(!strcmp(yyvsp[0].c, "SP")){
	ViewElementIdx = 0; ViewNumNodes = 1; ViewNumComp = 1;
	ViewValueList = View->SP; ViewNumList = &View->NbSP;
      }
      else if(!strcmp(yyvsp[0].c, "VP")){
	ViewElementIdx = 1; ViewNumNodes = 1; ViewNumComp = 3;
	ViewValueList = View->VP; ViewNumList = &View->NbVP;
      }
      else if(!strcmp(yyvsp[0].c, "TP")){
	ViewElementIdx = 2; ViewNumNodes = 1; ViewNumComp = 9;
	ViewValueList = View->TP; ViewNumList = &View->NbTP;
      }
      else if(!strcmp(yyvsp[0].c, "SL")){
	ViewElementIdx = 3; ViewNumNodes = 2; ViewNumComp = 1;
	ViewValueList = View->SL; ViewNumList = &View->NbSL;
      }
      else if(!strcmp(yyvsp[0].c, "VL")){
	ViewElementIdx = 4; ViewNumNodes = 2; ViewNumComp = 3;
	ViewValueList = View->VL; ViewNumList = &View->NbVL;
      }
      else if(!strcmp(yyvsp[0].c, "TL")){
	ViewElementIdx = 5; ViewNumNodes = 2; ViewNumComp = 9;
	ViewValueList = View->TL; ViewNumList = &View->NbTL;
      }
      else if(!strcmp(yyvsp[0].c, "ST")){
	ViewElementIdx = 6; ViewNumNodes = 3; ViewNumComp = 1;
	ViewValueList = View->ST; ViewNumList = &View->NbST;
      }
      else if(!strcmp(yyvsp[0].c, "VT")){
	ViewElementIdx = 7; ViewNumNodes = 3; ViewNumComp = 3;
	ViewValueList = View->VT; ViewNumList = &View->NbVT;
      }
      else if(!strcmp(yyvsp[0].c, "TT")){
	ViewElementIdx = 8; ViewNumNodes = 3; ViewNumComp = 9;
	ViewValueList = View->TT; ViewNumList = &View->NbTT;
      }
      else if(!strcmp(yyvsp[0].c, "SQ")){
	ViewElementIdx = 9; ViewNumNodes = 4; ViewNumComp = 1;
	ViewValueList = View->SQ; ViewNumList = &View->NbSQ;
      }
      else if(!strcmp(yyvsp[0].c, "VQ")){
	ViewElementIdx = 10; ViewNumNodes = 4; ViewNumComp = 3;
	ViewValueList = View->VQ; ViewNumList = &View->NbVQ;
      }
      else if(!strcmp(yyvsp[0].c, "TQ")){
	ViewElementIdx = 11; ViewNumNodes = 4; ViewNumComp = 9;
	ViewValueList = View->TQ; ViewNumList = &View->NbTQ;
      }
      else if(!strcmp(yyvsp[0].c, "SS")){
	ViewElementIdx = 12; ViewNumNodes = 4; ViewNumComp = 1;
	ViewValueList = View->SS; ViewNumList = &View->NbSS;
      }
      else if(!strcmp(yyvsp[0].c, "VS")){
	ViewElementIdx = 13; ViewNumNodes = 4; ViewNumComp = 3;
	ViewValueList = View->VS; ViewNumList = &View->NbVS;
      }
      else if(!strcmp(yyvsp[0].c, "TS")){
	ViewElementIdx = 14; ViewNumNodes = 4; ViewNumComp = 9;
	ViewValueList = View->TS; ViewNumList = &View->NbTS;
      }
      else if(!strcmp(yyvsp[0].c, "SH")){
	ViewElementIdx = 15; ViewNumNodes = 8; ViewNumComp = 1;
	ViewValueList = View->SH; ViewNumList = &View->NbSH;
      }
      else if(!strcmp(yyvsp[0].c, "VH")){
	ViewElementIdx = 16; ViewNumNodes = 8; ViewNumComp = 3;
	ViewValueList = View->VH; ViewNumList = &View->NbVH;
      }
      else if(!strcmp(yyvsp[0].c, "TH")){
	ViewElementIdx = 17; ViewNumNodes = 8; ViewNumComp = 9;
	ViewValueList = View->TH; ViewNumList = &View->NbTH;
      }
      else if(!strcmp(yyvsp[0].c, "SI")){
	ViewElementIdx = 18; ViewNumNodes = 6; ViewNumComp = 1;
	ViewValueList = View->SI; ViewNumList = &View->NbSI;
      }
      else if(!strcmp(yyvsp[0].c, "VI")){
	ViewElementIdx = 19; ViewNumNodes = 6; ViewNumComp = 3;
	ViewValueList = View->VI; ViewNumList = &View->NbVI;
      }
      else if(!strcmp(yyvsp[0].c, "TI")){
	ViewElementIdx = 20; ViewNumNodes = 6; ViewNumComp = 9;
	ViewValueList = View->TI; ViewNumList = &View->NbTI;
      }
      else if(!strcmp(yyvsp[0].c, "SY")){
	ViewElementIdx = 21; ViewNumNodes = 5; ViewNumComp = 1;
	ViewValueList = View->SY; ViewNumList = &View->NbSY;
      }
      else if(!strcmp(yyvsp[0].c, "VY")){
	ViewElementIdx = 22; ViewNumNodes = 5; ViewNumComp = 3;
	ViewValueList = View->VY; ViewNumList = &View->NbVY;
      }
      else if(!strcmp(yyvsp[0].c, "TY")){
	ViewElementIdx = 23; ViewNumNodes = 5; ViewNumComp = 9;
	ViewValueList = View->TY; ViewNumList = &View->NbTY;
      }
      else if(!strcmp(yyvsp[0].c, "SL2")){
	ViewElementIdx = 3; ViewNumNodes = 3; ViewNumComp = 1;
	ViewValueList = View->SL2; ViewNumList = &View->NbSL2;
      }
      else if(!strcmp(yyvsp[0].c, "VL2")){
	ViewElementIdx = 4; ViewNumNodes = 3; ViewNumComp = 3;
	ViewValueList = View->VL2; ViewNumList = &View->NbVL2;
      }
      else if(!strcmp(yyvsp[0].c, "TL2")){
	ViewElementIdx = 5; ViewNumNodes = 3; ViewNumComp = 9;
	ViewValueList = View->TL2; ViewNumList = &View->NbTL2;
      }
      else if(!strcmp(yyvsp[0].c, "ST2")){
	ViewElementIdx = 6; ViewNumNodes = 6; ViewNumComp = 1;
	ViewValueList = View->ST2; ViewNumList = &View->NbST2;
      }
      else if(!strcmp(yyvsp[0].c, "VT2")){
	ViewElementIdx = 7; ViewNumNodes = 6; ViewNumComp = 3;
	ViewValueList = View->VT2; ViewNumList = &View->NbVT2;
      }
      else if(!strcmp(yyvsp[0].c, "TT2")){
	ViewElementIdx = 8; ViewNumNodes = 6; ViewNumComp = 9;
	ViewValueList = View->TT2; ViewNumList = &View->NbTT2;
      }
      else if(!strcmp(yyvsp[0].c, "SQ2")){
	ViewElementIdx = 9; ViewNumNodes = 9; ViewNumComp = 1;
	ViewValueList = View->SQ2; ViewNumList = &View->NbSQ2;
      }
      else if(!strcmp(yyvsp[0].c, "VQ2")){
	ViewElementIdx = 10; ViewNumNodes = 9; ViewNumComp = 3;
	ViewValueList = View->VQ2; ViewNumList = &View->NbVQ2;
      }
      else if(!strcmp(yyvsp[0].c, "TQ2")){
	ViewElementIdx = 11; ViewNumNodes = 9; ViewNumComp = 9;
	ViewValueList = View->TQ2; ViewNumList = &View->NbTQ2;
      }
      else if(!strcmp(yyvsp[0].c, "SS2")){
	ViewElementIdx = 12; ViewNumNodes = 10; ViewNumComp = 1;
	ViewValueList = View->SS2; ViewNumList = &View->NbSS2;
      }
      else if(!strcmp(yyvsp[0].c, "VS2")){
	ViewElementIdx = 13; ViewNumNodes = 10; ViewNumComp = 3;
	ViewValueList = View->VS2; ViewNumList = &View->NbVS2;
      }
      else if(!strcmp(yyvsp[0].c, "TS2")){
	ViewElementIdx = 14; ViewNumNodes = 10; ViewNumComp = 9;
	ViewValueList = View->TS2; ViewNumList = &View->NbTS2;
      }
      else if(!strcmp(yyvsp[0].c, "SH2")){
	ViewElementIdx = 15; ViewNumNodes = 27; ViewNumComp = 1;
	ViewValueList = View->SH2; ViewNumList = &View->NbSH2;
      }
      else if(!strcmp(yyvsp[0].c, "VH2")){
	ViewElementIdx = 16; ViewNumNodes = 27; ViewNumComp = 3;
	ViewValueList = View->VH2; ViewNumList = &View->NbVH2;
      }
      else if(!strcmp(yyvsp[0].c, "TH2")){
	ViewElementIdx = 17; ViewNumNodes = 27; ViewNumComp = 9;
	ViewValueList = View->TH2; ViewNumList = &View->NbTH2;
      }
      else if(!strcmp(yyvsp[0].c, "SI2")){
	ViewElementIdx = 18; ViewNumNodes = 18; ViewNumComp = 1;
	ViewValueList = View->SI2; ViewNumList = &View->NbSI2;
      }
      else if(!strcmp(yyvsp[0].c, "VI2")){
	ViewElementIdx = 19; ViewNumNodes = 18; ViewNumComp = 3;
	ViewValueList = View->VI2; ViewNumList = &View->NbVI2;
      }
      else if(!strcmp(yyvsp[0].c, "TI2")){
	ViewElementIdx = 20; ViewNumNodes = 18; ViewNumComp = 9;
	ViewValueList = View->TI2; ViewNumList = &View->NbTI2;
      }
      else if(!strcmp(yyvsp[0].c, "SY2")){
	ViewElementIdx = 21; ViewNumNodes = 14; ViewNumComp = 1;
	ViewValueList = View->SY2; ViewNumList = &View->NbSY2;
      }
      else if(!strcmp(yyvsp[0].c, "VY2")){
	ViewElementIdx = 22; ViewNumNodes = 14; ViewNumComp = 3;
	ViewValueList = View->VY2; ViewNumList = &View->NbVY2;
      }
      else if(!strcmp(yyvsp[0].c, "TY2")){
	ViewElementIdx = 23; ViewNumNodes = 14; ViewNumComp = 9;
	ViewValueList = View->TY2; ViewNumList = &View->NbTY2;
      }
      else{
	yymsg(GERROR, "Unknown element type '%s'", yyvsp[0].c);	
	ViewElementIdx = -1; ViewNumNodes = 0; ViewNumComp = 0;
	ViewValueList = NULL; ViewNumList = NULL;
      }
      Free(yyvsp[0].c);
      ViewCoordIdx = 0;
    ;
    break;}
case 40:
#line 483 "Gmsh.y"
{
      if(ViewValueList){
	if(ViewCoordIdx != 3 * ViewNumNodes){
	  yymsg(GERROR, "Wrong number of node coordinates (%d != %d)", 
		ViewCoordIdx, 3 * ViewNumNodes);
	  double d = 0;
	  for(int i = 0; i < 3 * ViewNumNodes; i++)
	    List_Add(ViewValueList, &d);
	}
	else{
	  for(int i = 0; i < 3; i++)
	    for(int j = 0; j < ViewNumNodes; j++)
	      List_Add(ViewValueList, &ViewCoord[3*j+i]);
	}
	ViewNumListTmp = List_Nbr(ViewValueList);
      }
    ;
    break;}
case 41:
#line 501 "Gmsh.y"
{
      if(ViewValueList){  
	if((List_Nbr(ViewValueList) - ViewNumListTmp) % (ViewNumComp * ViewNumNodes)) 
	  ViewErrorFlags[ViewElementIdx]++;
	(*ViewNumList)++;
      }
    ;
    break;}
case 42:
#line 512 "Gmsh.y"
{ 
      for(int i = 0; i < (int)strlen(yyvsp[0].c)+1; i++) List_Add(View->T2C, &yyvsp[0].c[i]); 
      Free(yyvsp[0].c);
    ;
    break;}
case 43:
#line 517 "Gmsh.y"
{ 
      for(int i = 0; i < (int)strlen(yyvsp[0].c)+1; i++) List_Add(View->T2C, &yyvsp[0].c[i]); 
      Free(yyvsp[0].c);
    ;
    break;}
case 44:
#line 525 "Gmsh.y"
{ 
      List_Add(View->T2D, &yyvsp[-5].d); List_Add(View->T2D, &yyvsp[-3].d);
      List_Add(View->T2D, &yyvsp[-1].d); 
      double d = List_Nbr(View->T2C);
      List_Add(View->T2D, &d); 
    ;
    break;}
case 45:
#line 532 "Gmsh.y"
{
      View->NbT2++;
    ;
    break;}
case 46:
#line 539 "Gmsh.y"
{ 
      for(int i = 0; i < (int)strlen(yyvsp[0].c)+1; i++) List_Add(View->T3C, &yyvsp[0].c[i]); 
      Free(yyvsp[0].c);
    ;
    break;}
case 47:
#line 544 "Gmsh.y"
{ 
      for(int i = 0; i < (int)strlen(yyvsp[0].c)+1; i++) List_Add(View->T3C, &yyvsp[0].c[i]); 
      Free(yyvsp[0].c);
    ;
    break;}
case 48:
#line 552 "Gmsh.y"
{ 
      List_Add(View->T3D, &yyvsp[-7].d); List_Add(View->T3D, &yyvsp[-5].d);
      List_Add(View->T3D, &yyvsp[-3].d); List_Add(View->T3D, &yyvsp[-1].d); 
      double d = List_Nbr(View->T3C);
      List_Add(View->T3D, &d); 
    ;
    break;}
case 49:
#line 559 "Gmsh.y"
{
      View->NbT3++;
    ;
    break;}
case 50:
#line 567 "Gmsh.y"
{
      View->adaptive = new Adaptive_Post_View(View, yyvsp[-5].l, yyvsp[-2].l);
    ;
    break;}
case 51:
#line 574 "Gmsh.y"
{
      ViewValueList = View->Time;
    ;
    break;}
case 52:
#line 578 "Gmsh.y"
{
    ;
    break;}
case 53:
#line 583 "Gmsh.y"
{
      (*View->Grains) [(int)yyvsp[-3].d] = yyvsp[-1].l;
    ;
    break;}
case 54:
#line 591 "Gmsh.y"
{ yyval.i = 0; ;
    break;}
case 55:
#line 592 "Gmsh.y"
{ yyval.i = 1; ;
    break;}
case 56:
#line 593 "Gmsh.y"
{ yyval.i = 2; ;
    break;}
case 57:
#line 594 "Gmsh.y"
{ yyval.i = 3; ;
    break;}
case 58:
#line 595 "Gmsh.y"
{ yyval.i = 4; ;
    break;}
case 59:
#line 599 "Gmsh.y"
{ yyval.i = 1; ;
    break;}
case 60:
#line 600 "Gmsh.y"
{ yyval.i = -1; ;
    break;}
case 61:
#line 608 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-3].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))){
	if(!yyvsp[-2].i){
	  TheSymbol.val = List_Create(1, 1, sizeof(double));
	  List_Put(TheSymbol.val, 0, &yyvsp[-1].d);
	  Tree_Add(Symbol_T, &TheSymbol);
	}
	else{
	  yymsg(GERROR, "Unknown variable '%s'", yyvsp[-3].c);
	  Free(yyvsp[-3].c);
	}
      }
      else{
	double *pd = (double*)List_Pointer_Fast(pSymbol->val, 0); 
	switch(yyvsp[-2].i){
	case 0 : *pd = yyvsp[-1].d; break;
	case 1 : *pd += yyvsp[-1].d; break;
	case 2 : *pd -= yyvsp[-1].d; break;
	case 3 : *pd *= yyvsp[-1].d; break;
	case 4 : 
	  if(yyvsp[-1].d) *pd /= yyvsp[-1].d; 
	  else yymsg(GERROR, "Division by zero in '%s /= %g'", yyvsp[-3].c, yyvsp[-1].d);
	  break;
	}
	Free(yyvsp[-3].c);
      }
    ;
    break;}
case 62:
#line 639 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-6].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))){
	if(!yyvsp[-2].i){
	  TheSymbol.val = List_Create(5, 5, sizeof(double));
	  List_Put(TheSymbol.val, (int)yyvsp[-4].d, &yyvsp[-1].d);
	  Tree_Add(Symbol_T, &TheSymbol);
	}
	else{
	  yymsg(GERROR, "Unknown variable '%s'", yyvsp[-6].c);
	  Free(yyvsp[-6].c);
	}
      }
      else{
	double *pd;
	if((pd = (double*)List_Pointer_Test(pSymbol->val, (int)yyvsp[-4].d))){
	  switch(yyvsp[-2].i){
	  case 0 : *pd = yyvsp[-1].d; break;
	  case 1 : *pd += yyvsp[-1].d; break;
	  case 2 : *pd -= yyvsp[-1].d; break;
	  case 3 : *pd *= yyvsp[-1].d; break;
	  case 4 : 
	    if(yyvsp[-1].d) *pd /= yyvsp[-1].d; 
	    else yymsg(GERROR, "Division by zero in '%s[%d] /= %g'", yyvsp[-6].c, (int)yyvsp[-4].d, yyvsp[-1].d);
	    break;
	  }
	}
	else{
	  if(!yyvsp[-2].i)
	    List_Put(pSymbol->val, (int)yyvsp[-4].d, &yyvsp[-1].d);
	  else
	    yymsg(GERROR, "Uninitialized variable '%s[%d]'", yyvsp[-6].c, (int)yyvsp[-4].d);
	}
	Free(yyvsp[-6].c);
      }
    ;
    break;}
case 63:
#line 678 "Gmsh.y"
{
      if(List_Nbr(yyvsp[-5].l) != List_Nbr(yyvsp[-1].l)){
	yymsg(GERROR, "Incompatible array dimensions in affectation");
	Free(yyvsp[-8].c);
      }
      else{
	Symbol TheSymbol;
	TheSymbol.Name = yyvsp[-8].c;
	Symbol *pSymbol;
	if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))){
	  if(!yyvsp[-2].i){
	    TheSymbol.val = List_Create(5, 5, sizeof(double));
	    for(int i = 0; i < List_Nbr(yyvsp[-5].l); i++){
	      List_Put(TheSymbol.val, (int)(*(double*)List_Pointer(yyvsp[-5].l, i)),
		       (double*)List_Pointer(yyvsp[-1].l, i));
	    }
	    Tree_Add(Symbol_T, &TheSymbol);
	  }
	  else{
	    yymsg(GERROR, "Unknown variable '%s'", yyvsp[-8].c);
	    Free(yyvsp[-8].c);
	  }
	}
	else{
	  for(int i = 0; i < List_Nbr(yyvsp[-5].l); i++){
	    int j = (int)(*(double*)List_Pointer(yyvsp[-5].l, i));
	    double d = *(double*)List_Pointer(yyvsp[-1].l, i);
	    double *pd;
	    if((pd = (double*)List_Pointer_Test(pSymbol->val, j))){
	      switch(yyvsp[-2].i){
	      case 0 : *pd = d; break;
	      case 1 : *pd += d; break;
	      case 2 : *pd -= d; break;
	      case 3 : *pd *= d; break;
	      case 4 : 
		if(yyvsp[-1].l) *pd /= d; 
		else yymsg(GERROR, "Division by zero in '%s[%d] /= %g'", yyvsp[-8].c, j, d);
		break;
	      }
	    }
	    else{
	      if(!yyvsp[-2].i)
		List_Put(pSymbol->val, j, &d);
	      else
		yymsg(GERROR, "Uninitialized variable '%s[%d]'", yyvsp[-8].c, j);	  
	    }
	  }
	  Free(yyvsp[-8].c);
	}
      }
      List_Delete(yyvsp[-5].l);
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 64:
#line 732 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-5].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))){
	TheSymbol.val = List_Create(5, 5, sizeof(double));
	List_Copy(yyvsp[-1].l, TheSymbol.val);
	Tree_Add(Symbol_T, &TheSymbol);
      }
      else{
	List_Reset(pSymbol->val);
	List_Copy(yyvsp[-1].l, pSymbol->val);
	Free(yyvsp[-5].c);
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 65:
#line 749 "Gmsh.y"
{
      // appends to the list
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-5].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))){
	TheSymbol.val = List_Create(5, 5, sizeof(double));
	List_Copy(yyvsp[-1].l, TheSymbol.val);
	Tree_Add(Symbol_T, &TheSymbol);
      }
      else{
	for(int i = 0; i < List_Nbr(yyvsp[-1].l); i++)
	  List_Add(pSymbol->val, List_Pointer(yyvsp[-1].l, i));
	Free(yyvsp[-5].c);
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 66:
#line 767 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-2].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol)))
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[-2].c); 
      else
	*(double*)List_Pointer_Fast(pSymbol->val, 0) += yyvsp[-1].i;
      Free(yyvsp[-2].c);
    ;
    break;}
case 67:
#line 778 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-5].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol)))
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[-5].c); 
      else{
	double *pd;
	if((pd = (double*)List_Pointer_Test(pSymbol->val, (int)yyvsp[-3].d)))
	  *pd += yyvsp[-1].i;
	else
	  yymsg(GERROR, "Uninitialized variable '%s[%d]'", yyvsp[-5].c, (int)yyvsp[-3].d);
      }
      Free(yyvsp[-5].c);
    ;
    break;}
case 68:
#line 797 "Gmsh.y"
{ 
      char* (*pStrOpt)(int num, int action, char *value);
      StringXString *pStrCat;
      if(!(pStrCat = Get_StringOptionCategory(yyvsp[-5].c)))
	yymsg(GERROR, "Unknown string option class '%s'", yyvsp[-5].c);
      else{
	if(!(pStrOpt = (char *(*) (int, int, char *))Get_StringOption(yyvsp[-3].c, pStrCat)))
	  yymsg(GERROR, "Unknown string option '%s.%s'", yyvsp[-5].c, yyvsp[-3].c);
	else
	  pStrOpt(0, GMSH_SET|GMSH_GUI, yyvsp[-1].c);
      }
      Free(yyvsp[-5].c); Free(yyvsp[-3].c); //FIXME: somtimes leak $5
    ;
    break;}
case 69:
#line 811 "Gmsh.y"
{ 
      char* (*pStrOpt)(int num, int action, char *value);
      StringXString *pStrCat;
      if(!(pStrCat = Get_StringOptionCategory(yyvsp[-8].c)))
	yymsg(GERROR, "Unknown string option class '%s'", yyvsp[-8].c);
      else{
	if(!(pStrOpt = (char *(*) (int, int, char *))Get_StringOption(yyvsp[-3].c, pStrCat)))
	  yymsg(GERROR, "Unknown string option '%s[%d].%s'", yyvsp[-8].c, (int)yyvsp[-6].d, yyvsp[-3].c);
	else
	  pStrOpt((int)yyvsp[-6].d, GMSH_SET|GMSH_GUI, yyvsp[-1].c);
      }
      Free(yyvsp[-8].c); Free(yyvsp[-3].c); //FIXME: somtimes leak $8
    ;
    break;}
case 70:
#line 828 "Gmsh.y"
{
      double (*pNumOpt)(int num, int action, double value);
      StringXNumber *pNumCat;
      if(!(pNumCat = Get_NumberOptionCategory(yyvsp[-5].c)))
	yymsg(GERROR, "Unknown numeric option class '%s'", yyvsp[-5].c);
      else{
	if(!(pNumOpt = (double (*) (int, int, double))Get_NumberOption(yyvsp[-3].c, pNumCat)))
	  yymsg(GERROR, "Unknown numeric option '%s.%s'", yyvsp[-5].c, yyvsp[-3].c);
	else{
	  double d = 0;
	  switch(yyvsp[-2].i){
	  case 0 : d = yyvsp[-1].d; break;
	  case 1 : d = pNumOpt(0, GMSH_GET, 0) + yyvsp[-1].d; break;
	  case 2 : d = pNumOpt(0, GMSH_GET, 0) - yyvsp[-1].d; break;
	  case 3 : d = pNumOpt(0, GMSH_GET, 0) * yyvsp[-1].d; break;
	  case 4 : 
	    if(yyvsp[-1].d) d = pNumOpt(0, GMSH_GET, 0) / yyvsp[-1].d; 
	    else yymsg(GERROR, "Division by zero in '%s.%s /= %g'", yyvsp[-5].c, yyvsp[-3].c, yyvsp[-1].d);
	    break;
	  }
	  pNumOpt(0, GMSH_SET|GMSH_GUI, d);
	}
      }
      Free(yyvsp[-5].c); Free(yyvsp[-3].c);
    ;
    break;}
case 71:
#line 854 "Gmsh.y"
{
      double (*pNumOpt)(int num, int action, double value);
      StringXNumber *pNumCat;
      if(!(pNumCat = Get_NumberOptionCategory(yyvsp[-8].c)))
	yymsg(GERROR, "Unknown numeric option class '%s'", yyvsp[-8].c);
      else{
	if(!(pNumOpt =  (double (*) (int, int, double))Get_NumberOption(yyvsp[-3].c, pNumCat)))
	  yymsg(GERROR, "Unknown numeric option '%s[%d].%s'", yyvsp[-8].c, (int)yyvsp[-6].d, yyvsp[-3].c);
	else{
	  double d = 0;
	  switch(yyvsp[-2].i){
	  case 0 : d = yyvsp[-1].d; break;
	  case 1 : d = pNumOpt((int)yyvsp[-6].d, GMSH_GET, 0) + yyvsp[-1].d; break;
	  case 2 : d = pNumOpt((int)yyvsp[-6].d, GMSH_GET, 0) - yyvsp[-1].d; break;
	  case 3 : d = pNumOpt((int)yyvsp[-6].d, GMSH_GET, 0) * yyvsp[-1].d; break;
	  case 4 : 
	    if(yyvsp[-1].d) d = pNumOpt((int)yyvsp[-6].d, GMSH_GET, 0) / yyvsp[-1].d;
	    else yymsg(GERROR, "Division by zero in '%s[%d].%s /= %g'", 
		       yyvsp[-8].c, (int)yyvsp[-6].d, yyvsp[-3].c, yyvsp[-1].d);
	    break;
	  }
	  pNumOpt((int)yyvsp[-6].d, GMSH_SET|GMSH_GUI, d);
	}
      }
      Free(yyvsp[-8].c); Free(yyvsp[-3].c);
    ;
    break;}
case 72:
#line 881 "Gmsh.y"
{
      double (*pNumOpt)(int num, int action, double value);
      StringXNumber *pNumCat;
      if(!(pNumCat = Get_NumberOptionCategory(yyvsp[-4].c)))
	yymsg(GERROR, "Unknown numeric option class '%s'", yyvsp[-4].c);
      else{
	if(!(pNumOpt =  (double (*) (int, int, double))Get_NumberOption(yyvsp[-2].c, pNumCat)))
	  yymsg(GERROR, "Unknown numeric option '%s.%s'", yyvsp[-4].c, yyvsp[-2].c);
	else
	  pNumOpt(0, GMSH_SET|GMSH_GUI, pNumOpt(0, GMSH_GET, 0)+yyvsp[-1].i);
      }
      Free(yyvsp[-4].c); Free(yyvsp[-2].c);
    ;
    break;}
case 73:
#line 895 "Gmsh.y"
{
      double (*pNumOpt)(int num, int action, double value);
      StringXNumber *pNumCat;
      if(!(pNumCat = Get_NumberOptionCategory(yyvsp[-7].c)))
	yymsg(GERROR, "Unknown numeric option class '%s'", yyvsp[-7].c);
      else{
	if(!(pNumOpt =  (double (*) (int, int, double))Get_NumberOption(yyvsp[-2].c, pNumCat)))
	  yymsg(GERROR, "Unknown numeric option '%s[%d].%s'", yyvsp[-7].c, (int)yyvsp[-5].d, yyvsp[-2].c);
	else
	  pNumOpt((int)yyvsp[-5].d, GMSH_SET|GMSH_GUI, pNumOpt((int)yyvsp[-5].d, GMSH_GET, 0)+yyvsp[-1].i);
      }
      Free(yyvsp[-7].c); Free(yyvsp[-2].c);
    ;
    break;}
case 74:
#line 912 "Gmsh.y"
{
      unsigned int (*pColOpt)(int num, int action, unsigned int value);
      StringXColor *pColCat;
      if(!(pColCat = Get_ColorOptionCategory(yyvsp[-7].c)))
	yymsg(GERROR, "Unknown color option class '%s'", yyvsp[-7].c);
      else{
	if(!(pColOpt =  (unsigned int (*) (int, int, unsigned int))Get_ColorOption(yyvsp[-3].c, pColCat)))
	  yymsg(GERROR, "Unknown color option '%s.Color.%s'", yyvsp[-7].c, yyvsp[-3].c);
	else
	  pColOpt(0, GMSH_SET|GMSH_GUI, yyvsp[-1].u);
      }
      Free(yyvsp[-7].c); Free(yyvsp[-3].c);
    ;
    break;}
case 75:
#line 926 "Gmsh.y"
{
      unsigned int (*pColOpt)(int num, int action, unsigned int value);
      StringXColor *pColCat;
      if(!(pColCat = Get_ColorOptionCategory(yyvsp[-10].c)))
	yymsg(GERROR, "Unknown color option class '%s'", yyvsp[-10].c);
      else{
	if(!(pColOpt =  (unsigned int (*) (int, int, unsigned int))Get_ColorOption(yyvsp[-3].c, pColCat)))
	  yymsg(GERROR, "Unknown color option '%s[%d].Color.%s'", yyvsp[-10].c, (int)yyvsp[-8].d, yyvsp[-3].c);
	else
	  pColOpt((int)yyvsp[-8].d, GMSH_SET|GMSH_GUI, yyvsp[-1].u);
      }
      Free(yyvsp[-10].c); Free(yyvsp[-3].c);
    ;
    break;}
case 76:
#line 943 "Gmsh.y"
{
      GmshColorTable *ct = Get_ColorTable(0);
      if(!ct)
	yymsg(GERROR, "View[%d] does not exist", 0);
      else{
	ct->size = List_Nbr(yyvsp[-1].l);
	if(ct->size > COLORTABLE_NBMAX_COLOR)
	  yymsg(GERROR, "Too many (%d>%d) colors in View[%d].ColorTable", 
		ct->size, COLORTABLE_NBMAX_COLOR, 0);
	else
	  for(int i = 0; i < ct->size; i++) List_Read(yyvsp[-1].l, i, &ct->table[i]);
	if(ct->size == 1){
	  ct->size = 2;
	  ct->table[1] = ct->table[0];
	}
      }
      Free(yyvsp[-5].c);
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 77:
#line 963 "Gmsh.y"
{
      GmshColorTable *ct = Get_ColorTable((int)yyvsp[-6].d);
      if(!ct)
	yymsg(GERROR, "View[%d] does not exist", (int)yyvsp[-6].d);
      else{
	ct->size = List_Nbr(yyvsp[-1].l);
	if(ct->size > COLORTABLE_NBMAX_COLOR)
	  yymsg(GERROR, "Too many (%d>%d) colors in View[%d].ColorTable", 
		   ct->size, COLORTABLE_NBMAX_COLOR, (int)yyvsp[-6].d);
	else
	  for(int i = 0; i < ct->size; i++) List_Read(yyvsp[-1].l, i, &ct->table[i]);
	if(ct->size == 1){
	  ct->size = 2;
	  ct->table[1] = ct->table[0];
	}
      }
      Free(yyvsp[-8].c);
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 78:
#line 986 "Gmsh.y"
{
      try {
	GMSH_PluginManager::instance()->setPluginOption(yyvsp[-6].c, yyvsp[-3].c, yyvsp[-1].d); 
      }
      catch (...) {
	yymsg(GERROR, "Unknown option '%s' or plugin '%s'", yyvsp[-3].c, yyvsp[-6].c);
      }
      Free(yyvsp[-6].c); Free(yyvsp[-3].c);
    ;
    break;}
case 79:
#line 996 "Gmsh.y"
{
      try {
	GMSH_PluginManager::instance()->setPluginOption(yyvsp[-6].c, yyvsp[-3].c, yyvsp[-1].c); 
      }
      catch (...) {
	yymsg(GERROR, "Unknown option '%s' or plugin '%s'", yyvsp[-3].c, yyvsp[-6].c);
      }
      Free(yyvsp[-6].c); Free(yyvsp[-3].c); // FIXME: sometimes leak $8
    ;
    break;}
case 80:
#line 1011 "Gmsh.y"
{ 
      yyval.i = (int)yyvsp[0].d; 
    ;
    break;}
case 81:
#line 1015 "Gmsh.y"
{ 
      yyval.i = GMODEL->setPhysicalName(std::string(yyvsp[0].c), ++THEM->MaxPhysicalNum);
      Free(yyvsp[0].c);
    ;
    break;}
case 82:
#line 1026 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindPoint(num)){
	yymsg(GERROR, "Point %d already exists", num);
      }
      else{
	Vertex *v = Create_Vertex(num, CTX.geom.scaling_factor * yyvsp[-1].v[0],
				  CTX.geom.scaling_factor * yyvsp[-1].v[1],
				  CTX.geom.scaling_factor * yyvsp[-1].v[2],
				  CTX.geom.scaling_factor * yyvsp[-1].v[3], 1.0);
	Tree_Add(THEM->Points, &v);
      }
      yyval.s.Type = MSH_POINT;
      yyval.s.Num = num;
    ;
    break;}
case 83:
#line 1042 "Gmsh.y"
{
      int num = (int)yyvsp[-4].i;
      if(FindPhysicalGroup(num, MSH_PHYSICAL_POINT)){
	yymsg(GERROR, "Physical point %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	PhysicalGroup *p = Create_PhysicalGroup(num, MSH_PHYSICAL_POINT, temp);
	List_Delete(temp);
	List_Add(THEM->PhysicalGroups, &p);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_PHYSICAL_POINT;
      yyval.s.Num = num;
    ;
    break;}
case 84:
#line 1058 "Gmsh.y"
{
      yymsg(WARNING, "Attractors are deprecated");
      List_Delete(yyvsp[-9].l);
      yyval.s.Type = 0;
      yyval.s.Num = 0;
    ;
    break;}
case 85:
#line 1065 "Gmsh.y"
{      
      for(int i = 0; i < List_Nbr(yyvsp[-3].l); i++){
	double d;
	List_Read(yyvsp[-3].l, i, &d);
	Vertex *v = FindPoint((int)d); 	 
	if(v)
	  v->lc = yyvsp[-1].d;
	else{
	  GVertex *gv = GMODEL->vertexByTag((int)d);
	  if(gv) 
	    gv->setPrescribedMeshSizeAtVertex(yyvsp[-1].d);
	}
      }
      List_Delete(yyvsp[-3].l);
      // dummy values
      yyval.s.Type = 0;
      yyval.s.Num = 0;
    ;
    break;}
case 86:
#line 1087 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindCurve(num)){
	yymsg(GERROR, "Curve %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	Curve *c = Create_Curve(num, MSH_SEGM_LINE, 1, temp, NULL,
				-1, -1, 0., 1.);
	Tree_Add(THEM->Curves, &c);
	CreateReversedCurve(c);
	List_Delete(temp);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_SEGM_LINE;
      yyval.s.Num = num;
    ;
    break;}
case 87:
#line 1105 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindCurve(num)){
	yymsg(GERROR, "Curve %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	Curve *c = Create_Curve(num, MSH_SEGM_SPLN, 3, temp, NULL,
				-1, -1, 0., 1.);
	Tree_Add(THEM->Curves, &c);
	CreateReversedCurve(c);
	List_Delete(temp);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_SEGM_SPLN;
      yyval.s.Num = num;
    ;
    break;}
case 88:
#line 1123 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindCurve(num)){
	yymsg(GERROR, "Curve %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	Curve *c = Create_Curve(num, MSH_SEGM_CIRC, 2, temp, NULL,
				-1, -1, 0., 1.);
	Tree_Add(THEM->Curves, &c);
	CreateReversedCurve(c);
	List_Delete(temp);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_SEGM_CIRC;
      yyval.s.Num = num;
    ;
    break;}
case 89:
#line 1141 "Gmsh.y"
{
      int num = (int)yyvsp[-6].d;
      if(FindCurve(num)){
	yymsg(GERROR, "Curve %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-3].l);
	Curve *c = Create_Curve(num, MSH_SEGM_CIRC, 2, temp, NULL,
				-1, -1, 0., 1.);
	c->Circle.n[0] = yyvsp[-1].v[0];
	c->Circle.n[1] = yyvsp[-1].v[1];
	c->Circle.n[2] = yyvsp[-1].v[2];
	End_Curve(c);
	Tree_Add(THEM->Curves, &c);
	Curve *rc = CreateReversedCurve(c);
	rc->Circle.n[0] = yyvsp[-1].v[0];
	rc->Circle.n[1] = yyvsp[-1].v[1];
	rc->Circle.n[2] = yyvsp[-1].v[2];
	End_Curve(rc);
	List_Delete(temp);
      }
      List_Delete(yyvsp[-3].l);
      yyval.s.Type = MSH_SEGM_CIRC;
      yyval.s.Num = num;
    ;
    break;}
case 90:
#line 1167 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindCurve(num)){
	yymsg(GERROR, "Curve %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	Curve *c = Create_Curve(num, MSH_SEGM_ELLI, 2, temp, NULL,
				-1, -1, 0., 1.);
	Tree_Add(THEM->Curves, &c);
	CreateReversedCurve(c);
	List_Delete(temp);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_SEGM_ELLI;
      yyval.s.Num = num;
    ;
    break;}
case 91:
#line 1185 "Gmsh.y"
{
      int num = (int)yyvsp[-6].d;
      if(FindCurve(num)){
	yymsg(GERROR, "Curve %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-3].l);
	Curve *c = Create_Curve(num, MSH_SEGM_ELLI, 2, temp, NULL,
				-1, -1, 0., 1.);
	c->Circle.n[0] = yyvsp[-1].v[0];
	c->Circle.n[1] = yyvsp[-1].v[1];
	c->Circle.n[2] = yyvsp[-1].v[2];
	End_Curve(c);
	Tree_Add(THEM->Curves, &c);
	Curve *rc = CreateReversedCurve(c);
	rc->Circle.n[0] = yyvsp[-1].v[0];
	rc->Circle.n[1] = yyvsp[-1].v[1];
	rc->Circle.n[2] = yyvsp[-1].v[2];
	End_Curve(c);
	List_Delete(temp);
      }
      List_Delete(yyvsp[-3].l);
      yyval.s.Type = MSH_SEGM_ELLI;
      yyval.s.Num = num;
    ;
    break;}
case 92:
#line 1212 "Gmsh.y"
{
      int num = (int)yyvsp[-14].d;
      if(FindCurve(num)){
	yymsg(GERROR, "Curve %d already exists", num);
      }
      else{
	Curve *c = Create_Curve(num, MSH_SEGM_PARAMETRIC, 2, NULL, NULL,
				-1, -1, yyvsp[-10].d, yyvsp[-8].d);
	strcpy(c->functu, yyvsp[-6].c);
	strcpy(c->functv, yyvsp[-4].c);
	strcpy(c->functw, yyvsp[-2].c);
	Tree_Add(THEM->Curves, &c);
	CreateReversedCurve(c);
      }
      Free(yyvsp[-6].c); Free(yyvsp[-4].c); Free(yyvsp[-2].c);
      yyval.s.Type = MSH_SEGM_PARAMETRIC;
      yyval.s.Num = num;
    ;
    break;}
case 93:
#line 1231 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(List_Nbr(yyvsp[-1].l) < 4){
	yymsg(GERROR, "Too few control points for BSpline %d (%d < 4)", num,
	      List_Nbr(yyvsp[-1].l));
      }
      else{
	if(FindCurve(num)){
	  yymsg(GERROR, "Curve %d already exists", num);
	}
	else{
	  List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	  Curve *c = Create_Curve(num, MSH_SEGM_BSPLN, 2, temp, NULL,
				  -1, -1, 0., 1.);
	  Tree_Add(THEM->Curves, &c);
	  CreateReversedCurve(c);
	  List_Delete(temp);
	}
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_SEGM_BSPLN;
      yyval.s.Num = num;
    ;
    break;}
case 94:
#line 1255 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(List_Nbr(yyvsp[-1].l) < 4){
	yymsg(GERROR, "Too few control points for Bezier curve %d (%d < 4)", num,
	      List_Nbr(yyvsp[-1].l));
      }
      else{
	if(FindCurve(num)){
	  yymsg(GERROR, "Curve %d already exists", num);
	}
	else{
	  List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	  Curve *c = Create_Curve(num, MSH_SEGM_BEZIER, 2, temp, NULL,
				  -1, -1, 0., 1.);
	  Tree_Add(THEM->Curves, &c);
	  CreateReversedCurve(c);
	  List_Delete(temp);
	}
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_SEGM_BEZIER;
      yyval.s.Num = num;
    ;
    break;}
case 95:
#line 1279 "Gmsh.y"
{
      int num = (int)yyvsp[-8].d;
      if(List_Nbr(yyvsp[-5].l) + (int)yyvsp[-1].d + 1 != List_Nbr(yyvsp[-3].l)){
	yymsg(GERROR, "Wrong definition of Nurbs Curve %d: "
	      "got %d knots, need N + D + 1 = %d + %d + 1 = %d",
	      (int)yyvsp[-8].d, List_Nbr(yyvsp[-3].l), List_Nbr(yyvsp[-5].l), (int)yyvsp[-1].d, List_Nbr(yyvsp[-5].l) + (int)yyvsp[-1].d + 1);
      }
      else{
	if(FindCurve(num)){
	  yymsg(GERROR, "Curve %d already exists", num);
	}
	else{
	  List_T *temp = ListOfDouble2ListOfInt(yyvsp[-5].l);
	  Curve *c = Create_Curve(num, MSH_SEGM_NURBS, (int)yyvsp[-1].d, temp, yyvsp[-3].l,
				  -1, -1, 0., 1.);
	  Tree_Add(THEM->Curves, &c);
	  CreateReversedCurve(c);
	  List_Delete(temp);
	}
      }
      List_Delete(yyvsp[-5].l);
      List_Delete(yyvsp[-3].l);
      yyval.s.Type = MSH_SEGM_NURBS;
      yyval.s.Num = num;
    ;
    break;}
case 96:
#line 1305 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindEdgeLoop(num)){
	yymsg(GERROR, "Line loop %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	sortEdgesInLoop(num, temp);
	EdgeLoop *l = Create_EdgeLoop(num, temp);
	Tree_Add(THEM->EdgeLoops, &l);
	List_Delete(temp);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_SEGM_LOOP;
      yyval.s.Num = num;
    ;
    break;}
case 97:
#line 1322 "Gmsh.y"
{
      yymsg(WARNING, "Attractors are deprecated");
      List_Delete(yyvsp[-9].l);
      yyval.s.Type = 0;
      yyval.s.Num = 0;
    ;
    break;}
case 98:
#line 1329 "Gmsh.y"
{
      int num = (int)yyvsp[-4].i;
      if(FindPhysicalGroup(num, MSH_PHYSICAL_LINE)){
	yymsg(GERROR, "Physical line %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	PhysicalGroup *p = Create_PhysicalGroup(num, MSH_PHYSICAL_LINE, temp);
	List_Delete(temp);
	List_Add(THEM->PhysicalGroups, &p);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_PHYSICAL_LINE;
      yyval.s.Num = num;
    ;
    break;}
case 99:
#line 1348 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindSurface(num)){
	yymsg(GERROR, "Surface %d already exists", num);
      }
      else{
	Surface *s = Create_Surface(num, MSH_SURF_PLAN);
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	setSurfaceGeneratrices(s, temp);
	List_Delete(temp);
	s->Support = s;
	End_Surface(s);
	Tree_Add(THEM->Surfaces, &s);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_SURF_PLAN;
      yyval.s.Num = num;
    ;
    break;}
case 100:
#line 1367 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d, type = 0;
      if(FindSurface(num)){
	yymsg(GERROR, "Surface %d already exists", num);
      }
      else{
	double d;
	List_Read(yyvsp[-1].l, 0, &d);
	EdgeLoop *el = FindEdgeLoop((int)fabs(d));
	if(!el){
	  yymsg(GERROR, "Unknown line loop %d", (int)d);
	}
	else{
	  int j = List_Nbr(el->Curves);
	  if(j == 4){
	    type = MSH_SURF_REGL;
	  }
	  else if(j == 3){
	    type = MSH_SURF_TRIC;
	  }
	  else{
	    yymsg(GERROR, "Wrong definition of Ruled Surface %d: "
		  "%d borders instead of 3 or 4", num, j);
	    type = MSH_SURF_PLAN;
	  }
	  Surface *s = Create_Surface(num, type);
	  List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	  setSurfaceGeneratrices(s, temp);
	  List_Delete(temp);
	  s->Support = s;
	  End_Surface(s);
	  Tree_Add(THEM->Surfaces, &s);
	}
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = type;
      yyval.s.Num = num;
    ;
    break;}
case 101:
#line 1406 "Gmsh.y"
{
      int num = (int)yyvsp[-8].d;
      Surface *support = FindSurface((int)yyvsp[-4].d);
      if(!support){
	yymsg(GERROR, "Unknown support surface %d", (int)yyvsp[-4].d);
      }
      else{
	if(FindSurface(num)){
	  yymsg(GERROR, "Surface %d already exists", num);
	}
	else{
	  Surface *s = Create_Surface(num, MSH_SURF_TRIMMED);
	  List_T *temp = ListOfDouble2ListOfInt(yyvsp[-2].l);
	  setSurfaceGeneratrices(s, temp);
	  List_Delete(temp);
	  s->Support = support;
	  End_Surface(s);
	  Tree_Add(THEM->Surfaces, &s);
	}
      }
      List_Delete(yyvsp[-2].l);
      yyval.s.Type = MSH_SURF_TRIMMED;
      yyval.s.Num = num;
    ;
    break;}
case 102:
#line 1433 "Gmsh.y"
{
      int num = (int)yyvsp[-16].d;
      if(FindSurface(num)){
	yymsg(GERROR, "Surface %d already exists", num);
      }
      else{
	CreateNurbsSurface(num, (int)yyvsp[-4].d, (int)yyvsp[-2].d, yyvsp[-13].l, yyvsp[-10].l, yyvsp[-8].l);
      }
      for(int i = 0; i < List_Nbr(yyvsp[-13].l); i++)
	List_Delete((List_T*)List_Pointer(yyvsp[-13].l, i));
      List_Delete(yyvsp[-13].l);
      List_Delete(yyvsp[-10].l);
      List_Delete(yyvsp[-8].l);
      yyval.s.Type = MSH_SURF_NURBS;
      yyval.s.Num = num;
    ;
    break;}
case 103:
#line 1452 "Gmsh.y"
{
      int num = (int)yyvsp[-16].d;
      if(FindSurface(num)){
	yymsg(GERROR, "Surface %d already exists", num);
      }
      else{
	CreateNurbsSurfaceSupport(num, (int)yyvsp[-4].d, (int)yyvsp[-2].d, yyvsp[-13].l, yyvsp[-10].l, yyvsp[-8].l);
      }
      for(int i = 0; i < List_Nbr(yyvsp[-13].l); i++)
	List_Delete((List_T*)List_Pointer(yyvsp[-13].l, i));
      List_Delete(yyvsp[-13].l);
      List_Delete(yyvsp[-10].l);
      List_Delete(yyvsp[-8].l);
      yyval.s.Type = MSH_SURF_NURBS;
      yyval.s.Num = num;
    ;
    break;}
case 104:
#line 1469 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindSurfaceLoop(num)){
	yymsg(GERROR, "Surface loop %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	SurfaceLoop *l = Create_SurfaceLoop(num, temp);
	Tree_Add(THEM->SurfaceLoops, &l);
	List_Delete(temp);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_SURF_LOOP;
      yyval.s.Num = num;
    ;
    break;}
case 105:
#line 1485 "Gmsh.y"
{
      int num = (int)yyvsp[-4].i;
      if(FindPhysicalGroup(num, MSH_PHYSICAL_SURFACE)){
	yymsg(GERROR, "Physical surface %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	PhysicalGroup *p = Create_PhysicalGroup(num, MSH_PHYSICAL_SURFACE, temp);
	List_Delete(temp);
	List_Add(THEM->PhysicalGroups, &p);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_PHYSICAL_SURFACE;
      yyval.s.Num = num;
    ;
    break;}
case 106:
#line 1505 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindVolume(num)){
	yymsg(GERROR, "Volume %d already exists", num);
      }
      else{
	Volume *v = Create_Volume(num, MSH_VOLUME);
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	setVolumeSurfaces(v, temp);
	List_Delete(temp);
	Tree_Add(THEM->Volumes, &v);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_VOLUME;
      yyval.s.Num = num;
    ;
    break;}
case 107:
#line 1522 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindVolume(num)){
	yymsg(GERROR, "Volume %d already exists", num);
      }
      else{
	Volume *v = Create_Volume(num, MSH_VOLUME);
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	setVolumeSurfaces(v, temp);
	List_Delete(temp);
	Tree_Add(THEM->Volumes, &v);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_VOLUME;
      yyval.s.Num = num;
    ;
    break;}
case 108:
#line 1539 "Gmsh.y"
{
      int num = (int)yyvsp[-4].i;
      if(FindPhysicalGroup(num, MSH_PHYSICAL_VOLUME)){
	yymsg(GERROR, "Physical volume %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	PhysicalGroup *p = Create_PhysicalGroup(num, MSH_PHYSICAL_VOLUME, temp);
	List_Delete(temp);
	List_Add(THEM->PhysicalGroups, &p);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_PHYSICAL_VOLUME;
      yyval.s.Num = num;
    ;
    break;}
case 109:
#line 1560 "Gmsh.y"
{
      TranslateShapes(yyvsp[-3].v[0], yyvsp[-3].v[1], yyvsp[-3].v[2], yyvsp[-1].l, 1);
      yyval.l = yyvsp[-1].l;
    ;
    break;}
case 110:
#line 1565 "Gmsh.y"
{
      RotateShapes(yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].d, yyvsp[-1].l, 1);
      yyval.l = yyvsp[-1].l;
    ;
    break;}
case 111:
#line 1570 "Gmsh.y"
{
      SymmetryShapes(yyvsp[-3].v[0], yyvsp[-3].v[1], yyvsp[-3].v[2], yyvsp[-3].v[3], yyvsp[-1].l, 1);
      yyval.l = yyvsp[-1].l;
    ;
    break;}
case 112:
#line 1575 "Gmsh.y"
{
      DilatShapes(yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].d, yyvsp[-1].l, 1);
      yyval.l = yyvsp[-1].l;
    ;
    break;}
case 113:
#line 1582 "Gmsh.y"
{ yyval.l = yyvsp[0].l; ;
    break;}
case 114:
#line 1583 "Gmsh.y"
{ yyval.l = yyvsp[0].l; ;
    break;}
case 115:
#line 1584 "Gmsh.y"
{ yyval.l = yyvsp[0].l; ;
    break;}
case 116:
#line 1589 "Gmsh.y"
{
      yyval.l = List_Create(3, 3, sizeof(Shape));
    ;
    break;}
case 117:
#line 1593 "Gmsh.y"
{
      List_Add(yyval.l, &yyvsp[0].s);
    ;
    break;}
case 118:
#line 1597 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-2].l); i++){
	double d;
	List_Read(yyvsp[-2].l, i, &d);
	Shape TheShape;
	TheShape.Num = (int)d;
	Vertex *v = FindPoint(TheShape.Num);
	if(!v)
	  yymsg(WARNING, "Unknown point %d", TheShape.Num);
	else{
	  TheShape.Type = MSH_POINT;
	  List_Add(yyval.l, &TheShape);
	}
      }
    ;
    break;}
case 119:
#line 1613 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-2].l); i++){
	double d;
	List_Read(yyvsp[-2].l, i, &d);
	Shape TheShape;
	TheShape.Num = (int)d;
	Curve *c = FindCurve(TheShape.Num);
	if(!c)
	  yymsg(WARNING, "Unknown curve %d", TheShape.Num);
	else{
	  TheShape.Type = c->Typ;
	  List_Add(yyval.l, &TheShape);
	}
      }
    ;
    break;}
case 120:
#line 1629 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-2].l); i++){
	double d;
	List_Read(yyvsp[-2].l, i, &d);
	Shape TheShape;
	TheShape.Num = (int)d;
	Surface *s = FindSurface(TheShape.Num);
	if(!s)
	  yymsg(WARNING, "Unknown surface %d", TheShape.Num);
	else{
	  TheShape.Type = s->Typ;
	  List_Add(yyval.l, &TheShape);
	}
      }
    ;
    break;}
case 121:
#line 1645 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-2].l); i++){
	double d;
	List_Read(yyvsp[-2].l, i, &d);
	Shape TheShape;
	TheShape.Num = (int)d;
	Volume *v = FindVolume(TheShape.Num);
	if(!v)
	  yymsg(WARNING, "Unknown volume %d", TheShape.Num);
	else{
	  TheShape.Type = v->Typ;
	  List_Add(yyval.l, &TheShape);
	}
      }
    ;
    break;}
case 122:
#line 1666 "Gmsh.y"
{
      yyval.l = List_Create(3, 3, sizeof(Shape));
      for(int i = 0; i < List_Nbr(yyvsp[-1].l); i++){
	Shape TheShape;
	List_Read(yyvsp[-1].l, i, &TheShape);
	int j;
	CopyShape(TheShape.Type, TheShape.Num, &j);
	TheShape.Num = j;
	List_Add(yyval.l, &TheShape);
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 123:
#line 1680 "Gmsh.y"
{
      if(!strcmp(yyvsp[-4].c, "View")) AliasView((int)yyvsp[-2].d, 0);
      Free(yyvsp[-4].c);
      yyval.l = NULL;
    ;
    break;}
case 124:
#line 1686 "Gmsh.y"
{
      if(!strcmp(yyvsp[-4].c, "View")) AliasView((int)yyvsp[-2].d, 0);
      Free(yyvsp[-4].c);
      yyval.l = NULL;
    ;
    break;}
case 125:
#line 1692 "Gmsh.y"
{
      if(!strcmp(yyvsp[-4].c, "View")) AliasView((int)yyvsp[-2].d, 1);
      Free(yyvsp[-4].c);
      yyval.l = NULL;
    ;
    break;}
case 126:
#line 1704 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-1].l); i++){
	Shape TheShape;
	List_Read(yyvsp[-1].l, i, &TheShape);
	DeleteShape(TheShape.Type, TheShape.Num);
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 127:
#line 1713 "Gmsh.y"
{
      if(!strcmp(yyvsp[-4].c, "View")){
	RemoveViewByIndex((int)yyvsp[-2].d);
      }
      else{
	yymsg(GERROR, "Unknown command 'Delete %s'", yyvsp[-4].c);
      }
      Free(yyvsp[-4].c);
    ;
    break;}
case 128:
#line 1723 "Gmsh.y"
{
      if(!strcmp(yyvsp[-1].c, "Meshes") || !strcmp(yyvsp[-1].c, "All")){
	GMODEL->destroy();
	THEM->destroy();
      }
      else if(!strcmp(yyvsp[-1].c, "Physicals")){
	List_Action(THEM->PhysicalGroups, Free_PhysicalGroup);
	List_Reset(THEM->PhysicalGroups);
      }
      else{
	yymsg(GERROR, "Unknown command 'Delete %s'", yyvsp[-1].c);
      }
      Free(yyvsp[-1].c);
    ;
    break;}
case 129:
#line 1738 "Gmsh.y"
{
      if(!strcmp(yyvsp[-2].c, "Empty") && !strcmp(yyvsp[-1].c, "Views")){
	for(int i = List_Nbr(CTX.post.list) - 1; i >= 0; i--){
	  Post_View *v = *(Post_View **) List_Pointer(CTX.post.list, i);
	  if(v->empty())
	    RemoveViewByIndex(i);
	}
      }
      else{
	yymsg(GERROR, "Unknown command 'Delete %s %s'", yyvsp[-2].c, yyvsp[-1].c);
      }
      Free(yyvsp[-2].c); Free(yyvsp[-1].c);
    ;
    break;}
case 130:
#line 1757 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-1].l); i++){
	Shape TheShape;
	List_Read(yyvsp[-1].l, i, &TheShape);
	ColorShape(TheShape.Type, TheShape.Num, yyvsp[-3].u);
      }
      List_Delete(yyvsp[-1].l);      
    ;
    break;}
case 131:
#line 1771 "Gmsh.y"
{
      for(int i = 0; i < 4; i++)
	VisibilityShape(yyvsp[-1].c, i, 1);
      Free(yyvsp[-1].c);
    ;
    break;}
case 132:
#line 1777 "Gmsh.y"
{
      for(int i = 0; i < 4; i++)
	VisibilityShape(yyvsp[-1].c, i, 0);
      Free(yyvsp[-1].c);
    ;
    break;}
case 133:
#line 1783 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-1].l); i++){
	Shape TheShape;
	List_Read(yyvsp[-1].l, i, &TheShape);
	VisibilityShape(TheShape.Type, TheShape.Num, 1);
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 134:
#line 1792 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-1].l); i++){
	Shape TheShape;
	List_Read(yyvsp[-1].l, i, &TheShape);
	VisibilityShape(TheShape.Type, TheShape.Num, 0);
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 135:
#line 1806 "Gmsh.y"
{
      if(!strcmp(yyvsp[-2].c, "Include")){
	char tmpstring[1024];
	FixRelativePath(yyvsp[-1].c, tmpstring);
	// Warning: we *don't* close included files (to allow user
	// functions in these files). If you need to include many many
	// files and don't have functions in the files, use "Merge"
	// instead: some OSes limit the number of files a process can
	// open simultaneously. The right solution would be of course
	// to modify FunctionManager to reopen the files instead of
	// using the FILE pointer, but hey, I'm lazy...
	Msg(STATUS2, "Reading '%s'", tmpstring);
	ParseFile(tmpstring, 0, 1);
	SetBoundingBox();
	Msg(STATUS2, "Read '%s'", tmpstring);
      }
      else if(!strcmp(yyvsp[-2].c, "Print")){
#if defined(HAVE_FLTK)
	char tmpstring[1024];
	FixRelativePath(yyvsp[-1].c, tmpstring);
	CreateOutputFile(tmpstring, CTX.print.format);
#endif
      }
      else if(!strcmp(yyvsp[-2].c, "Save")){
#if defined(HAVE_FLTK)
	char tmpstring[1024];
	FixRelativePath(yyvsp[-1].c, tmpstring);
	CreateOutputFile(tmpstring, CTX.mesh.format);
#endif
      }
      else if(!strcmp(yyvsp[-2].c, "Merge") || !strcmp(yyvsp[-2].c, "MergeWithBoundingBox")){
	// MergeWithBoundingBox is deprecated
	char tmpstring[1024];
	FixRelativePath(yyvsp[-1].c, tmpstring);
	MergeFile(tmpstring, 1);
      }
      else if(!strcmp(yyvsp[-2].c, "System")){
	SystemCall(yyvsp[-1].c);
      }
      else{
	yymsg(GERROR, "Unknown command '%s'", yyvsp[-2].c);
      }
      Free(yyvsp[-2].c); Free(yyvsp[-1].c);
    ;
    break;}
case 136:
#line 1851 "Gmsh.y"
{
      if(!strcmp(yyvsp[-6].c, "Save") && !strcmp(yyvsp[-5].c, "View")){
	Post_View **vv = (Post_View **)List_Pointer_Test(CTX.post.list, (int)yyvsp[-3].d);
	if(vv){
	  char tmpstring[1024];
	  FixRelativePath(yyvsp[-1].c, tmpstring);
	  WriteView(*vv, tmpstring, CTX.post.file_format, 0);
	}
      }
      else{
	yymsg(GERROR, "Unknown command '%s'", yyvsp[-6].c);
      }
      Free(yyvsp[-6].c); Free(yyvsp[-5].c); Free(yyvsp[-1].c);
    ;
    break;}
case 137:
#line 1866 "Gmsh.y"
{
      if(!strcmp(yyvsp[-6].c, "Background") && !strcmp(yyvsp[-5].c, "Mesh")  && !strcmp(yyvsp[-4].c, "View")){
	Post_View **vv = (Post_View **)List_Pointer_Test(CTX.post.list, (int)yyvsp[-2].d);
	if(vv) BGMWithView(*vv);
      }
      else{
	yymsg(GERROR, "Unknown command '%s'", yyvsp[-6].c);
      }
      Free(yyvsp[-6].c); Free(yyvsp[-5].c); Free(yyvsp[-4].c);
    ;
    break;}
case 138:
#line 1877 "Gmsh.y"
{
      if(!strcmp(yyvsp[-2].c, "Sleep")){
	SleepInSeconds(yyvsp[-1].d);
      }
      else if(!strcmp(yyvsp[-2].c, "Remesh")){
	Msg(GERROR, "Surface ReMeshing must be reinterfaced");
	//	ReMesh();
      }
      else if(!strcmp(yyvsp[-2].c, "Mesh")){
	yymsg(GERROR, "Mesh directives are not (yet) allowed in scripts");
      }
      else if(!strcmp(yyvsp[-2].c, "Status")){
	yymsg(GERROR, "Mesh directives are not (yet) allowed in scripts");
      }
      else{
	yymsg(GERROR, "Unknown command '%s'", yyvsp[-2].c);
      }
      Free(yyvsp[-2].c);
    ;
    break;}
case 139:
#line 1897 "Gmsh.y"
{
       try {
	 GMSH_PluginManager::instance()->action(yyvsp[-4].c, yyvsp[-1].c, 0);
       }
       catch(...) {
	 yymsg(GERROR, "Unknown action '%s' or plugin '%s'", yyvsp[-1].c, yyvsp[-4].c);
       }
       Free(yyvsp[-4].c); Free(yyvsp[-1].c);
     ;
    break;}
case 140:
#line 1907 "Gmsh.y"
{
      if(!strcmp(yyvsp[-1].c, "ElementsFromAllViews"))
	CombineViews(0, 1, CTX.post.combine_remove_orig);
      else if(!strcmp(yyvsp[-1].c, "ElementsFromVisibleViews"))
	CombineViews(0, 0, CTX.post.combine_remove_orig);
      else if(!strcmp(yyvsp[-1].c, "ElementsByViewName"))
	CombineViews(0, 2, CTX.post.combine_remove_orig);
      else if(!strcmp(yyvsp[-1].c, "TimeStepsFromAllViews"))
	CombineViews(1, 1, CTX.post.combine_remove_orig);
      else if(!strcmp(yyvsp[-1].c, "TimeStepsFromVisibleViews"))
	CombineViews(1, 0, CTX.post.combine_remove_orig);
      else if(!strcmp(yyvsp[-1].c, "TimeStepsByViewName"))
	CombineViews(1, 2, CTX.post.combine_remove_orig);
      else if(!strcmp(yyvsp[-1].c, "Views"))
	CombineViews(0, 1, CTX.post.combine_remove_orig);
      else if(!strcmp(yyvsp[-1].c, "TimeSteps"))
	CombineViews(1, 2, CTX.post.combine_remove_orig);
      else
	yymsg(GERROR, "Unknown 'Combine' command");
      Free(yyvsp[-1].c);
    ;
    break;}
case 141:
#line 1929 "Gmsh.y"
{
      exit(0);
    ;
    break;}
case 142:
#line 1933 "Gmsh.y"
{
      CTX.forced_bbox = 0;
      SetBoundingBox();
    ;
    break;}
case 143:
#line 1938 "Gmsh.y"
{
      CTX.forced_bbox = 1;
      SetBoundingBox(yyvsp[-12].d, yyvsp[-10].d, yyvsp[-8].d, yyvsp[-6].d, yyvsp[-4].d, yyvsp[-2].d);
    ;
    break;}
case 144:
#line 1943 "Gmsh.y"
{
#if defined(HAVE_FLTK)
      Draw();
#endif
    ;
    break;}
case 145:
#line 1955 "Gmsh.y"
{
      LoopControlVariablesTab[ImbricatedLoop][0] = yyvsp[-3].d;
      LoopControlVariablesTab[ImbricatedLoop][1] = yyvsp[-1].d;
      LoopControlVariablesTab[ImbricatedLoop][2] = 1.0;
      LoopControlVariablesNameTab[ImbricatedLoop] = NULL;
      fgetpos(yyin, &yyposImbricatedLoopsTab[ImbricatedLoop]);
      yylinenoImbricatedLoopsTab[ImbricatedLoop] = yylineno;
      ImbricatedLoop++;
      if(ImbricatedLoop > MAX_RECUR_LOOPS-1){
	yymsg(GERROR, "Reached maximum number of imbricated loops");
	ImbricatedLoop = MAX_RECUR_LOOPS-1;
      }
      if(yyvsp[-3].d > yyvsp[-1].d) skip_until("For", "EndFor");
    ;
    break;}
case 146:
#line 1970 "Gmsh.y"
{
      LoopControlVariablesTab[ImbricatedLoop][0] = yyvsp[-5].d;
      LoopControlVariablesTab[ImbricatedLoop][1] = yyvsp[-3].d;
      LoopControlVariablesTab[ImbricatedLoop][2] = yyvsp[-1].d;
      LoopControlVariablesNameTab[ImbricatedLoop] = NULL;
      fgetpos(yyin, &yyposImbricatedLoopsTab[ImbricatedLoop]);
      yylinenoImbricatedLoopsTab[ImbricatedLoop] = yylineno;
      ImbricatedLoop++;
      if(ImbricatedLoop > MAX_RECUR_LOOPS-1){
	yymsg(GERROR, "Reached maximum number of imbricated loops");
	ImbricatedLoop = MAX_RECUR_LOOPS-1;
      }
      if((yyvsp[-1].d > 0. && yyvsp[-5].d > yyvsp[-3].d) || (yyvsp[-1].d < 0. && yyvsp[-5].d < yyvsp[-3].d))
	skip_until("For", "EndFor");
    ;
    break;}
case 147:
#line 1986 "Gmsh.y"
{
      LoopControlVariablesTab[ImbricatedLoop][0] = yyvsp[-3].d;
      LoopControlVariablesTab[ImbricatedLoop][1] = yyvsp[-1].d;
      LoopControlVariablesTab[ImbricatedLoop][2] = 1.0;
      LoopControlVariablesNameTab[ImbricatedLoop] = yyvsp[-6].c;
      Symbol TheSymbol;      
      TheSymbol.Name = yyvsp[-6].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))){
	TheSymbol.val = List_Create(1, 1, sizeof(double));
	List_Put(TheSymbol.val, 0, &yyvsp[-3].d);
	Tree_Add(Symbol_T, &TheSymbol);
      }
      else{
	List_Write(pSymbol->val, 0, &yyvsp[-3].d);
      }
      fgetpos(yyin, &yyposImbricatedLoopsTab[ImbricatedLoop]);
      yylinenoImbricatedLoopsTab[ImbricatedLoop] = yylineno;
      ImbricatedLoop++;
      if(ImbricatedLoop > MAX_RECUR_LOOPS-1){
	yymsg(GERROR, "Reached maximum number of imbricated loops");
	ImbricatedLoop = MAX_RECUR_LOOPS-1;
      }
      if(yyvsp[-3].d > yyvsp[-1].d) skip_until("For", "EndFor");
    ;
    break;}
case 148:
#line 2012 "Gmsh.y"
{
      LoopControlVariablesTab[ImbricatedLoop][0] = yyvsp[-5].d;
      LoopControlVariablesTab[ImbricatedLoop][1] = yyvsp[-3].d;
      LoopControlVariablesTab[ImbricatedLoop][2] = yyvsp[-1].d;
      LoopControlVariablesNameTab[ImbricatedLoop] = yyvsp[-8].c;
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-8].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))){
	TheSymbol.val = List_Create(1, 1, sizeof(double));
	List_Put(TheSymbol.val, 0, &yyvsp[-5].d);
	Tree_Add(Symbol_T, &TheSymbol);
      }
      else{
	List_Write(pSymbol->val, 0, &yyvsp[-5].d);
      }
      fgetpos(yyin, &yyposImbricatedLoopsTab[ImbricatedLoop]);
      yylinenoImbricatedLoopsTab[ImbricatedLoop] = yylineno;
      ImbricatedLoop++;
      if(ImbricatedLoop > MAX_RECUR_LOOPS-1){
	yymsg(GERROR, "Reached maximum number of imbricated loops");
	ImbricatedLoop = MAX_RECUR_LOOPS-1;
      }
      if((yyvsp[-1].d > 0. && yyvsp[-5].d > yyvsp[-3].d) || (yyvsp[-1].d < 0. && yyvsp[-5].d < yyvsp[-3].d))
	skip_until("For", "EndFor");
    ;
    break;}
case 149:
#line 2039 "Gmsh.y"
{
      if(ImbricatedLoop <= 0){
	yymsg(GERROR, "Invalid For/EndFor loop");
	ImbricatedLoop = 0;
      }
      else{
	double x0 = LoopControlVariablesTab[ImbricatedLoop-1][0];
	double x1 = LoopControlVariablesTab[ImbricatedLoop-1][1];
	double step = LoopControlVariablesTab[ImbricatedLoop-1][2];
	int do_next = (step > 0.) ? (x0+step <= x1) : (x0+step >= x1);
	if(do_next){
	  LoopControlVariablesTab[ImbricatedLoop-1][0] +=
	    LoopControlVariablesTab[ImbricatedLoop-1][2];
	  if(LoopControlVariablesNameTab[ImbricatedLoop-1]){
	    Symbol TheSymbol;
	    TheSymbol.Name = LoopControlVariablesNameTab[ImbricatedLoop-1];
	    Symbol *pSymbol;
	    if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol)))
	      yymsg(GERROR, "Unknown loop variable");
	    else
	      *(double*)List_Pointer_Fast(pSymbol->val, 0) += 
		LoopControlVariablesTab[ImbricatedLoop-1][2];
	  }
	  fsetpos(yyin, &yyposImbricatedLoopsTab[ImbricatedLoop-1]);
	  yylineno = yylinenoImbricatedLoopsTab[ImbricatedLoop-1];
	}
	else{
	  ImbricatedLoop--;
	}
      }
    ;
    break;}
case 150:
#line 2071 "Gmsh.y"
{
      if(!FunctionManager::Instance()->createFunction(yyvsp[0].c, yyin, yyname, yylineno))
	yymsg(GERROR, "Redefinition of function %s", yyvsp[0].c);
      skip_until(NULL, "Return");
      //FIXME: wee leak $2
    ;
    break;}
case 151:
#line 2078 "Gmsh.y"
{
      if(!FunctionManager::Instance()->leaveFunction(&yyin, yyname, yylineno))
	yymsg(GERROR, "Error while exiting function");
    ;
    break;}
case 152:
#line 2083 "Gmsh.y"
{
      if(!FunctionManager::Instance()->enterFunction(yyvsp[-1].c, &yyin, yyname, yylineno))
	yymsg(GERROR, "Unknown function %s", yyvsp[-1].c);
      //FIXME: wee leak $2
    ;
    break;}
case 153:
#line 2089 "Gmsh.y"
{
      if(!yyvsp[-1].d) skip_until("If", "EndIf");
    ;
    break;}
case 154:
#line 2093 "Gmsh.y"
{
    ;
    break;}
case 155:
#line 2102 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShapes(TRANSLATE, yyvsp[-1].l, 
		    yyvsp[-3].v[0], yyvsp[-3].v[1], yyvsp[-3].v[2], 0., 0., 0., 0., 0., 0., 0.,
		    NULL, yyval.l);
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 156:
#line 2110 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShapes(ROTATE, yyvsp[-1].l, 
		    0., 0., 0., yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].d,
		    NULL, yyval.l);
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 157:
#line 2118 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShapes(TRANSLATE_ROTATE, yyvsp[-1].l, 
		    yyvsp[-10].v[0], yyvsp[-10].v[1], yyvsp[-10].v[2], yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].d,
		    NULL, yyval.l);
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 158:
#line 2126 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = false;
      extr.mesh.Recombine = false;
    ;
    break;}
case 159:
#line 2131 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShapes(TRANSLATE, yyvsp[-3].l, 
		    yyvsp[-5].v[0], yyvsp[-5].v[1], yyvsp[-5].v[2], 0., 0., 0., 0., 0., 0., 0.,
		    &extr, yyval.l);
      List_Delete(yyvsp[-3].l);
    ;
    break;}
case 160:
#line 2139 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = false;
      extr.mesh.Recombine = false;
    ;
    break;}
case 161:
#line 2144 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShapes(ROTATE, yyvsp[-3].l, 
		    0., 0., 0., yyvsp[-10].v[0], yyvsp[-10].v[1], yyvsp[-10].v[2], yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].d,
		    &extr, yyval.l);
      List_Delete(yyvsp[-3].l);
    ;
    break;}
case 162:
#line 2152 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = false;
      extr.mesh.Recombine = false;
    ;
    break;}
case 163:
#line 2157 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShapes(TRANSLATE_ROTATE, yyvsp[-3].l, 
		    yyvsp[-12].v[0], yyvsp[-12].v[1], yyvsp[-12].v[2], yyvsp[-10].v[0], yyvsp[-10].v[1], yyvsp[-10].v[2], yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].d,
		    &extr, yyval.l);
      List_Delete(yyvsp[-3].l);
    ;
    break;}
case 164:
#line 2167 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE, MSH_POINT, (int)yyvsp[-4].d, 
		   yyvsp[-2].v[0], yyvsp[-2].v[1], yyvsp[-2].v[2], 0., 0., 0., 0., 0., 0., 0.,
		   NULL, yyval.l);
    ;
    break;}
case 165:
#line 2174 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE, MSH_SEGM_LINE, (int)yyvsp[-4].d, 
		   yyvsp[-2].v[0], yyvsp[-2].v[1], yyvsp[-2].v[2], 0., 0., 0., 0., 0., 0., 0.,
		   NULL, yyval.l);
    ;
    break;}
case 166:
#line 2181 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE, MSH_SURF_PLAN, (int)yyvsp[-4].d, 
		   yyvsp[-2].v[0], yyvsp[-2].v[1], yyvsp[-2].v[2], 0., 0., 0., 0., 0., 0., 0.,
		   NULL, yyval.l);
    ;
    break;}
case 167:
#line 2188 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(ROTATE, MSH_POINT, (int)yyvsp[-8].d, 
		   0., 0., 0., yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].v[0], yyvsp[-4].v[1], yyvsp[-4].v[2], yyvsp[-2].d,
		   NULL, yyval.l);
    ;
    break;}
case 168:
#line 2195 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(ROTATE, MSH_SEGM_LINE, (int)yyvsp[-8].d, 
		   0., 0., 0., yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].v[0], yyvsp[-4].v[1], yyvsp[-4].v[2], yyvsp[-2].d,
		   NULL, yyval.l);
    ;
    break;}
case 169:
#line 2202 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(ROTATE, MSH_SURF_PLAN, (int)yyvsp[-8].d, 
		   0., 0., 0., yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].v[0], yyvsp[-4].v[1], yyvsp[-4].v[2], yyvsp[-2].d,
		   NULL, yyval.l);
    ;
    break;}
case 170:
#line 2209 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE_ROTATE, MSH_POINT, (int)yyvsp[-10].d, 
		   yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].v[0], yyvsp[-4].v[1], yyvsp[-4].v[2], yyvsp[-2].d,
		   NULL, yyval.l);
    ;
    break;}
case 171:
#line 2216 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE_ROTATE, MSH_SEGM_LINE, (int)yyvsp[-10].d, 
		   yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].v[0], yyvsp[-4].v[1], yyvsp[-4].v[2], yyvsp[-2].d,
		   NULL, yyval.l);
    ;
    break;}
case 172:
#line 2223 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE_ROTATE, MSH_SURF_PLAN, (int)yyvsp[-10].d, 
		   yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].v[0], yyvsp[-4].v[1], yyvsp[-4].v[2], yyvsp[-2].d,
		   NULL, yyval.l);
    ;
    break;}
case 173:
#line 2230 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = false;
      extr.mesh.Recombine = false;
    ;
    break;}
case 174:
#line 2235 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE, MSH_POINT, (int)yyvsp[-8].d, 
		   yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], 0., 0., 0., 0., 0., 0., 0.,
		   &extr, yyval.l);
    ;
    break;}
case 175:
#line 2242 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = false;
      extr.mesh.Recombine = false;
    ;
    break;}
case 176:
#line 2247 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE, MSH_SEGM_LINE, (int)yyvsp[-8].d, 
		   yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], 0., 0., 0., 0., 0., 0., 0.,
		   &extr, yyval.l);
    ;
    break;}
case 177:
#line 2254 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = false;
      extr.mesh.Recombine = false;
    ;
    break;}
case 178:
#line 2259 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE, MSH_SURF_PLAN, (int)yyvsp[-8].d, 
		   yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], 0., 0., 0., 0., 0., 0., 0.,
		   &extr, yyval.l);
    ;
    break;}
case 179:
#line 2266 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = false;
      extr.mesh.Recombine = false;
    ;
    break;}
case 180:
#line 2271 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(ROTATE, MSH_POINT, (int)yyvsp[-12].d, 
		   0., 0., 0., yyvsp[-10].v[0], yyvsp[-10].v[1], yyvsp[-10].v[2], yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].d,
		   &extr, yyval.l);
    ;
    break;}
case 181:
#line 2278 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = false;
      extr.mesh.Recombine = false;
    ;
    break;}
case 182:
#line 2283 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(ROTATE, MSH_SEGM_LINE, (int)yyvsp[-12].d, 
		   0., 0., 0., yyvsp[-10].v[0], yyvsp[-10].v[1], yyvsp[-10].v[2], yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].d,
		   &extr, yyval.l);
    ;
    break;}
case 183:
#line 2290 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = false;
      extr.mesh.Recombine = false;
    ;
    break;}
case 184:
#line 2295 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(ROTATE, MSH_SURF_PLAN, (int)yyvsp[-12].d, 
		   0., 0., 0., yyvsp[-10].v[0], yyvsp[-10].v[1], yyvsp[-10].v[2], yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].d,
		   &extr, yyval.l);
    ;
    break;}
case 185:
#line 2302 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = false;
      extr.mesh.Recombine = false;
    ;
    break;}
case 186:
#line 2307 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE_ROTATE, MSH_POINT, (int)yyvsp[-14].d, 
		   yyvsp[-12].v[0], yyvsp[-12].v[1], yyvsp[-12].v[2], yyvsp[-10].v[0], yyvsp[-10].v[1], yyvsp[-10].v[2], yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].d,
		   &extr, yyval.l);
    ;
    break;}
case 187:
#line 2314 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = false;
      extr.mesh.Recombine = false;
    ;
    break;}
case 188:
#line 2319 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE_ROTATE, MSH_SEGM_LINE, (int)yyvsp[-14].d, 
		   yyvsp[-12].v[0], yyvsp[-12].v[1], yyvsp[-12].v[2], yyvsp[-10].v[0], yyvsp[-10].v[1], yyvsp[-10].v[2], yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].d,
		   &extr, yyval.l);
    ;
    break;}
case 189:
#line 2326 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = false;
      extr.mesh.Recombine = false;
    ;
    break;}
case 190:
#line 2331 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE_ROTATE, MSH_SURF_PLAN, (int)yyvsp[-14].d, 
		   yyvsp[-12].v[0], yyvsp[-12].v[1], yyvsp[-12].v[2], yyvsp[-10].v[0], yyvsp[-10].v[1], yyvsp[-10].v[2], yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].d,
		   &extr, yyval.l);
    ;
    break;}
case 191:
#line 2342 "Gmsh.y"
{
    ;
    break;}
case 192:
#line 2345 "Gmsh.y"
{
    ;
    break;}
case 193:
#line 2351 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = true;
      extr.mesh.NbLayer = 1;
      extr.mesh.NbElmLayer.clear();
      extr.mesh.hLayer.clear();
      extr.mesh.NbElmLayer.push_back((int)fabs(yyvsp[-2].d));
      extr.mesh.hLayer.push_back(1.);
    ;
    break;}
case 194:
#line 2360 "Gmsh.y"
{
      double d;
      extr.mesh.ExtrudeMesh = true;
      extr.mesh.NbLayer = List_Nbr(yyvsp[-4].l);
      if(List_Nbr(yyvsp[-4].l) == List_Nbr(yyvsp[-2].l)){
	extr.mesh.NbElmLayer.clear();
	extr.mesh.hLayer.clear();
	for(int i = 0; i < List_Nbr(yyvsp[-4].l); i++){
	  List_Read(yyvsp[-4].l, i, &d);
	  extr.mesh.NbElmLayer.push_back((d > 0) ? (int)d : 1);
	  List_Read(yyvsp[-2].l, i, &d);
	  extr.mesh.hLayer.push_back(d);
	}
      }
      else{
	yymsg(GERROR, "Wrong layer definition {%d, %d}", 
	      List_Nbr(yyvsp[-4].l), List_Nbr(yyvsp[-2].l));
      }
      List_Delete(yyvsp[-4].l);
      List_Delete(yyvsp[-2].l);
    ;
    break;}
case 195:
#line 2382 "Gmsh.y"
{
      yymsg(WARNING, "Explicit region numbers in layers are deprecated");
      double d;
      extr.mesh.ExtrudeMesh = true;
      extr.mesh.NbLayer = List_Nbr(yyvsp[-6].l);
      if(List_Nbr(yyvsp[-6].l) == List_Nbr(yyvsp[-4].l) && List_Nbr(yyvsp[-6].l) == List_Nbr(yyvsp[-2].l)){
	extr.mesh.NbElmLayer.clear();
	extr.mesh.hLayer.clear();
	for(int i = 0; i < List_Nbr(yyvsp[-6].l); i++){
	  List_Read(yyvsp[-6].l, i, &d);
	  extr.mesh.NbElmLayer.push_back((d > 0) ? (int)d : 1);
	  List_Read(yyvsp[-2].l, i, &d);
	  extr.mesh.hLayer.push_back(d);
	}
      }
      else{
	yymsg(GERROR, "Wrong layer definition {%d, %d, %d}", 
	      List_Nbr(yyvsp[-6].l), List_Nbr(yyvsp[-4].l), List_Nbr(yyvsp[-2].l));
      }
      List_Delete(yyvsp[-6].l);
      List_Delete(yyvsp[-4].l);
      List_Delete(yyvsp[-2].l);
    ;
    break;}
case 196:
#line 2406 "Gmsh.y"
{
      extr.mesh.Recombine = true;
    ;
    break;}
case 197:
#line 2415 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-3].l); i++){
	double d;
	List_Read(yyvsp[-3].l, i, &d);
	int j = (int)fabs(d);
        Curve *c = FindCurve(j);
	if(!c)
	  yymsg(WARNING, "Unknown curve %d", j);
	else{
	  c->Method = TRANSFINI;
	  c->ipar[0] = (yyvsp[-1].d>2)?(int)yyvsp[-1].d:2;
	  c->ipar[1] = sign(d);
	  c->dpar[0] = 1.0;
	}
      }
      List_Delete(yyvsp[-3].l);
    ;
    break;}
case 198:
#line 2433 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-6].l); i++){
	double d;
	List_Read(yyvsp[-6].l, i, &d);
	int j = (int)fabs(d);
        Curve *c = FindCurve(j);
	if(!c)
	  yymsg(WARNING, "Unknown curve %d", j);
	else{
	  c->Method = TRANSFINI;
	  c->ipar[0] = (yyvsp[-4].d>2)?(int)yyvsp[-4].d:2;
	  c->ipar[1] = sign(d); /* Progresion : code 1 ou -1 */
	  c->dpar[0] = fabs(yyvsp[-1].d);
	}
      }
      List_Delete(yyvsp[-6].l);
    ;
    break;}
case 199:
#line 2451 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-6].l); i++){
	double d;
	List_Read(yyvsp[-6].l, i, &d);
	int j = (int)fabs(d);
        Curve *c = FindCurve(j);
	if(!c)
	  yymsg(WARNING, "Unknown curve %d", j);
	else{
	  c->Method = TRANSFINI;
	  c->ipar[0] = (yyvsp[-4].d>2)?(int)yyvsp[-4].d:2;
	  c->ipar[1] = 2*sign(d); /* Bump : code 2 ou -2 */
	  c->dpar[0] = fabs(yyvsp[-1].d);
	}
      }
      List_Delete(yyvsp[-6].l);
    ;
    break;}
case 200:
#line 2469 "Gmsh.y"
{
      Surface *s = FindSurface((int)yyvsp[-4].d);
      if(!s)
	yymsg(WARNING, "Unknown surface %d", (int)yyvsp[-4].d);
      else{
	s->Method = TRANSFINI;
	s->Recombine_Dir = -1;
	int k = List_Nbr(yyvsp[-1].l);
	if(k != 3 && k != 4){
	  yymsg(GERROR, "Wrong definition of Transfinite Surface %d: "
		"%d points instead of 3 or 4" , (int)yyvsp[-4].d, k);
	}
	else{
	  List_Reset(s->TrsfPoints);
	  for(int i = 0; i < k; i++){
	    double d;
	    List_Read(yyvsp[-1].l, i, &d);
	    int j = (int)fabs(d);
	    Vertex *v = FindPoint(j);
	    if(!v)
	      yymsg(WARNING, "Unknown point %d", j);
	    else
	      List_Add(s->TrsfPoints, &v);
	  }
	}
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 201:
#line 2498 "Gmsh.y"
{
      Surface *s = FindSurface((int)yyvsp[-5].d);
      if(!s)
	yymsg(WARNING, "Unknown surface %d", (int)yyvsp[-5].d);
      else{
	s->Method = TRANSFINI;
	int k = List_Nbr(yyvsp[-2].l);
	if(k != 3 && k != 4){
	  yymsg(GERROR, "Wrong definition of Transfinite Surface %d: "
		"%d points instead of 3 or 4" , (int)yyvsp[-5].d, k);
	}
	else{
	  List_Reset(s->TrsfPoints);
	  if (!strcmp(yyvsp[-1].c, "Right"))
	    s->Recombine_Dir = 1;
	  else if (!strcmp(yyvsp[-1].c, "Left"))
	    s->Recombine_Dir = -1;
	  else
	    s->Recombine_Dir = 0;
	  for(int i = 0; i < k; i++){
	    double d;
	    List_Read(yyvsp[-2].l, i, &d);
	    int j = (int)fabs(d);
	    Vertex *v = FindPoint(j);
	    if(!v)
	      yymsg(WARNING, "Unknown point %d", j);
	    else
	      List_Add(s->TrsfPoints, &v);
	  }
	}
      }
      List_Delete(yyvsp[-2].l);
      Free(yyvsp[-1].c);
    ;
    break;}
case 202:
#line 2533 "Gmsh.y"
{
      yymsg(WARNING, "Elliptic Surface is deprecated: use Transfinite instead (with smoothing)");
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 203:
#line 2538 "Gmsh.y"
{
      Volume *v = FindVolume((int)yyvsp[-4].d);
      if(!v)
	yymsg(WARNING, "Unknown volume %d", (int)yyvsp[-4].d);
      else{
	v->Method = TRANSFINI;
	int k = List_Nbr(yyvsp[-1].l);
	if(k != 6 && k != 8)
	  yymsg(GERROR, "Wrong definition of Transfinite Volume %d: "
		"%d points instead of 6 or 8" , (int)yyvsp[-4].d, k);
	else{
	  List_Reset(v->TrsfPoints);
	  for(int i = 0; i < k; i++){
	    double d;
	    List_Read(yyvsp[-1].l, i, &d);
	    int j = (int)fabs(d);
	    Vertex *vert = FindPoint(j);
	    if(!vert)
	      yymsg(WARNING, "Unknown point %d", j);
	    else
	      List_Add(v->TrsfPoints, &vert);
	  }
	}
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 204:
#line 2565 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-3].l); i++){
	double d;
	List_Read(yyvsp[-3].l, i, &d);
	int j = (int)d;
	Surface *s = FindSurface(j);
	if(s){
	  s->Recombine = 1;
	  s->RecombineAngle = (yyvsp[-1].d > 0 && yyvsp[-1].d < 90) ? yyvsp[-1].d : 90;
	}
      }
      List_Delete(yyvsp[-3].l);
    ;
    break;}
case 205:
#line 2579 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-1].l); i++){
	double d;
	List_Read(yyvsp[-1].l, i, &d);
	int j = (int)d;
        Surface *s = FindSurface(j);
	if(s){
	  s->Recombine = 1;
        }
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 206:
#line 2598 "Gmsh.y"
{ 
      Surface *s = FindSurface((int)yyvsp[-1].d);
      if(s)
	setSurfaceEmbeddedPoints(s, yyvsp[-4].l);
    ;
    break;}
case 207:
#line 2604 "Gmsh.y"
{
      Surface *s = FindSurface((int)yyvsp[-1].d);
      if(s)
	setSurfaceEmbeddedCurves(s, yyvsp[-4].l);
    ;
    break;}
case 208:
#line 2610 "Gmsh.y"
{
    ;
    break;}
case 209:
#line 2613 "Gmsh.y"
{
    ;
    break;}
case 210:
#line 2620 "Gmsh.y"
{ 
      ReplaceAllDuplicates();
    ;
    break;}
case 211:
#line 2624 "Gmsh.y"
{ 
      yymsg(GERROR, "Intersect is deprecated");
    ;
    break;}
case 212:
#line 2633 "Gmsh.y"
{ yyval.d = yyvsp[0].d;           ;
    break;}
case 213:
#line 2634 "Gmsh.y"
{ yyval.d = yyvsp[-1].d;           ;
    break;}
case 214:
#line 2635 "Gmsh.y"
{ yyval.d = -yyvsp[0].d;          ;
    break;}
case 215:
#line 2636 "Gmsh.y"
{ yyval.d = yyvsp[0].d;           ;
    break;}
case 216:
#line 2637 "Gmsh.y"
{ yyval.d = !yyvsp[0].d;          ;
    break;}
case 217:
#line 2638 "Gmsh.y"
{ yyval.d = yyvsp[-2].d - yyvsp[0].d;      ;
    break;}
case 218:
#line 2639 "Gmsh.y"
{ yyval.d = yyvsp[-2].d + yyvsp[0].d;      ;
    break;}
case 219:
#line 2640 "Gmsh.y"
{ yyval.d = yyvsp[-2].d * yyvsp[0].d;      ;
    break;}
case 220:
#line 2642 "Gmsh.y"
{ 
      if(!yyvsp[0].d)
	yymsg(GERROR, "Division by zero in '%g / %g'", yyvsp[-2].d, yyvsp[0].d);
      else
	yyval.d = yyvsp[-2].d / yyvsp[0].d;     
    ;
    break;}
case 221:
#line 2648 "Gmsh.y"
{ yyval.d = (int)yyvsp[-2].d % (int)yyvsp[0].d;  ;
    break;}
case 222:
#line 2649 "Gmsh.y"
{ yyval.d = pow(yyvsp[-2].d, yyvsp[0].d);  ;
    break;}
case 223:
#line 2650 "Gmsh.y"
{ yyval.d = yyvsp[-2].d < yyvsp[0].d;      ;
    break;}
case 224:
#line 2651 "Gmsh.y"
{ yyval.d = yyvsp[-2].d > yyvsp[0].d;      ;
    break;}
case 225:
#line 2652 "Gmsh.y"
{ yyval.d = yyvsp[-2].d <= yyvsp[0].d;     ;
    break;}
case 226:
#line 2653 "Gmsh.y"
{ yyval.d = yyvsp[-2].d >= yyvsp[0].d;     ;
    break;}
case 227:
#line 2654 "Gmsh.y"
{ yyval.d = yyvsp[-2].d == yyvsp[0].d;     ;
    break;}
case 228:
#line 2655 "Gmsh.y"
{ yyval.d = yyvsp[-2].d != yyvsp[0].d;     ;
    break;}
case 229:
#line 2656 "Gmsh.y"
{ yyval.d = yyvsp[-2].d && yyvsp[0].d;     ;
    break;}
case 230:
#line 2657 "Gmsh.y"
{ yyval.d = yyvsp[-2].d || yyvsp[0].d;     ;
    break;}
case 231:
#line 2658 "Gmsh.y"
{ yyval.d = yyvsp[-4].d? yyvsp[-2].d : yyvsp[0].d;  ;
    break;}
case 232:
#line 2659 "Gmsh.y"
{ yyval.d = exp(yyvsp[-1].d);      ;
    break;}
case 233:
#line 2660 "Gmsh.y"
{ yyval.d = log(yyvsp[-1].d);      ;
    break;}
case 234:
#line 2661 "Gmsh.y"
{ yyval.d = log10(yyvsp[-1].d);    ;
    break;}
case 235:
#line 2662 "Gmsh.y"
{ yyval.d = sqrt(yyvsp[-1].d);     ;
    break;}
case 236:
#line 2663 "Gmsh.y"
{ yyval.d = sin(yyvsp[-1].d);      ;
    break;}
case 237:
#line 2664 "Gmsh.y"
{ yyval.d = asin(yyvsp[-1].d);     ;
    break;}
case 238:
#line 2665 "Gmsh.y"
{ yyval.d = cos(yyvsp[-1].d);      ;
    break;}
case 239:
#line 2666 "Gmsh.y"
{ yyval.d = acos(yyvsp[-1].d);     ;
    break;}
case 240:
#line 2667 "Gmsh.y"
{ yyval.d = tan(yyvsp[-1].d);      ;
    break;}
case 241:
#line 2668 "Gmsh.y"
{ yyval.d = atan(yyvsp[-1].d);     ;
    break;}
case 242:
#line 2669 "Gmsh.y"
{ yyval.d = atan2(yyvsp[-3].d, yyvsp[-1].d);;
    break;}
case 243:
#line 2670 "Gmsh.y"
{ yyval.d = sinh(yyvsp[-1].d);     ;
    break;}
case 244:
#line 2671 "Gmsh.y"
{ yyval.d = cosh(yyvsp[-1].d);     ;
    break;}
case 245:
#line 2672 "Gmsh.y"
{ yyval.d = tanh(yyvsp[-1].d);     ;
    break;}
case 246:
#line 2673 "Gmsh.y"
{ yyval.d = fabs(yyvsp[-1].d);     ;
    break;}
case 247:
#line 2674 "Gmsh.y"
{ yyval.d = floor(yyvsp[-1].d);    ;
    break;}
case 248:
#line 2675 "Gmsh.y"
{ yyval.d = ceil(yyvsp[-1].d);     ;
    break;}
case 249:
#line 2676 "Gmsh.y"
{ yyval.d = fmod(yyvsp[-3].d, yyvsp[-1].d); ;
    break;}
case 250:
#line 2677 "Gmsh.y"
{ yyval.d = fmod(yyvsp[-3].d, yyvsp[-1].d); ;
    break;}
case 251:
#line 2678 "Gmsh.y"
{ yyval.d = sqrt(yyvsp[-3].d*yyvsp[-3].d+yyvsp[-1].d*yyvsp[-1].d); ;
    break;}
case 252:
#line 2679 "Gmsh.y"
{ yyval.d = yyvsp[-1].d*(double)rand()/(double)RAND_MAX; ;
    break;}
case 253:
#line 2681 "Gmsh.y"
{ yyval.d = exp(yyvsp[-1].d);      ;
    break;}
case 254:
#line 2682 "Gmsh.y"
{ yyval.d = log(yyvsp[-1].d);      ;
    break;}
case 255:
#line 2683 "Gmsh.y"
{ yyval.d = log10(yyvsp[-1].d);    ;
    break;}
case 256:
#line 2684 "Gmsh.y"
{ yyval.d = sqrt(yyvsp[-1].d);     ;
    break;}
case 257:
#line 2685 "Gmsh.y"
{ yyval.d = sin(yyvsp[-1].d);      ;
    break;}
case 258:
#line 2686 "Gmsh.y"
{ yyval.d = asin(yyvsp[-1].d);     ;
    break;}
case 259:
#line 2687 "Gmsh.y"
{ yyval.d = cos(yyvsp[-1].d);      ;
    break;}
case 260:
#line 2688 "Gmsh.y"
{ yyval.d = acos(yyvsp[-1].d);     ;
    break;}
case 261:
#line 2689 "Gmsh.y"
{ yyval.d = tan(yyvsp[-1].d);      ;
    break;}
case 262:
#line 2690 "Gmsh.y"
{ yyval.d = atan(yyvsp[-1].d);     ;
    break;}
case 263:
#line 2691 "Gmsh.y"
{ yyval.d = atan2(yyvsp[-3].d, yyvsp[-1].d);;
    break;}
case 264:
#line 2692 "Gmsh.y"
{ yyval.d = sinh(yyvsp[-1].d);     ;
    break;}
case 265:
#line 2693 "Gmsh.y"
{ yyval.d = cosh(yyvsp[-1].d);     ;
    break;}
case 266:
#line 2694 "Gmsh.y"
{ yyval.d = tanh(yyvsp[-1].d);     ;
    break;}
case 267:
#line 2695 "Gmsh.y"
{ yyval.d = fabs(yyvsp[-1].d);     ;
    break;}
case 268:
#line 2696 "Gmsh.y"
{ yyval.d = floor(yyvsp[-1].d);    ;
    break;}
case 269:
#line 2697 "Gmsh.y"
{ yyval.d = ceil(yyvsp[-1].d);     ;
    break;}
case 270:
#line 2698 "Gmsh.y"
{ yyval.d = fmod(yyvsp[-3].d, yyvsp[-1].d); ;
    break;}
case 271:
#line 2699 "Gmsh.y"
{ yyval.d = fmod(yyvsp[-3].d, yyvsp[-1].d); ;
    break;}
case 272:
#line 2700 "Gmsh.y"
{ yyval.d = sqrt(yyvsp[-3].d*yyvsp[-3].d+yyvsp[-1].d*yyvsp[-1].d); ;
    break;}
case 273:
#line 2701 "Gmsh.y"
{ yyval.d = yyvsp[-1].d*(double)rand()/(double)RAND_MAX; ;
    break;}
case 274:
#line 2710 "Gmsh.y"
{ yyval.d = yyvsp[0].d; ;
    break;}
case 275:
#line 2711 "Gmsh.y"
{ yyval.d = 3.141592653589793; ;
    break;}
case 276:
#line 2712 "Gmsh.y"
{ yyval.d = ParUtil::Instance()->rank(); ;
    break;}
case 277:
#line 2713 "Gmsh.y"
{ yyval.d = ParUtil::Instance()->size(); ;
    break;}
case 278:
#line 2714 "Gmsh.y"
{ yyval.d = Get_GmshMajorVersion(); ;
    break;}
case 279:
#line 2715 "Gmsh.y"
{ yyval.d = Get_GmshMinorVersion(); ;
    break;}
case 280:
#line 2716 "Gmsh.y"
{ yyval.d = Get_GmshPatchVersion(); ;
    break;}
case 281:
#line 2721 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[0].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))) {
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[0].c);
	yyval.d = 0.;
      }
      else
	yyval.d = *(double*)List_Pointer_Fast(pSymbol->val, 0);
      Free(yyvsp[0].c);
    ;
    break;}
case 282:
#line 2737 "Gmsh.y"
{
      char tmpstring[1024];
      sprintf(tmpstring, "%s_%d", yyvsp[-4].c, (int)yyvsp[-1].d) ;
      Symbol TheSymbol;
      TheSymbol.Name = tmpstring;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))) {
	yymsg(GERROR, "Unknown variable '%s'", tmpstring);
	yyval.d = 0.;
      }
      else
	yyval.d = *(double*)List_Pointer_Fast(pSymbol->val, 0);
      Free(yyvsp[-4].c);
    ;
    break;}
case 283:
#line 2752 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-3].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))) {
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[-3].c);
	yyval.d = 0.;
      }
      else{
	double *pd;
	if((pd = (double*)List_Pointer_Test(pSymbol->val, (int)yyvsp[-1].d)))
	  yyval.d = *pd;
	else{
	  yymsg(GERROR, "Uninitialized variable '%s[%d]'", yyvsp[-3].c, (int)yyvsp[-1].d);
	  yyval.d = 0.;
	}
      }
      Free(yyvsp[-3].c);
    ;
    break;}
case 284:
#line 2772 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-2].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))) {
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[-2].c);
	yyval.d = 0.;
      }
      else{
	yyval.d = List_Nbr(pSymbol->val);
      }
      Free(yyvsp[-2].c);
    ;
    break;}
case 285:
#line 2786 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-1].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))) {
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[-1].c);
	yyval.d = 0.;
      }
      else
	yyval.d = (*(double*)List_Pointer_Fast(pSymbol->val, 0) += yyvsp[0].i);
      Free(yyvsp[-1].c);
    ;
    break;}
case 286:
#line 2799 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-4].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))) {
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[-4].c);
	yyval.d = 0.;
      }
      else{
	double *pd;
	if((pd = (double*)List_Pointer_Test(pSymbol->val, (int)yyvsp[-2].d)))
	  yyval.d = (*pd += yyvsp[0].i);
	else{
	  yymsg(GERROR, "Uninitialized variable '%s[%d]'", yyvsp[-4].c, (int)yyvsp[-2].d);
	  yyval.d = 0.;
	}
      }
      Free(yyvsp[-4].c);
    ;
    break;}
case 287:
#line 2822 "Gmsh.y"
{
      double (*pNumOpt)(int num, int action, double value);
      StringXNumber *pNumCat;
      if(!(pNumCat = Get_NumberOptionCategory(yyvsp[-2].c))){
	yymsg(GERROR, "Unknown numeric option class '%s'", yyvsp[-2].c);
	yyval.d = 0.;
      }
      else{
	if(!(pNumOpt =  (double (*) (int, int, double))Get_NumberOption(yyvsp[0].c, pNumCat))){
	  yymsg(GERROR, "Unknown numeric option '%s.%s'", yyvsp[-2].c, yyvsp[0].c);
	  yyval.d = 0.;
	}
	else
	  yyval.d = pNumOpt(0, GMSH_GET, 0);
      }
      Free(yyvsp[-2].c); Free(yyvsp[0].c);
    ;
    break;}
case 288:
#line 2840 "Gmsh.y"
{
      double (*pNumOpt)(int num, int action, double value);
      StringXNumber *pNumCat;
      if(!(pNumCat = Get_NumberOptionCategory(yyvsp[-5].c))){
	yymsg(GERROR, "Unknown numeric option class '%s'", yyvsp[-5].c);
	yyval.d = 0.;
      }
      else{
	if(!(pNumOpt =  (double (*) (int, int, double))Get_NumberOption(yyvsp[0].c, pNumCat))){
	  yymsg(GERROR, "Unknown numeric option '%s[%d].%s'", yyvsp[-5].c, (int)yyvsp[-3].d, yyvsp[0].c);
	  yyval.d = 0.;
	}
	else
	  yyval.d = pNumOpt((int)yyvsp[-3].d, GMSH_GET, 0);
      }
      Free(yyvsp[-5].c); Free(yyvsp[0].c);
    ;
    break;}
case 289:
#line 2858 "Gmsh.y"
{
      double (*pNumOpt)(int num, int action, double value);
      StringXNumber *pNumCat;
      if(!(pNumCat = Get_NumberOptionCategory(yyvsp[-3].c))){
	yymsg(GERROR, "Unknown numeric option class '%s'", yyvsp[-3].c);
	yyval.d = 0.;
      }
      else{
	if(!(pNumOpt =  (double (*) (int, int, double))Get_NumberOption(yyvsp[-1].c, pNumCat))){
	  yymsg(GERROR, "Unknown numeric option '%s.%s'", yyvsp[-3].c, yyvsp[-1].c);
	  yyval.d = 0.;
	}
	else
	  yyval.d = pNumOpt(0, GMSH_SET|GMSH_GUI, pNumOpt(0, GMSH_GET, 0)+yyvsp[0].i);
      }
      Free(yyvsp[-3].c); Free(yyvsp[-1].c);
    ;
    break;}
case 290:
#line 2876 "Gmsh.y"
{
      double (*pNumOpt)(int num, int action, double value);
      StringXNumber *pNumCat;
      if(!(pNumCat = Get_NumberOptionCategory(yyvsp[-6].c))){
	yymsg(GERROR, "Unknown numeric option class '%s'", yyvsp[-6].c);
	yyval.d = 0.;
      }
      else{
	if(!(pNumOpt =  (double (*) (int, int, double))Get_NumberOption(yyvsp[-1].c, pNumCat))){
	  yymsg(GERROR, "Unknown numeric option '%s[%d].%s'", yyvsp[-6].c, (int)yyvsp[-4].d, yyvsp[-1].c);
	  yyval.d = 0.;
	}
	else
	  yyval.d = pNumOpt((int)yyvsp[-4].d, GMSH_SET|GMSH_GUI, pNumOpt((int)yyvsp[-4].d, GMSH_GET, 0)+yyvsp[0].i);
      }
      Free(yyvsp[-6].c); Free(yyvsp[-1].c);
    ;
    break;}
case 291:
#line 2894 "Gmsh.y"
{ 
      yyval.d = GetValue(yyvsp[-3].c, yyvsp[-1].d);
      Free(yyvsp[-3].c);
    ;
    break;}
case 292:
#line 2902 "Gmsh.y"
{
      memcpy(yyval.v, yyvsp[0].v, 5*sizeof(double));
    ;
    break;}
case 293:
#line 2906 "Gmsh.y"
{
      for(int i = 0; i < 5; i++) yyval.v[i] = -yyvsp[0].v[i];
    ;
    break;}
case 294:
#line 2910 "Gmsh.y"
{ 
      for(int i = 0; i < 5; i++) yyval.v[i] = yyvsp[0].v[i];
    ;
    break;}
case 295:
#line 2914 "Gmsh.y"
{ 
      for(int i = 0; i < 5; i++) yyval.v[i] = yyvsp[-2].v[i] - yyvsp[0].v[i];
    ;
    break;}
case 296:
#line 2918 "Gmsh.y"
{
      for(int i = 0; i < 5; i++) yyval.v[i] = yyvsp[-2].v[i] + yyvsp[0].v[i];
    ;
    break;}
case 297:
#line 2925 "Gmsh.y"
{ 
      yyval.v[0] = yyvsp[-9].d;  yyval.v[1] = yyvsp[-7].d;  yyval.v[2] = yyvsp[-5].d;  yyval.v[3] = yyvsp[-3].d; yyval.v[4] = yyvsp[-1].d;
    ;
    break;}
case 298:
#line 2929 "Gmsh.y"
{ 
      yyval.v[0] = yyvsp[-7].d;  yyval.v[1] = yyvsp[-5].d;  yyval.v[2] = yyvsp[-3].d;  yyval.v[3] = yyvsp[-1].d; yyval.v[4] = 1.0;
    ;
    break;}
case 299:
#line 2933 "Gmsh.y"
{
      yyval.v[0] = yyvsp[-5].d;  yyval.v[1] = yyvsp[-3].d;  yyval.v[2] = yyvsp[-1].d;  yyval.v[3] = 0.0; yyval.v[4] = 1.0;
    ;
    break;}
case 300:
#line 2937 "Gmsh.y"
{
      yyval.v[0] = yyvsp[-5].d;  yyval.v[1] = yyvsp[-3].d;  yyval.v[2] = yyvsp[-1].d;  yyval.v[3] = 0.0; yyval.v[4] = 1.0;
    ;
    break;}
case 301:
#line 2944 "Gmsh.y"
{
    ;
    break;}
case 302:
#line 2947 "Gmsh.y"
{
       yyval.l = yyvsp[-1].l;
    ;
    break;}
case 303:
#line 2951 "Gmsh.y"
{
       yyval.l = yyvsp[-1].l;
    ;
    break;}
case 304:
#line 2958 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(List_T*));
      List_Add(yyval.l, &(yyvsp[0].l));
    ;
    break;}
case 305:
#line 2963 "Gmsh.y"
{
      List_Add(yyval.l, &(yyvsp[0].l));
    ;
    break;}
case 306:
#line 2971 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(double));
      List_Add(yyval.l, &(yyvsp[0].d));
    ;
    break;}
case 307:
#line 2976 "Gmsh.y"
{
      yyval.l = yyvsp[0].l;
    ;
    break;}
case 308:
#line 2980 "Gmsh.y"
{
      // creates an empty list
      yyval.l = List_Create(2, 1, sizeof(double));
    ;
    break;}
case 309:
#line 2985 "Gmsh.y"
{
      yyval.l = yyvsp[-1].l;
    ;
    break;}
case 310:
#line 2989 "Gmsh.y"
{
      yyval.l = yyvsp[-1].l;
      double *pd;
      for(int i = 0; i < List_Nbr(yyval.l); i++){
	pd = (double*)List_Pointer(yyval.l, i);
	(*pd) = - (*pd);
      }
    ;
    break;}
case 311:
#line 3001 "Gmsh.y"
{ 
      yyval.l = List_Create(2, 1, sizeof(double)); 
      for(double d = yyvsp[-2].d; (yyvsp[-2].d < yyvsp[0].d) ? (d <= yyvsp[0].d) : (d >= yyvsp[0].d); (yyvsp[-2].d < yyvsp[0].d) ? (d += 1.) : (d -= 1.)) 
	List_Add(yyval.l, &d);
    ;
    break;}
case 312:
#line 3007 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(double)); 
      if(!yyvsp[0].d || (yyvsp[-4].d < yyvsp[-2].d && yyvsp[0].d < 0) || (yyvsp[-4].d > yyvsp[-2].d && yyvsp[0].d > 0)){
        yymsg(GERROR, "Wrong increment in '%g:%g:%g'", yyvsp[-4].d, yyvsp[-2].d, yyvsp[0].d);
	List_Add(yyval.l, &(yyvsp[-4].d));
      }
      else
	for(double d = yyvsp[-4].d; (yyvsp[0].d > 0) ? (d <= yyvsp[-2].d) : (d >= yyvsp[-2].d); d += yyvsp[0].d)
	  List_Add(yyval.l, &d);
   ;
    break;}
case 313:
#line 3018 "Gmsh.y"
{
      // Returns the coordinates of a point and fills a list with it.
      // This allows to ensure e.g. that relative point positions are
      // always conserved
      Vertex *v = FindPoint((int)yyvsp[-1].d);
      yyval.l = List_Create(3, 1, sizeof(double));      
      if(!v) {
	yymsg(GERROR, "Unknown point '%d'", (int) yyvsp[-1].d);
	double d = 0.0;
	List_Add(yyval.l, &d);
	List_Add(yyval.l, &d);
	List_Add(yyval.l, &d);
      }
      else{
	List_Add(yyval.l, &v->Pos.X);
	List_Add(yyval.l, &v->Pos.Y);
	List_Add(yyval.l, &v->Pos.Z);
      }
    ;
    break;}
case 314:
#line 3038 "Gmsh.y"
{
      yyval.l = List_Create(List_Nbr(yyvsp[0].l), 1, sizeof(double));
      for(int i = 0; i < List_Nbr(yyvsp[0].l); i++){
	Shape *s = (Shape*) List_Pointer(yyvsp[0].l, i);
	double d = s->Num;
	List_Add(yyval.l, &d);
      }
      List_Delete(yyvsp[0].l);
    ;
    break;}
case 315:
#line 3048 "Gmsh.y"
{
      yyval.l = List_Create(List_Nbr(yyvsp[0].l), 1, sizeof(double));
      for(int i = 0; i < List_Nbr(yyvsp[0].l); i++){
	Shape *s = (Shape*) List_Pointer(yyvsp[0].l, i);
	double d = s->Num;
	List_Add(yyval.l, &d);
      }
      List_Delete(yyvsp[0].l);
    ;
    break;}
case 316:
#line 3058 "Gmsh.y"
{
      yyval.l = List_Create(List_Nbr(yyvsp[0].l), 1, sizeof(double));
      for(int i = 0; i < List_Nbr(yyvsp[0].l); i++){
	Shape *s = (Shape*) List_Pointer(yyvsp[0].l, i);
	double d = s->Num;
	List_Add(yyval.l, &d);
      }
      List_Delete(yyvsp[0].l);
    ;
    break;}
case 317:
#line 3068 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(double));
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-2].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))) {
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[-2].c);
	double d = 0.0;
	List_Add(yyval.l, &d);
      }
      else{
	for(int i = 0; i < List_Nbr(pSymbol->val); i++)
	  List_Add(yyval.l, (double*)List_Pointer_Fast(pSymbol->val, i));
      }
      Free(yyvsp[-2].c);
    ;
    break;}
case 318:
#line 3085 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(double));
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-2].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))) {
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[-2].c);
	double d = 0.0;
	List_Add(yyval.l, &d);
      }
      else{
	for(int i = 0; i < List_Nbr(pSymbol->val); i++){
	  double d = - *(double*)List_Pointer_Fast(pSymbol->val, i);
	  List_Add(yyval.l, &d);
	}
      }
      Free(yyvsp[-2].c);
    ;
    break;}
case 319:
#line 3104 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(double));
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-5].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))) {
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[-5].c);
	double d = 0.0;
	List_Add(yyval.l, &d);
      }
      else{
	for(int i = 0; i < List_Nbr(yyvsp[-2].l); i++){
	  int j = (int)(*(double*)List_Pointer_Fast(yyvsp[-2].l, i));
	  double *pd;
	  if((pd = (double*)List_Pointer_Test(pSymbol->val, j)))
	    List_Add(yyval.l, pd);
	  else
	    yymsg(GERROR, "Uninitialized variable '%s[%d]'", yyvsp[-5].c, j);	  
	}
      }
      Free(yyvsp[-5].c);
      List_Delete(yyvsp[-2].l);
    ;
    break;}
case 320:
#line 3128 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(double));
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-5].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))) {
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[-5].c);
	double d = 0.0;
	List_Add(yyval.l, &d);
      }
      else{
	for(int i = 0; i < List_Nbr(yyvsp[-2].l); i++){
	  int j = (int)(*(double*)List_Pointer_Fast(yyvsp[-2].l, i));
	  double *pd;
	  if((pd = (double*)List_Pointer_Test(pSymbol->val, j))){
	    double d = - *pd;
	    List_Add(yyval.l, &d);
	  }
	  else
	    yymsg(GERROR, "Uninitialized variable '%s[%d]'", yyvsp[-5].c, j);	  
	}
      }
      Free(yyvsp[-5].c);
      List_Delete(yyvsp[-2].l);
    ;
    break;}
case 321:
#line 3157 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(double));
      List_Add(yyval.l, &(yyvsp[0].d));
    ;
    break;}
case 322:
#line 3162 "Gmsh.y"
{
      yyval.l = yyvsp[0].l;
    ;
    break;}
case 323:
#line 3166 "Gmsh.y"
{
      List_Add(yyval.l, &(yyvsp[0].d));
    ;
    break;}
case 324:
#line 3170 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[0].l); i++){
	double d;
	List_Read(yyvsp[0].l, i, &d);
	List_Add(yyval.l, &d);
      }
      List_Delete(yyvsp[0].l);
    ;
    break;}
case 325:
#line 3183 "Gmsh.y"
{
      yyval.u = CTX.PACK_COLOR((int)yyvsp[-7].d, (int)yyvsp[-5].d, (int)yyvsp[-3].d, (int)yyvsp[-1].d);
    ;
    break;}
case 326:
#line 3187 "Gmsh.y"
{
      yyval.u = CTX.PACK_COLOR((int)yyvsp[-5].d, (int)yyvsp[-3].d, (int)yyvsp[-1].d, 255);
    ;
    break;}
case 327:
#line 3199 "Gmsh.y"
{
      int flag;
      yyval.u = Get_ColorForString(ColorString, -1, yyvsp[0].c, &flag);
      if(flag) yymsg(GERROR, "Unknown color '%s'", yyvsp[0].c);
      Free(yyvsp[0].c);
    ;
    break;}
case 328:
#line 3206 "Gmsh.y"
{
      unsigned int (*pColOpt)(int num, int action, unsigned int value);
      StringXColor *pColCat;
      if(!(pColCat = Get_ColorOptionCategory(yyvsp[-4].c))){
	yymsg(GERROR, "Unknown color option class '%s'", yyvsp[-4].c);
	yyval.u = 0;
      }
      else{
	if(!(pColOpt =  (unsigned int (*) (int, int, unsigned int))Get_ColorOption(yyvsp[0].c, pColCat))){
	  yymsg(GERROR, "Unknown color option '%s.Color.%s'", yyvsp[-4].c, yyvsp[0].c);
	  yyval.u = 0;
	}
	else{
	  yyval.u = pColOpt(0, GMSH_GET, 0);
	}
      }
      Free(yyvsp[-4].c); Free(yyvsp[0].c);
    ;
    break;}
case 329:
#line 3228 "Gmsh.y"
{
      yyval.l = yyvsp[-1].l;
    ;
    break;}
case 330:
#line 3232 "Gmsh.y"
{
      yyval.l = List_Create(256, 10, sizeof(unsigned int));
      GmshColorTable *ct = Get_ColorTable((int)yyvsp[-3].d);
      if(!ct)
	yymsg(GERROR, "View[%d] does not exist", (int)yyvsp[-3].d);
      else{
	for(int i = 0; i < ct->size; i++) 
	  List_Add(yyval.l, &ct->table[i]);
      }
      Free(yyvsp[-5].c);
    ;
    break;}
case 331:
#line 3247 "Gmsh.y"
{
      yyval.l = List_Create(256, 10, sizeof(unsigned int));
      List_Add(yyval.l, &(yyvsp[0].u));
    ;
    break;}
case 332:
#line 3252 "Gmsh.y"
{
      List_Add(yyval.l, &(yyvsp[0].u));
    ;
    break;}
case 333:
#line 3259 "Gmsh.y"
{
      yyval.c = yyvsp[0].c;
    ;
    break;}
case 334:
#line 3263 "Gmsh.y"
{
      yyval.c = (char *)Malloc(32*sizeof(char));
      time_t now;
      time(&now);
      strcpy(yyval.c, ctime(&now));
      yyval.c[strlen(yyval.c) - 1] = '\0';
    ;
    break;}
case 335:
#line 3271 "Gmsh.y"
{
      yyval.c = (char *)Malloc((strlen(yyvsp[-3].c)+strlen(yyvsp[-1].c)+1)*sizeof(char));
      strcpy(yyval.c, yyvsp[-3].c);
      strcat(yyval.c, yyvsp[-1].c);
      Free(yyvsp[-3].c);
      Free(yyvsp[-1].c);
    ;
    break;}
case 336:
#line 3279 "Gmsh.y"
{
      yyval.c = (char *)Malloc((strlen(yyvsp[-1].c)+1)*sizeof(char));
      int i;
      for(i = strlen(yyvsp[-1].c)-1; i >= 0; i--){
	if(yyvsp[-1].c[i] == '.'){
	  strncpy(yyval.c, yyvsp[-1].c, i);
	  yyval.c[i]='\0';
	  break;
	}
      }
      if(i <= 0) strcpy(yyval.c, yyvsp[-1].c);
      Free(yyvsp[-1].c);
    ;
    break;}
case 337:
#line 3293 "Gmsh.y"
{
      yyval.c = (char *)Malloc((strlen(yyvsp[-1].c)+1)*sizeof(char));
      int i;
      for(i = strlen(yyvsp[-1].c)-1; i >= 0; i--){
	if(yyvsp[-1].c[i] == '/' || yyvsp[-1].c[i] == '\\')
	  break;
      }
      if(i <= 0)
	strcpy(yyval.c, yyvsp[-1].c);
      else
	strcpy(yyval.c, &yyvsp[-1].c[i+1]);
      Free(yyvsp[-1].c);
    ;
    break;}
case 338:
#line 3307 "Gmsh.y"
{
      yyval.c = yyvsp[-1].c;
    ;
    break;}
case 339:
#line 3311 "Gmsh.y"
{
      char tmpstring[1024];
      int i = PrintListOfDouble(yyvsp[-3].c, yyvsp[-1].l, tmpstring);
      if(i < 0){
	yymsg(GERROR, "Too few arguments in Sprintf");
	yyval.c = yyvsp[-3].c;
      }
      else if(i > 0){
	yymsg(GERROR, "%d extra argument%s in Sprintf", i, (i>1)?"s":"");
	yyval.c = yyvsp[-3].c;
      }
      else{
	yyval.c = (char*)Malloc((strlen(tmpstring)+1)*sizeof(char));
	strcpy(yyval.c, tmpstring);
	Free(yyvsp[-3].c);
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 340:
#line 3330 "Gmsh.y"
{ 
      char* (*pStrOpt)(int num, int action, char *value);
      StringXString *pStrCat;
      if(!(pStrCat = Get_StringOptionCategory(yyvsp[-3].c))){
	yymsg(GERROR, "Unknown string option class '%s'", yyvsp[-3].c);
	yyval.c = (char*)Malloc(sizeof(char));
	yyval.c[0] = '\0';
      }
      else{
	if(!(pStrOpt = (char *(*) (int, int, char *))Get_StringOption(yyvsp[-1].c, pStrCat))){
	  yymsg(GERROR, "Unknown string option '%s.%s'", yyvsp[-3].c, yyvsp[-1].c);
	  yyval.c = (char*)Malloc(sizeof(char));
	  yyval.c[0] = '\0';
	}
	else{
	  char *str = pStrOpt(0, GMSH_GET, NULL);
	  yyval.c = (char*)Malloc((strlen(str)+1)*sizeof(char));
	  strcpy(yyval.c, str);
	}
      }
    ;
    break;}
case 341:
#line 3352 "Gmsh.y"
{ 
      char* (*pStrOpt)(int num, int action, char *value);
      StringXString *pStrCat;
      if(!(pStrCat = Get_StringOptionCategory(yyvsp[-6].c))){
	yymsg(GERROR, "Unknown string option class '%s'", yyvsp[-6].c);
	yyval.c = (char*)Malloc(sizeof(char));
	yyval.c[0] = '\0';
      }
      else{
	if(!(pStrOpt = (char *(*) (int, int, char *))Get_StringOption(yyvsp[-1].c, pStrCat))){
	  yymsg(GERROR, "Unknown string option '%s[%d].%s'", yyvsp[-6].c, (int)yyvsp[-4].d, yyvsp[-1].c);
	  yyval.c = (char*)Malloc(sizeof(char));
	  yyval.c[0] = '\0';
	}
	else{
	  char *str = pStrOpt((int)yyvsp[-4].d, GMSH_GET, NULL);
	  yyval.c = (char*)Malloc((strlen(str)+1)*sizeof(char));
	  strcpy(yyval.c, str);
	}
      }
    ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 3375 "Gmsh.y"


void DeleteSymbol(void *a, void *b){
  Symbol *s = (Symbol*)a;
  Free(s->Name);
  List_Delete(s->val);
}

int CompareSymbols (const void *a, const void *b){
  return(strcmp(((Symbol*)a)->Name, ((Symbol*)b)->Name));
}

void InitSymbols(void){
  if(Symbol_T){
    Tree_Action(Symbol_T, DeleteSymbol);
    Tree_Delete(Symbol_T);
  }
  Symbol_T = Tree_Create(sizeof(Symbol), CompareSymbols);
}

int PrintListOfDouble(char *format, List_T *list, char *buffer){
  int j, k;
  char tmp1[256], tmp2[256];

  j = 0;
  buffer[j] = '\0';

  while(j < (int)strlen(format) && format[j] != '%') j++;
  strncpy(buffer, format, j); 
  buffer[j]='\0'; 
  for(int i = 0; i < List_Nbr(list); i++){
    k = j;
    j++;
    if(j < (int)strlen(format)){
      if(format[j] == '%'){
	strcat(buffer, "%");
	j++;
      }
      while(j < (int)strlen(format) && format[j] != '%') j++;
      if(k != j){
	strncpy(tmp1, &(format[k]), j-k);
	tmp1[j-k] = '\0';
	sprintf(tmp2, tmp1, *(double*)List_Pointer(list, i)); 
	strcat(buffer, tmp2);
      }
    }
    else{
      return List_Nbr(list)-i;
    }
  }
  if(j != (int)strlen(format))
    return -1;
  return 0;
}

int CheckViewErrorFlags(Post_View *v){
  if(View->adaptive) return 0; // hope for the best :-)

  char *name[8] = { "point", "line", "triangle", "quadrangle", 
		    "tetrahedron", "hexahedron", "prism", "pyramid" };
  char *type[3] = { "scalar", "vector", "tensor" };

  if(8 * 3 != VIEW_NB_ELEMENT_TYPES){
    Msg(GERROR, "Please upgrade CheckViewErrorFlags!");
    return 0;
  }
  
  for(int i = 0; i < VIEW_NB_ELEMENT_TYPES; i++)
    if(ViewErrorFlags[i])
      Msg(GERROR, "%d %s %s%s in View[%d] contain%s a wrong number of values",
	  ViewErrorFlags[i], type[i%3], name[i/3], (ViewErrorFlags[i] > 1) ? "s" : "",
	  v->Index, (ViewErrorFlags[i] > 1) ? "" : "s");
  
  return 0;
}

void yyerror(char *s){
  Msg(GERROR, "'%s', line %d : %s (%s)", yyname, yylineno-1, s, yytext);
  yyerrorstate++;
}

void yymsg(int type, char *fmt, ...){
  va_list args;
  char tmp[1024];

  va_start (args, fmt);
  vsprintf (tmp, fmt, args);
  va_end (args);

  Msg(type, "'%s', line %d : %s", yyname, yylineno-1, tmp);

  if(type == GERROR) yyerrorstate++;
}
